function x0 = abtast(fs,f)
% x0 = abtast(fs,f)
% Zeichnet eine Sinusschwingung mit f Perioden im Bild   
% und eine Aliasschwingung.
% fs ist die Zahl der Abtastschritte im Bild.
% Beispiele: abtast(10,4); abtast(10,6); abtast(10,21.6)

% K. v. d. Heide,  e-mail:  v.d.heide@on-line.de

if nargin<2  f = 21.6; end
if nargin<1  fs= 10;   end
fsiz = 13;                   % FontSize
m  = 512;                    % Darstellungspunkte
t  = (0:m-1)/m;              % Darstellungszeitpunkte
ts = (0:fs-1)/fs;            % Abtastpunkte
x  = sin(2*pi*f*t);          % kontinuierliches Signal
xs = sin(2*pi*f*ts);         % abgetastetes Signal
fa = min(abs(f-(1:100)*fs)); % Aliasfrequenz
xa = sin(2*pi*fa*t);         % Aliassignal
if xs(2)*sin(2*pi*fa*ts(2))<0  xa = -xa; end % Vorzeichen

h  = fullscreen('Sinus und Alias');
set(h,'KeyPressFcn','hervorhebung')
set(h,'UserData',{zeros(1,8); 1.2*ones(1,8); {'b';'g';'m';'c'}});
line(t,x,'Color','b')
line(t,xa,'Color','r')
line(ts,xs,'Marker','o','MarkerSize',5','LineStyle','none','Color','r','LineWidth',3)
title('Sinus und sein Aliassignal mit tiefster Frequenz','FontSize',fsiz)
legend('Sinus','Alias','Abtastwerte')
axis([0,1,-1.1,1.1])
