function ddsgraph(b)
% ddsgraph(b)
% Graph zur Erluterung der Direkten Digitalen Synthese
% falls b~=0 wird auch die Reprsentation gezeigt.

% K. v. d. Heide,  e-mail:  v.d.heide@on-line.de
%
if nargin<1 b = 0; end
abtastbild('sin(2*pi*1.321*t-0.871)',3,[0,1]);
set(gcf,'Name','DDS')
line([0.104 0.86; 0.104 0.86],0.32*[1 1; -1 -1],'Color','k')
line([0.333 0.665; 0.333 0.665],0.17*[1 1; -1 -1],'Color','r')
c = 'm';
drawarr([0.5 -0.3],[0.86 -0.3],c,2.0,0.02)
drawarr([0.5 -0.3],[0.104 -0.3],c,2.0,0.02)
text(0.42,-0.25,'2\pi','FontSize',14,'Color',c)
drawarr([0.5 -0.15],[0.665 -0.15],c,2.0,0.02)
drawarr([0.5 -0.15],[0.335 -0.15],c,2.0,0.02)
text(0.42,-0.10,'\beta','FontSize',14,'Color',c)
text(0.69,-0.2,'Winkel','FontSize',14,'Color',c)
c = 'k';
drawarr([0.5 +0.3],[0.86 +0.3],c,2.0,0.02)
drawarr([0.5 +0.3],[0.104 +0.3],c,2.0,0.02)
text(0.5,+0.35,'1/f','FontSize',14,'Color',c)
drawarr([0.5 +0.15],[0.665 +0.15],c,2.0,0.02)
drawarr([0.5 +0.15],[0.335 +0.15],c,2.0,0.02)
text(0.5,+0.21,'1/f_s','FontSize',14,'Color',c)
title('Direkte Digitale Synthese','FontSize',14)
text(0.69,+0.2,'Zeit','FontSize',14,'Color',c)
if b==0 break; end
c = 'b';
line([0.104 0.86; 0.104 0.86],0.82*[0 0; -1 -1],'Color','k')
line(0.333*[1 1],0.67*[0 -1],'Color','r')
drawarr([0.5 -0.8],[0.86 -0.8],c,2.0,0.02)
drawarr([0.5 -0.8],[0.104 -0.8],c,2.0,0.02)
text(0.4,-0.74,'M = Lnge der Tabelle','FontSize',14,'Color',c)
drawarr([0.5 -0.65],[0.665 -0.65],c,2.0,0.02)
drawarr([0.5 -0.65],[0.335 -0.65],c,2.0,0.02)
text(0.4,-0.6,'DP = beta','FontSize',14,'Color',c)
text(0.69,-0.7,'Reprsentation','FontSize',14,'Color',c)
