function ph = drawccir(mitte,radius,farbe,wort,pt)
%  ph = drawccir(mitte,radius,farbe,wort,pt)
%  drawccir zeichnet einen mit farbe gefllten Kreis
%  mit dem radius an die Position mitte.
%  In den Kreis wird der Text wort geschrieben 
%  mit der Fontgrsse pt.
%  zurckgegeben wird das Patchhandle der Kreisflche.

% K. v. d. Heide,  e-mail:  v.d.heide@on-line.de
%
if nargin<3  farbe = 'w';   end
if nargin<2 radius = 10;    end
if nargin<1  mitte = [0 0]; end
k  = (0:127)/128*2*pi;
x  = mitte(1) + radius*cos(k);
y  = mitte(2) + radius*sin(k);
ph = patch(x,y,farbe);
if nargin>3
   if nargin<5 pt = [12]; end
   th = text(mitte(1),mitte(2),wort);
   set(th,'HorizontalAlignment','center','FontSize',pt)
end
