%
%
%10.2  Demonstrationen zur Notwendigkeit komplexer Signale%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-22,'Color',MSVTITLCOLOR>
%
%
%
%  Gegeben sei ein Signal   {\fontname{Courier}-1 < x(t) < +1}  , welches nach 
%
%  y(t) = (x(t)+1) cos(2\pift)                            %<'FontName',MSVFORMFONT>
%
%  einem Trger der Frequenz  {\fontname{Courier}f}  in der Amplitude aufmoduliert wird. 
%  Am Empfangsort ist das Signal   {\fontname{Courier}x(t)}  zu rekonstruieren (Demodulation).
%
%  Das folgende Bild zeigt von oben nach unten   {\fontname{Courier}x(t), y(t)}  und die
%  Rekonstruktion  {\fontname{Courier}z(t)} .  Nur zur Veranschaulichung ist die Hllkurve 
%  des modulierten Signals  {\fontname{Courier}y(t)}  grau unterlegt.
%
amplmod;                   % Demo: Amplitudenmodulation
%
%  Im Falle analoger elektrischer Signale wird zur Demodulation meist ein
%  Spitzenwertdetektor plus R-C-Glied verwendet.  Bei abgetasteten Signalen ist der 
%  Spitzenwert, also die Amplitude, nicht direkt verfgbar, wie im folgenden Bild 
%  veranschaulicht.
%
s = abtastbild;            % Demo: Abtastung
set(gca,'YLim',[-1.5,1.5]) % y skalieren
%
%%  Dieses Bild stehen lassen und hin und her klicken mit dem nchsten.
%
%  Mglich wre eine Interpolation mit Ermittlung der Extremwerte.
%  Der Rechenaufwand ist jedoch sehr hoch.  Das folgende Bild zeigt die
%  im Abschnitt 9.3 behandelte Shannon/Nyquist-Interpolation fr den
%  Datensatz des letzten Bildes:
%
nyquistinterpol(s);     % Rekonstruktion des zeitkontinuierlichen Signals
delete(gcf)
set(gca,'YLim',[-1.5,1.5]) % y skalieren wie oberes Bild
%
%%  Der Vergleich zwischen Originalsignal und der Interpolation des 
%%  abgetasteten Signals zeigt den Fehler durch Abschneidung im 
%%  Zeitbereich.
%
%  Prinzipiell lsst sich die Amplitude aus dem interpolierten Signal ermitteln. 
%  Man kann sie auf andere Weise aber einfacher gewinnen, nmlich durch Benutzung 
%  komplexer Signale.  Der besondere Vorteil dieser Methode liegt darin, dass die 
%  Amplitude (und die Phase) fr jeden Abtastschritt berechnet werden kann im 
%  Gegensatz zu den nicht quidistant liegenden Spitzenwerten.  Zunchst betrachten 
%  wir ein einfaches Cosinus-Signal:
%
t = 0:0.001:1;          % Zeitbereich: 1 Sekunde in 1001 Punkten
f = 1.7;                % Frequenz = 1.7 Hz
x = cos(2*pi*f*t);      % cos
h1= fullscreen('cos','w',0,[2 1; 1 1]);  % Generierung eines Graphikfensters
plot(t,x);              % Darstellung des Cosinussignals
axis([0 1 -1.2 1.2]);   % Darstellungsbereich festlegen
line([0 1],[0 0],'LineStyle',':','Color',0.7*[1 1 1])
xlabel('Zeit','FontSize',13)
%
%  Zustzlich berechnen wir das gegenber   {\fontname{Courier}x(t)}   um   {\fontname{Courier}90\circ}   verschobene
%  Signal   {\fontname{Courier}y(t)}   und stellen dieses zustzlich grn dar.
%%  Das obere Bild muss hierfr stehen bleiben.
%
y = sin(2*pi*f*t);              % sin
figure(h1)                      % obere Graphik fokussieren
line(t,y,'Color','g')           % Darstellung des Sinussignals
legend('cos','Zeitachse','sin') % Legende
%
%  Andererseits kann man es dreidimensional darstellen mit den Achsen   {\fontname{Courier}x, y, t} :
%
h2 = fullscreen('Komplex 3D');  % Generierung eines Graphikfensters
plot3(t,x,y,'Color','r')        % 3D-Darstellung
axis square
ax = gca;
legend('komplexes Signal')
xlabel('Zeit','FontSize',12)
%
%  Wir setzen   {\fontname{Courier}x(t)}   in der  {\fontname{Courier}x-t-}Ebene sowie   {\fontname{Courier}y(t)}   in der  {\fontname{Courier}y-t-}Ebene 
%  und die  {\fontname{Courier}t-}Achse noch hinzu.
%%  Dafr muss das obere Bild natrlich stehen bleiben.
%
nullen = zeros(1,length(t));
figure(h2)
line(t,x,nullen,'Color','b')
line(t,nullen,y,'Color','g')
line(t,nullen,nullen,'Color',0.7*[1 1 1])
legend('komplexes Signal','cos (Realteil)','sin (Imaginrteil)','Zeitachse')
ylabel('Realteil','FontSize',12)
zlabel('Imaginrteil','FontSize',12)
rotate3d on             % Drehung per Maus ermglichen
%
%  Die Amplitude des Cosinussignals ist nun offenbar zu jeder Zeit nach 
%  Pythagoras berechenbar:
%
%  a(t) = sqrt(x(t)^2 + y(t)^2)                            %<'FontName',MSVFORMFONT>
%
%  Im Falle der Cosinusschwingung ergibt sich natrlich zu jeder Zeit die Amplitude  {\fontname{Courier}1} .
%
%  Wir werden spter sehen, dass es praktisch ist, die  {\fontname{Courier}x-y-}Ebene als komplexe 
%  Ebene mit dem Realteil  {\fontname{Courier}x}  und dem Imaginrteil  {\fontname{Courier}y} anzusehen.
%  Zunchst bernehmen wir nur diese Bezeichnung, ohne komplexe Operationen 
%  mit dem komplexen Signal durchzufhren.
%
%  Tastet man das komplexe Signal ab, so ergeben sich natrlich komplexe Abtastwerte. 
%  Wir tragen das im Bild ein:
%
ti = 1:250:1000;          % Indices der Abtastpunkte
zi = zeros(1,length(ti)); % soviele Nullen
axes(ax)                  % Achsen ax in den Vordergrund
line([t(ti);t(ti)],[zi;x(ti)],[zi;y(ti)],'Color','r','LineWidth',2)
line(t(ti),x(ti),y(ti),'LineStyle','none','LineWidth',3,'Marker','o','MarkerSize',7,'Color','r')
line(t(ti),zi,zi,'LineStyle','none','LineWidth',3,'Marker','o','MarkerSize',4,'Color','k')
%
%  Die Funktion  {\fontname{Courier}komplexanimat}  stellt die zeitliche Entwicklung des im ersten 
%  Parameter angegebenen Signalvektors als Animation dar.  Als Beispiel dient hier 
%  die Funktion
%
%  e^{i2\pift} = cos(2\pift) + i sin(2\pift)                   %<'FontName',MSVFORMFONT>
%
komplexanimat(exp(i*2*pi*10/500*(0:500)))
%
%  {\fontname{Courier}komplexanimat}  bietet mehrere Darstellungsformen, die mit einem Binrvektor 
%  als zweitem Parameter eingestellt werden.  Weitere Parameter sind die Geschwindigkeit 
%  der Animation sowie der Blickwinkel.  Einige werden hier in rascher Folge demonstriert:
%
komplexanimat(exp(i*2*pi*4.1/500*(0:500)),[1],10,[25 25])
komplexanimat(exp(i*2*pi*4.1/500*(0:500)),[0 1],10,[25 25])
komplexanimat(exp(i*2*pi*4.1/500*(0:500)),[0 0 1],10,[25 25])
komplexanimat(exp(i*2*pi*4.1/500*(0:500)),[0 1 1],10,[90 0])
komplexanimat(exp(i*2*pi*4.1/500*(0:500)),[1 0 1],10,[0 0])
%
%%  Alle Bilder lassen sich im Nachhinein ineinander berfhren durch 
%%  Drehen und Benutzung der Tasten 1 2 3. 
%
%  Wichtig ist die Feststellung, dass die komplexe Abtastung durch Transformation 
%  in Polarkoordinaten die momentane Amplitude und die momentane Phase liefert. 
%  Im Fall aus mehreren Komponenten zusammengesetzter Signale ergibt sich das 
%  analytische Signal als Summe der analytischen Komponenten.  Das folgende Bild 
%  zeigt eine Rechteck-Schwingung (roter Punkt) mit ihren Fourier-Komponenten 
%  (schwarze Punkte) in der komplexen Ebene.  Diese Ebene ist hier entgegen der 
%  Gewohnheit mit dem Imaginrteil als Abszisse dargestellt.  An den Flanken des 
%  Rechtecks sind alle Komponenten in Phase.  Dann ist der Imaginrteil
%   \infty                                                 %<'FontName',MSVFORMFONT>
%   {\fontsize{30}_\Sigma} 1/(2k+1)  \rightarrow  \infty   %<'FontName',MSVFORMFONT>
%  k=0                                                     %<'FontName',MSVFORMFONT>
%
%  Die Funktion   {\fontname{Courier}rectanalyt(n)}   hat als Parameter die obere Summationsgrenze 
%  fr  {\fontname{Courier}k}  und einen Faktor fr die Amplitude der hchsten Komponente zur 
%  Milderung des Gibbs-Effektes.
%
rectanalyt(3)
%
%%  Die Animation wird durch Lschen des Bildes abgebrochen.  
%%  Die dann erfolgende Fehlermeldung ist zu ignorieren.  Lschen Sie auch das Wartefenster !
%
rectanalyt(10,0.5)
%
rectanalyt(50,0.5)
%
%  Man beachte, dass auch in diesem Fall des zusammengesetzten Signals ein einzelner 
%  herausgegriffener Abtastwert mit seiner Phase Auskunft darber gibt, an welcher 
%  Stelle innerhalb einer Periode abgetastet wurde.  Bis auf die Schwingungen des 
%  Gibbs-Effektes ist der Phasengang der Rechteckschwingung monoton:
%
rectanalyt(400,0.5)
%
%  Die Funktionn  {\fontname{Courier}komplexsig}  erzeugt ein Bandpass-gefiltertes Signal aus einem 
%  Sinus plus Rauschen mit dem Signal/Rauschverhltnis  {\fontname{Courier}snr}  und stellt dies mit 
%  {\fontname{Courier}komplexanimat}  dar.
%
%  Im ersten Beispiel ist die abgetastete Frequenz klein gegen die Abtastfrequenz:  
%  {\fontname{Courier}f = 0.05 f_s} .
%
komplexsig(0.1,0.075,0.125,5,1000,0.5,[25 25],0)
%
%%  Drehen Sie das Bild und toggeln Sie die Sichtbarkeit des zeitkontinuierlichen Signals 
%%  mit der Taste 1 sowie der Abtastpunkte mit der Taste 2 und der Abtastradien mit der 
%%  Taste 3 oder klicken Sie die folgenden Eistellungen:
%
%  Realteil ber der Zeit:
kfig = findobj('Name','Komplexsignal'); 
for k=1:length(kfig) figure(kfig(k)); set(gca,'View',[0 90]); end
%
%  Imaginrteil ber der Zeit:
kfig = findobj('Name','Komplexsignal'); 
for k=1:length(kfig) figure(kfig(k)); set(gca,'View',[0 0]); end
%
%  Komplexe Ebene:
kfig = findobj('Name','Komplexsignal'); 
for k=1:length(kfig) figure(kfig(k)); set(gca,'View',[90 0]); end
%
%  Das zweite Beispiel demonstriert die Abtastung von  {\fontname{Courier}f = 0.95 f_s/2} .
%
komplexsig(0.95,0.02,0.98,10000,30,0.05,[25 25],0);
%
%%  Auch hier sollten die obenstehenden Einstellungen angeklickt werden.
%
%  Offenbar scheinen sowohl der Real- wie auch der Imaginrteil eine Amplituden-
%  modulation aufzuweisen.  Die komplexe Ebene dagegen zeigt eine linear ansteigende 
%  Phase bei konstanter Amplitude.
%
%  Es folgt die Darstellung der negativen Frequenz   {\fontname{Courier}f = -0.05 f_s/2} .   Man beachte 
%  die Drehrichtung.  Bei reellen Signalen sind positive und negative Frequenzen nicht 
%  unterscheidbar.  Komplexe Signale mit negativen Frequenzen entstehen durch Rotation 
%  im Frequenzbereich.  Bei diesem Beispiel ist das Rauschen breitbandiger, was zu 
%  Epizykeln fhrt.
%
komplexsig(-0.1,0.05,0.35,10,500,0.2,[25 25],0);
%
%  Genauso kann ein Signal der Frequenz   {\fontname{Courier}f}  mit   {\fontname{Courier}0 < f < f_s/2} , wo  {\fontname{Courier}f_s}  
%  wie immer  die Abtastfrequenz bedeutet, von seinem Spiegel bei  {\fontname{Courier}f_s - f}  an der 
%  Drehrichtung unterschieden werden.  Wir zeigen dies mit  {\fontname{Courier}f_1 = 0.67 f_s/2}  und  
%  {\fontname{Courier}f_2 = f_s - f_1} :
%
f1 = 0.67;  fs = 2;
komplexsig(f1,0.02,0.98,10000,30,0.05,[25 25],0);
%
f1 = 0.67;  fs = 2;
komplexsig(fs-f1,0.02,0.98,10000,30,0.05,[25 25],0);
%
%  Weil das analytische Signal und sein analytischer Spiegel unterscheidbar sind, 
%  handelt es sich nicht um Alias-Signale.  Bei zeitdiskreter analytischer Verarbeitung 
%  kann deshalb der gesamte Frequenzbereich einer Periode ausgenutzt werden.  Die 
%  Beschrnkung auf den Bereich   {\fontname{Courier}0...f_s/2}  gibt es also nicht.
%
%%  bung 10.2  Vergleichen Sie ein leicht verrauschtes schmalbandiges Signal mit 
%%  einem schmalbandigen reinen Rauschsignal.  Der durch das Rauschen hervorgehobene 
%%  Phasenfehler ist aus der Drehung des Bildes abzulesen:
%%
komplexsig(0.5,0.48,0.52,20,500,10,[90 0],0); % 20 dB Rauschabstand
%%
komplexsig(0.5,0.48,0.52,0,500,10,[90 0],0);  % Rauschsignal
%%
