%
%
%10.4  Analytische Signale%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Analytische Signale sind komplexe Signale, die aus einem reellen Signal durch 
%  Hilberttransformation hervorgegangen sind.  Der Imaginrteil enthlt das durch 
%  Hilbert-Transformation um  {\fontname{Courier}-\pi/2}  gedrehte Signal und der Realteil das ursprngliche
%  reelle Signal, jedoch verzgert um die Verzgerung des Hilbertfilters. 
%
%  In diesem Abschnitt diskutieren wir die Eigenschaften von analytischen Signalen.
%
%  \bf(a)  Darstellung
%
%  Analytische Signale werden zweckmssig im Signalraum, d.h. in der komplexen Ebene 
%  dargestellt.  Aus einem reellen Cosinus-Signal  {\fontname{Courier}a\cdotcos(\omegat)}  wird dann 
%
%  {\fontname{Courier}a\cdote^{i\omegat} = a\cdotcos(\omegat) + i a\cdotsin(\omegat)} .
%
%  Dargestellt wird der Punkt {\fontname{Courier}(a cos(\omegat), a sin(\omegat))}  bzw. dessen Ortsvektor
%  mit der Lnge {\fontname{Courier}a}.  Dabei werden positive und negative Frequenzen im Bereich  
%  {\fontname{Courier}-f_s/2 ... f_s/2}  unterscheidbar an der Drehrichtung.  Betrachtet man den Bereich
%  {\fontname{Courier}0 ... f_s}  als Periode im Frequenzbereich, so drehen Frequenzen des Bereichs  
%  {\fontname{Courier}f_s/2 ... f_s}  rckwrts. 
%
komplexsig(0.05,0.05,0.8,10000,500,1,[90,0])
%
komplexsig(-0.05,0.05,0.8,10000,500,1,[90,0])
%
%  Die folgende Demonstration zeigt zwei Signale  {\fontname{Courier}x}  und  {\fontname{Courier}y}  mit unterschiedlicher 
%  Frequenz sowie die Ergebnisse der komplexen Grundoperationen   
%  {\fontname{Courier}x + y;  x - y;  x * y;  x / y}
%
kompop;
%
%
%  \bf(b)  Spektraleigenschaften analytischer Signale
%
%  Sei  {\fontname{Courier}x}  ein reelles Signal und  {\fontname{Courier}X}  seine Fouriertransformierte sowie  {\fontname{Courier}x_a = x_r + i\cdotx_i}  
%  das zu  {\fontname{Courier}x}  gehrige analytische Signal.  Wegen   {\fontname{Courier}x_r = x}   ist die Fouriertransformierte  
%  {\fontname{Courier}X_r}  des Realteils gleich der von  {\fontname{Courier}x}.  Fr die Fouriertransformierte  {\fontname{Courier}X_i}  des 
%  Imaginrteils erhlt man mit der bertragungsfunktion des Hilbertfilters (siehe 10.3):
%
%  X_i = - i sign(\omega) X                            %<'FontName',MSVFORMFONT>
%
%  Aufgrund der Linearitt der Fouriertransformation ergibt sich durch Addition 
%  von Real- und Imaginrteil die Fouriertransformierte des analytischen Signals:
%
%  X_a = X + i (- i sign(\omega) X) = X + sign(\omega) X              %<'FontName',MSVFORMFONT>
%
%  also:
%
%  X_a = 2 X   fr  \omega > 0;   X_a = 0   fr  \omega < 0           %<'FontName',MSVFORMFONT>
%
%  Es folgt eine Reihe von Demonstrationen  mit  {\fontname{Courier}analytsig}  fr das Verhalten
%  analytischer Signale.  Gezeigt wird ein Sinussignal im Bandpassrauschen. 
%  Die Parameter von  {\fontname{Courier}analytsig}  sind:
%  {\fontname{Courier}analytsig(fsin,f1,f2,snr,m,velocity,blick)} , wo  {\fontname{Courier}fsin}  die
%  Sinusfrequenz und  {\fontname{Courier}f1, f2}  die Eckfrequenzen des Rauschfilters sind.
%  {\fontname{Courier}snr}  ist das Signal-Rausch-Verhltnis ( {\fontname{Courier}snr = 0} :  nur Rauschen).
%  Die brigen Parameter sind optional.  Ihre Bedeutung kann wie immer durch 
%  {\fontname{Courier}help funktionsname}  im Kommandofenster erfragt werden.
%
analytsig;    % mit verschiedenen Parametern:
%
analytsig(0.501,0.2,0.8,100000,500,1,[90,0])      % kein Rauschen
%
analytsig(0.666667,0.64666,0.68666,0,500,1,[90,0])% Schmalbandrauschen, kein Signal
%
analytsig(0.985,0.94,0.98,10000,500,1)            % kein Rauschen
%
analytsig(0.4,0.38,0.4201,4,500,1,[90,0])
%
analytsig(0.1,0.08,0.12001,1,500,1,[90,0])
%
analytsig(0.1,0.02,0.98,3,500,1,[90,0])
%
%
%  \bf(c)  Rekonstruktion des reellen aus einem analytischen Signal
%
%  Bei anlytischen Signalen gibt es das Problem der Spiegelfrequenzen nicht.  
%  Eine Frequenz  {\fontname{Courier}f} , fr die gilt:  {\fontname{Courier}f_s/2 < f < f_s} , hat also keine Spiegelfrequenz 
%  bei  {\fontname{Courier}0 < f_s - f < f_s/2} .  Deshalb gibt es als Bedingung beim Abtasten mit 
%  der Abtastfrequenz  {\fontname{Courier}f_s}  im Falle von analytischen Signalen  {\fontname{Courier}0 \leq f < f_s}  
%  anstelle von  {\fontname{Courier}0 \leq f < f_s/2} , was fr reelle Signale gilt.  In der Praxis wird 
%  man daher bei der Transformation des reellen abgetasteten Signals in das 
%  analytische Signal nur jeden zweiten Abtastwert berechnen und damit die 
%  Abtastrate halbieren. 
%
%  Der umgekehrte Fall kommt zwar nicht hufig vor, soll hier aber als
%  Demonstration behandelt werden:  Gegeben sei ein analytisches Signal.
%  Es ist daraus das reelle Signal der doppelten Abtastfrequenz zu bestimmen.  
%  Der Realteil stellt jeden zweiten Abtastwert.  Durch Drehung um  {\fontname{Courier}+\pi/2} , 
%  also inverse Hilbert-Transformation erhlt man aus dem Imaginrteil die 
%  gesuchten Zwischenwerte.  Dies demonstriert die Funktion  {\fontname{Courier}analytsp} .  
%  Anstelle der Drehung um  {\fontname{Courier}+\pi/2}  wird hier der negative, also um  {\fontname{Courier}\pi}  
%  gedrehte Realteil um  {\fontname{Courier}-\pi/2}  gedreht.
%
analytsp
%
analytsp(0.2,0.1,0.9,0.2)
%
