%
%
%11.1 Anforderungen%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Signalprozessoren sind Spezialprozessoren, die fr den festen Aufgabenbereich 
%  der Signalverarbeitung optimiert sind.  Charakteristisch fr die digitale 
%  Signalverarbeitung ist:
%
%  (A)  Die Verarbeitung erfolgt in Realzeit
%
%  (B)  Der Wertebereich der Daten sowie ihre Genauigkeit ist meist relativ gering
%
%  (C)  Die Komplexitt der Aufgabe ist meist relativ gering
%
%  Aus (A) folgt meist eine sehr hohe Forderung an die Rechenleistung.
%  Dieser Forderung kommt die geringe Anforderung an die Wortbreite (B)
%  entgegen.  Die Forderung (A) ist selten mit Standard-Rechnern zu erfllen.
%
%  Entsprechend diesen Punkten gilt fr die meisten Anwendungen:
%
%  (D)  Der Speicherbedarf fr Daten ist gering
%
%  (E)  Der Speicherbedarf fr das Programm ist gering
%
%  (F)  Die Unterprogramm- und Schleifenverschachtelung ist gering
%
%  (G)  Die wesentlichen Teile der Anwendung liegen in sehr kurzen Programmschleifen
%
%  (H)  Eine Betriebsmittelverwaltung zur Laufzeit ist nicht ntig
%
%  Alle Signalprozessoren sind optimiert gemss der Entwurfsregel 
%  "Mache die hufig vorkommenden Aufgaben schnell".  Dies fhrt zu
%  folgenden Architekturmerkmalen:
%
%  (1)  Havardarchitektur mit parallelem Zugriff auf Progamm- und Datenspeicher, 
%        die auf dem Chip integriert sind
%
%  (2)  Parallele Busse fr Befehlsadresse, Datenadresse, Befehle und Daten
%
%  (3)  Wenige Datenformate:  Adressen entsprechend dem Adressraum;
%        Signalreprsentation in Festkomma  {\fontname{Courier}16}  bis  {\fontname{Courier}24} Bit oder in Gleitkomma  {\fontname{Courier}32} Bit
%
%  (4)  Spezialhardware zur Realisierung von Programmschleifen,
%
%  (5)  Rechenwerk mit "Multipliziere und Akkumuliere - Funktion"
%        zur Realisierung von Skalarprodukt, Faltung, Korrelation.
%
%  (6)  Spezialhardware zur Realisierung wichtiger Objekttypen wie Puffer, Stack u..
%
%  (7)  Schnelle Reaktion auf Interrupts
%
%  (8)  On-Chip-Ports fr schnellen Datenverkehr mit der Aussenwelt
%
%  (9)  Selten vorkommende Operationen sind u.U. sehr langsam, z.B. die Division
%
%  Signalprozessoren sind prinzipiell universelle Prozessoren.  Sie sind in ihrem 
%  Aufgabenbereich konkurrenzlos schnell, in anderen Bereichen den Standard-
%  Mikroprozessoren aber unterlegen.
%
