%
%
%11.7 Programmierung der DSP5600-Familie%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-16,'Color',MSVTITLCOLOR>
%
%
%
%  Ein System zur digitalen Signalverarbeitung enthlt neben dem Prozessor die 
%  Schnittstellen zur Aussenwelt.  Bei einem Entwicklungssystem wie dem Motorola 
%  DSP56002EVM-Board, welches in diesem Kurs benutzt wird, kommt die Schnittstelle 
%  zum steuernden Rechner hinzu.  Ein komplettes DSP-Programm muss deshalb 
%  neben dem eigentlichen signalverarbeitenden Teil noch Teile zur Bedienung 
%  der Kommunikation enthalten.
%
%  Das EVM-Board benutzt den Crystal CS4215-CODEC als Stereo-Analog/Digital-
%  Digital/Analog-Wandler.  Die Kommunikation zwischen Signalprozessor und 
%  CODEC erfolgt ber eine schnelle serielle Schnittstelle, ber die alle 
%  Steuerinformation und alle Daten bertragen werden.  Die beiden Bausteine 
%  arbeiten asynchron.  Sie synchronisieren sich ber Interrupts.  Ohne die 
%  passenden Interrupt-Routinen sowie einem Initialisierungsprogramm fr den 
%  CODEC kann das EVM-Board nicht laufen.
%  
%  In diesem Kurs werden zwei verschiedene Basis-Programme fr das Motorola 
%  DSP56002EVM-Board benutzt, in die nur noch der Anwendungsteil einzusetzen ist:
%
%
%  bas_prg  geht davon aus, dass jede Abtastung unmittelbar    %<'FontName',MSVFORMFONT,'interpreter','none'>
%           verarbeitet wird. Die Anwendung ist zu schreiben   %<'FontName',MSVFORMFONT,'interpreter','none'>
%           als Subroutine audio_process. Die Schnittstelle    %<'FontName',MSVFORMFONT,'interpreter','none'>
%           zum Basisprogramm besteht in den Registern a,b.    %<'FontName',MSVFORMFONT,'interpreter','none'>
%           Diese enthalten beim Aufruf von audio_process      %<'FontName',MSVFORMFONT,'interpreter','none'> 
%           die Abtastwerte fr den linken bzw. rechten        %<'FontName',MSVFORMFONT,'interpreter','none'> 
%           Input-Kanal und sollen beim Ende von audio_process %<'FontName',MSVFORMFONT,'interpreter','none'> 
%           die entsprechenden Abtastwerte fr die Ausgabe auf %<'FontName',MSVFORMFONT,'interpreter','none'> 
%           dem linken bzw. rechten Kanal enthalten.           %<'FontName',MSVFORMFONT,'interpreter','none'> 
%
%  simple   puffert je n Abtastungen und bergibt diesen       %<'FontName',MSVFORMFONT,'interpreter','none'>
%           Puffer an die Anwendung.                           %<'FontName',MSVFORMFONT,'interpreter','none'>
%
%  {\fontname{Courier}bas-prg}  basiert auf einem Programm, das zusammen mit dem EVM-Board 
%  geliefert wird.   {\fontname{Courier}simple}  benutzt ein ursprnglich von Jarkko Vuori 
%  entwickeltes BIOS.
%
%  Als erste Anwendung soll eine Basisbreitenregelung fr Stereo-bertragung 
%  realisiert werden.  Seien  {\fontname{Courier}L}  und  {\fontname{Courier}R}  die Abtastungen fr den linken bzw. rechten Kanal und  {\fontname{Courier}L', R'}
%  die zu berechnenden Werte, dann ist der einfache Zusammenhang:
%
%      L' = L + q(L - R)                                      %<'FontName',MSVFORMFONT>
%      R' = R - q(L - R)                                      %<'FontName',MSVFORMFONT>
%
%  Mit dem Parameter  {\fontname{Courier}q}  erzielt man folgende Wirkung:
%
%      q     formal                    Wirkung                 %<'FontName',MSVFORMFONT>
%   -----------------------------------------------------------%<'FontName',MSVFORMFONT>
%    -1.0   L' = R;  R' = L            Vertauschung der Kanle %<'FontName',MSVFORMFONT>
%    -0.5   L' = R' = (L + R)/2        Stereo => Mono          %<'FontName',MSVFORMFONT>
%     0.0   L' = L;  R' = R            Identitt               %<'FontName',MSVFORMFONT>
%     1.0   L' = 2*L - R; R' = 2*R - L Basisbreite erhht      %<'FontName',MSVFORMFONT>
%
%  Fr diese Anwendung ist das  {\fontname{Courier}bas-prg}  am besten geeignet.
%  Wir legen  {\fontname{Courier}r}  auf den Speicherplatz  {\fontname{Courier}x:$1000} .  Mit den Festlegungen des  {\fontname{Courier}bas-prg}  
%  {\fontname{Courier}L = a,  R = b;}  und  {\fontname{Courier}a := L', b := R'},  sowie  {\fontname{Courier}x1}  als Zwischensoeicher fr  {\fontname{Courier}L}  
%  und  {\fontname{Courier}x0}  als Zwischenspeicher fr  {\fontname{Courier}(L - R)}  und  {\fontname{Courier}y0}  als Register fr  {\fontname{Courier}q}  
%  ergibt sich z.B. die folgende Routine
%
%  audio_process                                               %<'FontName',MSVFORMFONT,'Interpreter','none'>
%     move  x:$1000,y0                                         %<'FontName',MSVFORMFONT>
%     sub   b,a  a,x1                                          %<'FontName',MSVFORMFONT>
%     move  a,x0                                               %<'FontName',MSVFORMFONT>
%     mac   -y0,x0,b  x1,a                                     %<'FontName',MSVFORMFONT>
%     mac   y0,x0,a                                            %<'FontName',MSVFORMFONT>
%     rts                                                      %<'FontName',MSVFORMFONT>
%
%  Diese ist direkt oder per include-Anweisung in das  {\fontname{Courier}bas-prg}  einzufgen. 
%  Der Assemblierer wird im DOS-Fenster gestartet.  Es ist darauf zu achten, dass 
%  alle Pfade richtig gesetzt sind.  Nach korrekter bersetzung kann das Programm 
%  aus dem Command Window des EVM56k-Debuggers geladen und gestartet werden.  
%  Den Wert von  {\fontname{Courier}q}  ndert man direkt in einem Datenfenster oder mit dem 
%  Kommando  {\fontname{Courier}change x:$1000 Wert} .
%
