%
%
%
%
%12.1.2  Berechnung der Kreisfunktion fr quidistante Winkel %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-22,'Color',MSVTITLCOLOR>
%
%
%
% Zu berechnen sind der Reihe nach fr  {\fontname{Courier}k = 0, 1, 2, ...}  die Werte der Kreisfunktion 
% fr die Winkel
%
% {\fontname{Courier}\alpha_k = \alpha_0 + k \omega \deltat}   ;      {\fontname{Courier}k \in \bfN}
%
% Hieraus folgt die Rekursion
%
% {\fontname{Courier}\alpha_{k+1}  =  \alpha_k + \beta  ;    z_k = e^{i\alpha_k}}
%
% wo       {\fontname{Courier}\beta = \omega \deltat}
%
% Die Berechnung erfordert also eine reelle Addition und die Ermittlung der Kreisfunktion  
% fr jeden Abtastpunkt.  Eine Realisierung mit rationaler Chebyscheff-Approximation, 
% wie sie auf Rechnern sonst blich ist, kommt hier aus Realzeitgrnden nicht in Betracht.  
% Sinnvoll ist eine Realisierung mithilfe von Tabellen. 
%
% Die Methode erfordert eine Reprsentation der Winkel.   Der Winkelschritt  {\fontname{Courier}\beta}  legt 
% dabei die Frequenz fest.  Wir benutzen im Nachfolgenden als Bezeichner fr 
% Reprsentanten von Variablen solche, die man direkt auch in Programmen benutzen 
% knnte.   {\fontname{Courier}DP}  soll z.B.  {\fontname{Courier}\beta}  reprsentieren. Fr die meist geforderte Einstellgenauigkeit 
% der Frequenz von  {\fontname{Courier}10^{-9}}  sind bei  {\fontname{Courier}DP}  wenigstens  
% {\fontname{Courier}\lceillog_2(10^9)\rceil = \lceil9/log_{10}(2)\rceil = 30}  Bit erforderlich.  blich sind  {\fontname{Courier}n = 32} Bit.
%
% Fr die Momentanphase  {\fontname{Courier}\alpha_k}  fhrt man entsprechend einen Phasenakkumulator  {\fontname{Courier}PA}  ein, 
% der bei jedem Abtastschritt wie folgt aktualisiert wird:
%
% PA = (PA + DP) mod M                 %<'FontName',MSVFORMFONT>
%
% DP = M f T                           %<'FontName',MSVFORMFONT>
%
% {\fontname{Courier}M}  ist die Gesamtzahl aller reprsentierbaren Winkel fr einen Vollkreis.
% {\fontname{Courier}DP}  ist konstant und wird deshalb nur einmal berechnet.  {\fontname{Courier}PA}  und {\fontname{Courier}DP}  werden als 
% nicht negative Festkommazahlen mit  {\fontname{Courier}N}  Bits reprsentiert.  {\fontname{Courier}PA = 0}  entspricht dem 
% Winkel  {\fontname{Courier}0}  und  {\fontname{Courier}PA = M}  entspricht dem Winkel  {\fontname{Courier}2\pi} . 
%
% Die Reprsentation der Zeitpunkte bzw. der Winkel sowie deren Reprsentation wird 
% anschaulich dargestellt durch
%
ddsgraph(1)
%
% Hieraus ergeben sich die Entsprechungen
%
% 1/f \sim 2\pi \sim M    ;    1/f_s \sim \beta \sim DP  %<'FontName',MSVFORMFONT>
%
% woraus durch Bildung der Verhltnisse folgt
%
% DP = M f/f_s                                           %<'FontName',MSVFORMFONT>
%
% Der kleinste Phasenschritt ist dann  {\fontname{Courier}DP = 1} .  Dem entspricht die kleinste realisierbare 
% positive Frequenz, die zugleich der Frequenzschritt des realisierbaren Rasters ist:
%
% \Deltaf = f_s / M                                      %<'FontName',MSVFORMFONT>
%
% blich ist  {\fontname{Courier}M = 2^{32}} .  Die damit realisierbare Frequenzauflsung von  
% {\fontname{Courier}\Deltaf = f_s 2^{-32}}  ist fr praktisch alle Flle mehr als ausreichend.
%
% Die gewnschte Geschwindigkeit der Berechnung legt nahe, die Ausgabewerte in einer 
% Tabelle abzulegen.  Der eben ermittelte Adressraum von wenigstens  {\fontname{Courier}2^{30}}  ist jedoch 
% unrealistisch.  Man nimmt deshalb die  {\fontname{Courier}m}  signifikantesten Bits der Winkelreprsentation 
% fr einen Tabellennachschlag und geht dann nach einem der drei folgenden Varianten 
% vor:
%
% (1)  Der Tabellenwert wird direkt ausgegeben
%
% (2)  Man fhrt eine lineare Interpolation durch zwischen zwei benachbarten Tabellenwerten
%
% (3)  Man rechnet eine Taylor-Entwicklung um einen Tabellenpunkt (z.B. vom Grad 3)
%
% Andererseits ist die Sinus-Funktion zumindest in einem Quartal so glatt, dass eine 
% Reihenentwicklung um den Nullpunkt schon mit geringem Grad ausreichende 
% Genauigkeit liefert.  Dies wird als viertes Verfahren der klassischen DDS untersucht:
%
% (4)  Man approximiert den Sinus quartalsweise mit einem Polynom
%
% Die auf diese Weise erreichten Genauigkeiten werden im Unterabschnitt 12.2.3 diskutiert.
%