%
%
%
%
%12.1.3  Frequenzsynthese  %<'FontSize',32,'FontWeight','bold','FontName','Times','Color',0.7*[1 1 1]>
%
%
%
% Mit
%      N                                              %<'FontName',MSVFORMFONT>
% \omega = _{\fontsize{26}\Sigma} \omega_\mu          %<'FontName',MSVFORMFONT>
%     \mu=1                                           %<'FontName',MSVFORMFONT>
%
% lsst sich
%
% z = e^{i\omegat}                                    %<'FontName',MSVFORMFONT>
%
% schreiben in der Form
%      N                                              %<'FontName',MSVFORMFONT>
% z = _{\fontsize{26}\Pi} e^{i\omega_\mut}            %<'FontName',MSVFORMFONT>
%     \mu=1                                           %<'FontName',MSVFORMFONT>
%
%
% Beispiel 1:  binre Synthese                        %<'FontSize',18,'FontWeight','bold'>
%
% Gegeben sei die binre Reprsentation der Frequenz  {\fontname{Courier}f}
%        N-1                                          %<'FontName',MSVFORMFONT>
% f = f_s _{\fontsize{26}\Sigma} f_\mu\cdot2^{N-\mu}  %<'FontName',MSVFORMFONT>
%        \mu=0                                        %<'FontName',MSVFORMFONT>
%
% Realisiert man nun die Kreisfunktionen
%
% z_\mu = e^{i\omega_\mu}                             %<'FontName',MSVFORMFONT>
%
% fr alle
%
% \omega_\mu = 2\pif_s\cdot2^{N-\mu}                  %<'FontName',MSVFORMFONT>
%
% so lsst sich  {\fontname{Courier}z}  synthetisieren nach
%     N-1                                             %<'FontName',MSVFORMFONT>
% z = _{\fontsize{26}\Pi} f_\mu z_\mu                 %<'FontName',MSVFORMFONT>
%     \mu=0                                           %<'FontName',MSVFORMFONT>
%
%
% Beispiel 2:  Synthese nach dem Chinesischen Restsatz%<'FontSize',18,'FontWeight','bold'>
%
% Anstatt  {\fontname{Courier}f}  als Binrzahl zu segmentieren wird diese nach dem Chinesischen Restsatz 
% zerlegt in
%          N                                           %<'FontName',MSVFORMFONT>
% f =  ( ( {\fontsize{30}_\Sigma} f_\mu) mod M ) f_s/M %<'FontName',MSVFORMFONT>
%         \mu=1                                        %<'FontName',MSVFORMFONT>
%
% Hierin ist 
%      N                                           %<'FontName',MSVFORMFONT>
% M = {\fontsize{30}_\Pi} z_\mu                    %<'FontName',MSVFORMFONT>
%     \mu=1                                        %<'FontName',MSVFORMFONT>
%
% wo  z_\mu \in {\bfN}  (\mu = 1...N),  z_\mu \neq z_\nu  fr  \mu \neq \nu   %<'FontName',MSVFORMFONT>
%
% und 
%
% f_\mu = (x_\mu M f / (f_s z_\mu)) mod z_\mu         %<'FontName',MSVFORMFONT>
% 
% Die  {\fontname{Courier}x_\mu}  sind eine Lsung der diophantischen Gleichung
%    N                                                %<'FontName',MSVFORMFONT>
% ( {\fontsize{30}_\Sigma} x_\mu M / z_\mu) mod M = 1 %<'FontName',MSVFORMFONT>
%   \mu=1                                             %<'FontName',MSVFORMFONT>
%
% Eine solche Lsung existiert nach dem chinesischen Restsatz, wenn die  {\fontname{Courier}z_\mu}  paarweise 
% teilerfremd sind, d.h.  {\fontname{Courier}gcd(z_\mu,z_\nu) = 1   \forall \mu \neq \nu}
% Hierin bedeutet die Funktion  {\fontname{Courier}gcd}  den grten gemeinsamen Teiler der Argumente. 
%
% Folgendes MATLAB-Script fhrt die Rechnungen aus fr  {\fontname{Courier}N < 5} :
%
z  = [173  179  181  191]       %  4 Tabellenlngen
M  = prod(z)                    %  der Vollkreis wird in diese Anzahl quantisiert
x  = diophant(z)                %  Lsung der Diophantischen Gleichung
fs = 44100                      %  Abtastfrequenz
f  = 440                        %  Sollfrequenz
df = fs/M                       %  Frequenzschritt
nf = round(f/df)                %  Sollfrequenz in Schritten
fm = mod( nf * x , z )          %  die Frequenzzerlegung
ft = fs*fm./z                   %  die realen Teilfrequenzen
fr = mod(sum(ft),fs)            %  die realisierte Ausgabefrequenz
%
% Das Prinzip wird durch folgende Animation erlutert:
%
newddsanimat([3 4 5],1/60)
%
% Das Frequenzraster ist gegeben durch den Frequenzschritt
%
% \deltaf = f_s / M                                   %<'FontName',MSVFORMFONT>
%
% Im Falle des obigen Beispiels ist  {\fontname{Courier}\deltaf = f_s / 60} .  Dargestellt wurde gerade diese 
% kleinste erzeugbare positive Frequenz.  Das selbe Beispiel fr eine grssere Frequenz:
%
newddsanimat([3 4 5],0.37)
%
% Die Teilschwingungen der Frequenzen {\fontname{Courier}f_\mu}  sollen durch Tabellennachschlag 
% realisiert werden.  Die Tabellenlnge fr je eine ganze Schwingung sei  {\fontname{Courier}z_\mu} .  
% Ein Vorteil dieser Methode liegt darin, dass die Tabelle der Winkelquantisierung
% genau entspricht.
%
% Z.B. erreicht man mit drei Tabellen der Lngen  {\fontname{Courier} 991  1009  1013}  schon die 
% geforderte Einstellgenauigkeit.  Sollen die Tabellen kleiner sein, muss man mehr 
% nehmen, z.B. {\fontname{Courier} 173  179  181  191 }  oder  {\fontname{Courier} 23  29  31  37  41  43} . 
%
% Ein Vorteil dieser Methode ist auch die grssere Freiheit bei der Festlegung eines 
% Rasters generierbarer Frequenzen.  Soll z.B. fr die Abtastrate der CD ein Raster 
% mit Schritten von genau  {\fontname{Courier}1.000 Hz}  realisiert werden, so ist offenbar  {\fontname{Courier}M = 44100} .  
% Als Zerlegung in Primfaktoren erhlt man  {\fontname{Courier}M = 44100 = 2^2 \cdot 3^2 \cdot 5^2 \cdot 7^2} .  
% Hieraus ergeben sich eine Reihe von Mglichkeiten fr die  {\fontname{Courier}z_\mu} .  Eine sinnvolle ist 
% z.B.  {\fontname{Courier}N = 2}  mit  {\fontname{Courier}z_1 = 196, z_2 = 225} .
%
%
%% bung 12.1.3a  Prfen Sie exemplarisch durch Benutzung verschiedener 
%% Tabellenlngen  z  in obigem Script, ob der Fehler  fr  der realisierten 
%% Frequenz tatschlich kleiner ist als  df/2.
%
%% bung 12.1.3b  Nach der beschriebenen Methode soll mit dem  DSP56002 
%% bei der Abtastrate von  8000 Hz  ein Frequenzraster von genau  0.01 Hz 
%% realisiert werden.  Welche Mglichkeiten gibt es fr die  z_\mu ?
%% Kann man die On-Chip-Sinustabelle mit  z_1 = 256  verwenden ?
%
