%
%
%12.1.4  Phasenregelung (PLL)  %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-2,'Color',MSVTITLCOLOR>
%
%
%
%  Bei der Phase Locked Loop (PLL) wird ein Oszillator OSC durch Regelung 
%  auf eine vorgegebene Frequenz gezwungen.  Aus einer Referenzschwingung der 
%  Frequenz  {\fontname{Courier}f_r} wird durch Frequenzteilung die Sollfrequenz   {\fontname{Courier}f_p = f_r/n}  
%  erzeugt.  Ebenso teilt man die Oszillatorfrequenz  {\fontname{Courier}f}  durch   {\fontname{Courier}m} :  {\fontname{Courier}f_p' = f/m} .  
%  In einem Phasendetektor  {\fontname{Courier}PD}  wird die Phasendifferenz zwischen  {\fontname{Courier}f_p}  und  {\fontname{Courier}f_p'}
%  bestimmt.  Diese wird durch ein Reglerfilter den Erfordernissen angepasst und 
%  dann als Regelgrsse zur Steuerung des Oszillators benutzt.  Das folgende Bild 
%  zeigt das Schema einer PLL.
%
pllgraph
%
%  Wenn die Regelung arbeitet - man sagt die PLL hat gefangen - dann gilt offenbar
%
%  {\fontname{Courier}f/m = f_r/n} ,   also   {\fontname{Courier}f = f_r m / n}
%
%  Mit einer PLL kann man nur Frequenzen  {\fontname{Courier}f} erzeugen, deren Frequenzverhltnis zu  
%  {\fontname{Courier}f_r} man durch die gegeben Frequenzteiler einstellen kann.  Meistens legt man  {\fontname{Courier}n}
%  fest und verndert nur  {\fontname{Courier}m} .   Dann kann man diskrete quidistante Frequenzen 
%  erzeugen im Abstand  {\fontname{Courier}f_p = f_r / n }.
%
%  Das folgende Beispiel zeigt den Einschwingvorgang einer PLL fr den Fall  {\fontname{Courier}m = 1}  
%  und  {\fontname{Courier}n = 1} .  Das Eingangssignal, auf das sich die PLL synchronisieren soll ist 
%  zustzlich verrauscht.  Eingangs- und Ausgangssignal sind auch als Audiosignal zu hren.
%
pll;
%
%%  Dies sollte mehrfach aufgerufen werden.
%
%  {\fontname{Courier}n}  kann nicht beliebig klein gewhlt werden, weil sonst die Frequenz  {\fontname{Courier}f_p} ,
%  auf der die Phase verglichen wird, sehr klein wird.  Dann msste auch die Regelung 
%  entsprechend trge erfolgen.  Der freie Oszillator ist aber vielfltigen Strungen 
%  ausgesetzt.  Wenn die Regelung zu langsam ist, luft er weg bzw. kann gar nicht erst 
%  gefangen werden.  Die Ungenauigkeit der Phase wird Phasenrauschen genannt.  
%  Sie hat zur Folge, dass das Spektrum des erzeugten Signals eine gewisse Breite hat.
%
%  Die wesentlichen Eigenschaften einer PLL sind:
%
%  (1)  erzeugbares Frequenzraster mit Schrittweite  {\fontname{Courier}f_p = f_r/n}
%  (2)  das Phasenrauschen ist gross bei grossem  {\fontname{Courier}n}
%  (3)  Kompromiss zwischen Fangbereich und Phasenrauschen
%  (4)  nach nderung von  {\fontname{Courier}m}  muss die Fangzeit abgewartet werden
%
