%
%
%
%
%12.3.3  Klassische DDS   %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Die gewnschte Geschwindigkeit der Berechnung legt nahe, die Ausgabewerte 
% in einer Tabelle abzulegen.  Der ermittelte Adressraum von wenigstens  {\fontname{Courier}2^{30}}  
% ist jedoch unrealistisch.  Man nimmt deshalb die  {\fontname{Courier}m}  signifikantesten Bits der 
% Winkelreprsentation fr einen Tabellennachschlag und geht dann nach einem 
% der drei folgenden Varianten vor:
%
% (1)  Der Tabellenwert wird direkt ausgegeben
%
% (2)  Man fhrt eine lineare Interpolation durch zwischen zwei 
%       benachbarten Tabellenwerten
%
% (3)  Man rechnet eine Taylor-Entwicklung um einen Tabellenpunkt (z.B. vom Grad 3)
%
% (4)  Man ermittelt die Sinuswerte mit einer Polynomapproximation um den Nullpunkt
%
% Die erreichbaren Genauigkeiten der ersten drei Verfahren berechnet die Funktion  
% {\fontname{Courier}sinprec( 2^m , Verfahren )} :
%
sinprec(16,1);         %  m = 4    direkter Tabebellenwert
%
sinprec(16,2);         %  m = 4    lineare Interpolation
%
sinprec(16,3);         %  m = 4    Taylor-Entwicklung  3. Grades
%
sinprec(256,3);        %  m = 8    Taylor-Entwicklung  3. Grades
%
%
% Bei allen Verfahren ausser dem vierten ist der Fehler jeweils in Halbwellen 
% systematisch wegen des dort gleichen Vorzeichens der Krmmung.  Das macht 
% sich im Spektrum durch Nebenwellen bemerkbar. 
%
% Zwei Beispiele:
%
%{\fontname{Courier}            f     n    m    w}
ddssim( 3/23 , 32 , 8 , 16 );                            %  rationale Frequenz (f_a = 1.0) ;  Rechteckfenster
%
%{\fontname{Courier}               f          n   m    w}
ddssim( 0.213759823 , 32 , 8 , 16 , 16 , 0 , 0 , 3 );    %  bel. Frequenz (f_a = 1.0) ;       Kaiserfenster
%
% Die systematischen Effekte des Quantisierungsrauschens lassen sich durch 
% Dithern verringern.  Das folgende Beispiel dithert die ROM-Adresse vor
% dem direkten Tabellennachschlag.
%
ddssim( 3/23 , 32 , 8 , 16 , 16, 0 , 0 );        %  ohne Dithern
for k=1:4  delete(gcf); end                      %  nicht bentigte Bilder entfernen
ddssim( 3/23 , 32 , 8 , 16 , 16, 1 , 0 );        %  mit Dithern
for k=1:4  delete(gcf); end                      %  nicht bentigte Bilder entfernen
%
% Offensichtlich ist das Dithern der ROM-Adresse bei sehr schnellen Realisierungen, 
% die ohne Interpolation oder Taylor-Entwicklung auskommen mssen, ein brauchbares 
% Verfahren.  Das  SNR  wird dabei nur geringfgig schlechter.
%
% Nun dithern wir das Ausgangssignal der Taylor-Entwicklung:
%
ddssim( 3/23 , 32 , 8 , 16 , 16, 0 , 0 );        %  ohne Dithern
ddssim( 3/23 , 32 , 8 , 16 , 16, 0 , 1 );        %  mit Dithern
delete(findobj('Name','Tabelle direkt'))                    %  nicht bentigte Bilder entfernen
delete(findobj('Name','Ausschnitt Tabelle direkt'))         %  nicht bentigte Bilder entfernen
delete(findobj('Name','lineare Interpolation'))             %  nicht bentigte Bilder entfernen
delete(findobj('Name','Ausschnitt lineare Interpolation'))  %  nicht bentigte Bilder entfernen
%
% Das Dithern der Ausgabewerte ist offensichtlich weniger erfolgreich, 
% bringt aber auch noch  2 dB  bei nur geringer Anhebung des SNR.
%
%
% Das vierte der oben genannten Verfahren benutzt keine Tabelle.  Der strende 
% Fehler durch die Quantisierung der ROM-Adresse entfllt deshalb.  Die erreichbare 
% Genauigkeit lsst sich mit der Funktion  {\fontname{Courier}polynomfit} ermitteln:
%
help polynomfit
%
% Wir probieren die Approximation von  {\fontname{Courier}sin(pi/2*x)}  im Bereich von 
% {\fontname{Courier}0 <= x <= 1}  fr mehrere Polynomgrade bei einer Reprsentation der 
% Sinuswerte und der Koeffizienten in  {\fontname{Courier}16} Bit :
%
polynomfit( 'sin(pi/2*x)' , 4, 16 )   %  Grad 4
%
polynomfit( 'sin(pi/2*x)' , 5, 16 )   %  Grad 5
%
polynomfit( 'sin(pi/2*x)' , 6, 16 )   %  Grad 6
%
polynomfit( 'sin(pi/2*x)' , 7, 16 )   %  Grad 7
%
% Sichtlich lsst sich wegen der Quantisierung mit einem hheren Grad als 6 kaum 
% etwas gewinnen. 
%
%
%% bung 12.3.3  Ermitteln Sie Polynome von minimalem Grad mit optimaler 
%% Genauigkeit fr die Quantisierung in  24  und  32 Bit.
%