%
%
%
%
%12.4.2  Klassische DDS mit Taylor-Entwicklung  %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-16,'Color',MSVTITLCOLOR>
%
%
%
% Nachfolgend ein Unterprogramm zur Generierung von cos/sin-Paaren 
% mit dem DSP56002
%
%\fontname{Courier};========================= Sinus-Cosinus-Generator ============================
%\fontname{Courier}; Digitale Direkt Synthese (DDS) mit 23 Bit-Genauigkeit.
%\fontname{Courier};
%\fontname{Courier}; Es wird die interne Sinus-Tabelle benutzt und um den jeweils nchsten 
%\fontname{Courier}; unteren Tabelleneintrag eine Taylor-Entwicklung dritten Grades gemacht.
%\fontname{Courier}; 
%\fontname{Courier}; Im Hauptprogramm sind folgende Konstanten im  x-Speicher zu deklarieren:
%\fontname{Courier};
%\fontname{Courier}; K0000FF dc $0000FF   ; Maske fr den Index der Sinustabelle
%\fontname{Courier}; K000100 dc $000100   ; Basis der Sinustabelle im y-Speicher
%\fontname{Courier}; K000140 dc $000140   ; Basis der CosinusTabelle
%\fontname{Courier}; K2PI256 dc $03243F   ; 2*3.1415926535/256
%\fontname{Courier}; K1DIV6  dc $155555   ; 1/6
%\fontname{Courier}; 
%\fontname{Courier}; Parameterbergabe: r1 mu auf den Anfang des Parameterfeldes zeigen.
%\fontname{Courier}; Das Parameterfeld liegt im L-Speicher und enthlt zwei Eintrge:
%\fontname{Courier}; 0. den Phasenakku
%\fontname{Courier}; 1. den Phasenschritt
%\fontname{Courier};
%\fontname{Courier}; Der berechnete Cosinus wird auf dem Akkumulator a ausgegeben.
%\fontname{Courier}; Der berechnete Sinus wird auf dem Akkumulator b ausgegeben.
%\fontname{Courier};
%\fontname{Courier}; typischer Aufruf:
%\fontname{Courier};       move    Parameterbasis,r1
%\fontname{Courier};       jsr     Sincos24
%\fontname{Courier};       move    ab,l:COS_SIN
%\fontname{Courier};
%\fontname{Courier}; Der Phasenschritt als Ganzzahl im Langformat ist wie folgt zu bestimmen: 
%\fontname{Courier}; Phasenschritt = (2^32)*(Sinusfrequenz)/(Aufruffrequenz). Beispiel:
%\fontname{Courier}; Sinus: 1.0 k Hz;  Abtastung: 48 k Hz. Damit ergibt sich fr die Parameter:
%\fontname{Courier};       org     l:Sinusparameter
%\fontname{Courier};       ds      1
%\fontname{Courier};       dc      $000005555555 
%\fontname{Courier};
%\fontname{Courier}; Damit die Sinus-Tabelle verfgbar ist, mu  move  #4,omr   erfolgen.
%\fontname{Courier}; Hinweis: Die Routine ist nicht optimiert. Verbesserungen bitte melden
%\fontname{Courier};          an K. v. d. Heide, e-mail:  v.d.heide@on-line.de
%\fontname{Courier}
%\fontname{Courier}Sincos24
%\fontname{Courier}        move    l:(r1)+,a        ; Phasenakku holen
%\fontname{Courier}        clr     b l:(r1)-,x      ; Phasenschritt holen
%\fontname{Courier}        add     x,a x:K0000FF,x0 ; Phasenaddition und Tabellenmaske
%\fontname{Courier}        and     x0,a             ; Maskierung modulo Tabellenlnge 256
%\fontname{Courier}        move    a,l:(r1)         ; Phasenakku speichern
%\fontname{Courier}        move    a1,n1            ; Index in Tabelle als Offset setzen
%\fontname{Courier}        move    b1,a1            ; 2*DX' durch Lschen der oberen Bits
%\fontname{Courier}        asr     a                ; DX' durch ShiftR
%\fontname{Courier}        move    x0,m1            ; Modulus fr Sinustabelle setzen
%\fontname{Courier}        move    x:K000100,r1     ; Basis der Sinustabelle setzen
%\fontname{Courier}        move    a0,y1            ; DX' => y1
%\fontname{Courier}        move    x:K2PI256,x1     ; 2*PI/256 => x1
%\fontname{Courier}        mpyr    x1,y1,a y:(r1+n1),y0 ;DX = 2*PI/256 * DX' => a, sin => y0 
%\fontname{Courier}        move    x:K000140,r1     ; Basis der Cosinustabelle setzen
%\fontname{Courier}        move    x:K1DIV6,y1      ; 1/6 => y1
%\fontname{Courier}        move    y:(r1+n1),x0     ; cos => x0
%\fontname{Courier}        mpyr    -x0,y1,b a,x1    ; -cos/6 => b, DX => x1
%\fontname{Courier}        mpyr    y0,y1,a  b,y1    ; -cos/6 => y1, sin/6 => a
%\fontname{Courier}        mpy     -y0,#1,b         ; -sin/2 => b
%\fontname{Courier}        macr    x1,y1,b          ; -sin/2 - DX*cos/6 => b
%\fontname{Courier}        move    b,y1             ; -sin/2 - DX*cos/6 => y1
%\fontname{Courier}        mpy     x1,y1,b          ; DX*(-sin/2 - DX*cos/6) => b
%\fontname{Courier}        add     x0,b             ; cos + DX*(-sin/2 - DX*cos/6) => b
%\fontname{Courier}        move    b,y1             ; cos + DX*(-sin/2 - DX*cos/6) => y1
%\fontname{Courier}        mpy     x1,y1,b  a,y1    ; DX*(cos + DX*(-sin/2 - DX*cos/6)) => b
%\fontname{Courier}        add     y0,b             ; sin + DX*(cos + DX*(-sin/2 - DX*cos/6)) =>b
%\fontname{Courier}        rnd     b                ; Rundung auf 24 Bit
%\fontname{Courier}        mpy     -x0,#1,a         ; -cos/2 => a
%\fontname{Courier}        macr    x1,y1,a          ; -cos/2 + DX*sin/6 => a
%\fontname{Courier}        move    a,y1             ; -cos/2 + DX*sin/6 => y1
%\fontname{Courier}        mpy     x1,y1,a          ; DX*(-cos/2 + DX*sin/6) => a
%\fontname{Courier}        sub     y0,a             ; -sin + DX*(-cos/2 + DX*sin/6) => a
%\fontname{Courier}        move    a,y1             ; -sin + DX*(-cos/2 + DX*sin/6) => y1
%\fontname{Courier}        mpy     x1,y1,a          ; DX*(-sin + DX*(-cos/2 + DX*sin/6)) => a
%\fontname{Courier}        add     x0,a             ; cos + DX*(cos + DX*(-sin/2 - DX*cos/6)) =>a
%\fontname{Courier}        rnd     a                ; Rundung auf 24 Bit
%\fontname{Courier}        rts
%\fontname{Courier};============================ Ende Sincosgenerator =============================
%
%
% Ein lauffhiges Programm kann eingesehen werden:
%
edit cossint.asm
%
