%
%
%13.1  Einfhrung %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  FIR-Tiefpassfilter oder Bandpassfilter mit sehr schmalem Durchlassbereich und 
%  engen bergangsbereichen erfordern sehr hohen Filtergrad.  Hier ein Beispiel 
%  mit  {\fontname{Courier}553}  Koeffizienten:
%
[n,fo,mo,w] = remezord([0.01,0.015],[1 0],[0.03 0.0001],1); 
b = remez(n,fo,mo,w); 
h2 = fullscreen('Impulsantwort','w',0,[2 1; 1 1]);
stem(b); 
set(gca,'XLim',[0,n+2])
text(350,0.017,'Impulsantwort','FontSize',13)
h1 = fullscreen('FIR-TP','w',0,[2 1; 2 1]);
filterplot(b,0,0.1);
text(0.045,-10,['FIR-Tiefpass mit ' num2str(n+1) ' Koeffizienten'],'FontSize',13)
%
%  In diesem Beispiel knnte das Ausgangssignal des Filters mit  {\fontname{Courier}f_s/32 = 0.03125\cdotf_s}  
%  abgetastet werden.  Das Filter braucht also nur in jedem  {\fontname{Courier}32}. Abtastschritt gerechnet 
%  zu werden.  Bei Multiratenfiltern erfolgt diese Abtastratenreduzierung in mehreren 
%  Schritten mit einfacheren Filtern.
%
%  Zur Demonstration nutzen wir die Mglichkeiten der Funktion  
%  {\fontname{Courier}filterplot(b,f1,f2,vs,d1,d2,dez,p,ser)} durch die Parameter  {\fontname{Courier}dez} und  {\fontname{Courier}ser} . 
%  Aus dem Kommentar von  {\fontname{Courier}filterplot} :
%
%  dez:   Zeilenvektor, der die Dezimationszahlen der Filter enthlt;    %<'FontName',MSVFORMFONT>
%         z.B.  [1, 2, 4].  Default ist [1  1  1 ...]                    %<'FontName',MSVFORMFONT>
%         Wird ein Skalar dez angegeben, so gilt dieser fr alle Filter. %<'FontName',MSVFORMFONT>
%  ser:   Ist ser = 1 , dann wird der Frequenzgang der Serienschaltung   %<'FontName',MSVFORMFONT>
%         aller in b enthaltenen Filter gezeichnet.                      %<'FontName',MSVFORMFONT>
%
%  {\fontname{Courier}dez}  ist das Verhltnis der Abtastfrequenzen von Input zum Output des Filters, 
%  bzw. sei der zeitliche Abstand zweier Abtastungen beim Input  {\fontname{Courier}t_i}  und bei der 
%  Filterausgabe  {\fontname{Courier}t_a} , dann gilt  {\fontname{Courier}dez = t_a/t_i} .  Die Frequenzachse von
%  {\fontname{Courier}filterplot}  bezieht sich dann auf den Input.  Entsprechend gilt das fr  
%  {\fontname{Courier}f_1}  und  {\fontname{Courier}f_2} .  Setzt man reziprok ein  {\fontname{Courier}dez = t_i/t_a} , so gelten  {\fontname{Courier}f_1, f_2}  und die
%  Frequenzachse fr die Filterausgabe. Die Ausgabe stellt jedoch die Periodizitt 
%  nicht dar, sie ist also auf den Bereich  {\fontname{Courier}0..1} zu beschrnken.
%
%  Zunchst probieren wir dies bei dem oben berechneten Filter mit  {\fontname{Courier}dez = 1/32} ,
%  um den Frequenzgang des Ausgangssignals zu betrachten bezogen auf die um {\fontname{Courier}1/32}
%  reduzierte Abtastrate:
%
h3 = fullscreen('Filterplot');
filterplot(b,0,1,0,-100,10,1/32)
%
%  Bei Multiratenfiltern werden mehrere Filter mit stufenweise reduzierter 
%  Abtastrate hintereinander geschaltet.  Wir versuchen dies mit einem einfachen 
%  Halbbandtiefpass und der Abtastratenreduzierung, der sog. Dezimation um den 
%  Faktor  {\fontname{Courier}1/2} , die dreimal erfolgt.  Das erste Bild zeigt das Verhalten 
%  der drei Filter bezogen auf die Abtastrate des Inputs.  Fr das zweite Bild 
%  wird der Parameter  {\fontname{Courier}ser = 1}  gesetzt, um den Frequenzgang der Kombination 
%  der Filter darzustellen.
%
b = fir1(20,1/2);
h4 = fullscreen('Einzelfilter','w',0,[2 1; 1 1]);
filterplot({b;b;b},0,1,0,-100,10,[1,2,4])
h5 = fullscreen('Filterkombination','w',0,[2 1; 2 1]);
filterplot({b;b;b},0,1,0,-100,10,[1,2,4],24,1)
%
%  Auf diese Weise lassen sich Tiefpsse mit sehr kleinen Durchlassbreiten realisieren. 
%  Wir verwenden das obige Filter in einer  {\fontname{Courier}5}-stufigen Kaskade von Dezimationen:
%
h6 = fullscreen('Einzelfilter','w',0,[2 1; 1 1]);
filterplot({b;b;b;b;b},0,1,0,-100,10,[1,2,4,8,16],24)
h7 = fullscreen('Filterkombination','w',0,[2 1; 2 1]);
filterplot({b;b;b;b;b},0,1,0,-100,10,[1,2,4,8,16],24,1)
%
%  Dieses einfache Filter erreicht zwar nicht die Dmpfung unseres ersten Beispiels, 
%  es zeigt aber das Prinzip der Multiratenfilter.
%
%  Zur Vereinfachung der Darstellung von Multiratenfilterkaskaden dient die Funktion  
%  {\fontname{Courier}mrplot(b,s,k,d1,d2)} :
%
%    Demonstration einer s-stufigen Kaskade von Dezimationsfiltern  %<'FontName',MSVFORMFONT>
%    mit Dezimation um den Faktor k.   b sind die Koeffizienten.    %<'FontName',MSVFORMFONT>
%    d1 .. d2 ist der Frequenzbereich fr den Plot bezogen          %<'FontName',MSVFORMFONT>
%    auf die halbe Abtastrate der Filtereingabe.                          %<'FontName',MSVFORMFONT>
%
%  Fr das vorige Beispiel ergibt sich:
%
mrplot(b,5,2,0,1)
%
%  Der folgende Abschnitt behandelt den Entwurf von Dezimationsfiltern.
%  
