%
%
%13.2  Dezimation%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Der bersichtlichkeit halber soll zunchst der einfachste Fall des Dezimationsfaktors  {\fontname{Courier}k = 2}
%  behandelt werden, d.h. es ist ein FIR-Filter zu entwerfen, dass alle Spiegel sperrt, 
%  die bei der Abtastratenreduzierung auf  {\fontname{Courier}f_s' = f_s/k}  entstehen. 
%  Dies sei am Beispiel des Entwurfs fr einen Tiefpass mit folgenden Eigenschaften 
%  diskutiert:
%
%  Durchlassbereich   0 .. 0.1   mit Welligkeit < 0.1 dB   %<'FontName',MSVFORMFONT>
%  bergang         0.1 .. 0.125                           %<'FontName',MSVFORMFONT>
%  Sperrbereich   0.125 .. 1     mit   Dmpfung > 60 dB    %<'FontName',MSVFORMFONT>
%
%  Das erste Dezimationsfilter muss also den Bereich  {\fontname{Courier}0... 0.1}  mit geringer Welligkeit 
%  durchlassen und den Spiegel bei  {\fontname{Courier}0.9...1}  wenigstens mit  {\fontname{Courier}-60} dB sperren.
%
%  Zur Anschauung geben wir die Filterspezifikation graphisch aus und probieren diese 
%  danach mit einem Tiefpass von mglichst kleinem Filtergrad zu erfllen. Im Fall der 
%  Dezimation mit  {\fontname{Courier}k = 2}  ist hufig ein Halbbandtiefpass optimal. 
%  Wir beginnen mit einem solchen vom Grad  {\fontname{Courier}4} .
%
%%  Dieser Abschnitt sollte in der vorgesehenen Reihenfolge bearbeitet werden, weil 
%%  Filterkoeffizienten nicht fr jedes Diagramm neu berechnet werden, andernfalls 
%%  Fehlermeldungen.  Danach sind Wiederholungen in beliebiger Reihenfolge mglich.
%
r1 = 0.1;
b1 = remez(4,[0,r1,1-r1,1],[1,1,0,0])
filspezgraph([0,r1],[1-r1,1],0.5,-60,b1);  set(gcf,'Name','D1 S-')
text(0.25,-45,'Filter 1: Spezifikation im Sperrbereich verletzt','FontSize',13,'Color','r')
%
b1 = remez(6,[0,r1,1-r1,1],[1,1,0,0])
filspezgraph([0,r1],[1-r1,1],0.5,-60,b1);  set(gcf,'Name','D1 S+'); setfigpos(2,1,1,1)
text(0.25,-45,'Filter 1: Spezifikation im Sperrbereich erfllt','FontSize',13)
h3 = fullscreen('D1 D+'); setfigpos(2,1,2,1);
filterplot(b1,0,r1,0,-0.01,0.01)
text(0.02,0.0075,'Filter 1: Spezifikation im Durchlassbereich erfllt','FontSize',13)
%
%  Das Filter mit nur fnf nicht verschwindenden Koeffizienten  erfllt schon 
%  die Spezifikation.
%
%  Das zweite Dezimationsfilter muss den Bereich  {\fontname{Courier}0...0.2}  mit geringer 
%  Welligkeit durchlassen und den Spiegel bei  {\fontname{Courier}0.8...1}  wenigstens mit  {\fontname{Courier}-60} dB sperren. 
%  Die Frequenzangaben beziehen sich nun auf die vom ersten Filter ausgegebene
%  dezimierte Abtastung.
%
%  Zur Anschauung geben wir wieder die Filterspezifikation graphisch aus und 
%  probieren diese danach mit einem Halbbandtiefpass von mglichst kleinem 
%  Filtergrad zu erfllen: 
%
r2 = 0.2;
b2 = remez(8,[0,r2,1-r2,1],[1,1,0,0])
filspezgraph([0,r2],[1-r2,1],0.5,-60,b2);  set(gcf,'Name','D2 S-');
text(0.25,-45,'Filter 2: Spezifikation im Sperrbereich verletzt','FontSize',13,'Color','r')
%
b2 = remez(10,[0,r2,1-r2,1],[1,1,0,0])
filspezgraph([0,r2],[1-r2,1],0.5,-60,b2);  set(gcf,'Name','D2 S+'); setfigpos(2,1,1,1)
text(0.25,-45,'Filter 2: Spezifikation im Sperrbereich erfllt','FontSize',13)
h6 = fullscreen('D2 D+'); setfigpos(2,1,2,1);
filterplot(b2,0,r2,0,-0.01,0.01)
text(0.02,0.0075,'Filter 2: Spezifikation im Durchlassbereich erfllt','FontSize',13)
%
%  Das Filter mit nur sieben nicht verschwindenden Koeffizienten erfllt die Spezifikation.
%
%  Das dritte Dezimationsfilter muss den Bereich  {\fontname{Courier}0... 0.4}  mit geringer Welligkeit 
%  durchlassen und den Spiegel bei  {\fontname{Courier}0.6...1}  wenigstens mit  {\fontname{Courier}-60} dB sperren. 
%  Die Frequenzangaben beziehen sich nun auf die vom zweiten Filter ausgegebene
%  dezimierte Abtastung.  Wie bei den beiden vorigen Filtern ergibt sich das 
%  optimale Filter:
%
r3 = 0.4;
b3 = remez(34,[0,r3,1-r3,1],[1,1,0,0]); 
filspezgraph([0,r3],[1-r3,1],0.5,-60,b3);  set(gcf,'Name','D3 S+'); setfigpos(2,1,1,1)
text(0.25,-45,'Filter 3: Spezifikation im Sperrbereich erfllt','FontSize',13)
h8 = fullscreen('D3 D+'); setfigpos(2,1,2,1);
filterplot(b3,0,r3,0,-0.01,0.01)
text(0.02,0.0075,'Filter 3: Spezifikation im Durchlassbereich erfllt','FontSize',13)
%
%  Wegen des deutlich kleineren bergangsbereiches sind hier erheblich mehr 
%  Koeffizienten erforderlich ({\fontname{Courier}18} nicht verschwindend).
%
%  Die Frequenzgnge der drei Filter getrennt bzw. den Frequenzgang der 
%  Dezimationskaskade zeigen die folgenden Bilder.  Dabei offenbart sich ein 
%  Problem in den bergangsbereichen:
%
h9 = fullscreen('D123--'); setfigpos(2,1,1,1);
filterplot({b1;b2;b3},0,1,0,-80,10,[1 2 4],24)
legend('Filter 1','Filter 2','Filter 3')
h10 = fullscreen('Kaskade S--'); setfigpos(2,1,2,1);
filterplot({b1;b2;b3},0,1,0,-80,10,[1 2 4],24,1)
drawarr([0.3735,-10],[0.3735,-40],'r',4,6)
text(0.15,-5,'Filterkaskade: Spezifikation im Sperrbereich verletzt','FontSize',13,'Color','r')
%
%  Es empfiehlt sich immer diese beiden Diagramme bereinander darzustellen, 
%  weil daran zu erkennen ist, durch welche Parameternderung das Problem gelst 
%  werden kann. Hier sollte offenbar  {\fontname{Courier}r2}  etwas vergrssert werden. 
%  Mit  {\fontname{Courier}r2 = 0.25}   erreicht man das Ziel gerade nicht ganz.  Denn wegen der 
%  Erhhung von  {\fontname{Courier}r2}  ist die Dmpfung des Filters 2 nicht mehr ganz ausreichend:
%
r2 = 0.25;
b2 = remez(10,[0,r2,1-r2,1],[1,1,0,0]);
h11 = fullscreen('D123-'); setfigpos(2,1,1,1);
filterplot({b1;b2;b3},0,1,0,-80,10,[1 2 4])
legend('Filter 1','Filter 2','Filter 3')
h12 = fullscreen('Kaskade S-'); setfigpos(2,1,2,1);
filterplot({b1;b2;b3},0,1,0,-80,10,[1 2 4],24,1)
text(0.15,-5,'Spezifikation im Sperrbereich geringfgig verletzt','FontSize',13,'Color','r')
%
%  Mit etwas hherem Filtergrad gelingt es:
%
b2 = remez(14,[0,r2,1-r2,1],[1,1,0,0]);
h13 = fullscreen('D123'); setfigpos(2,1,1,1);
filterplot({b1;b2;b3},0,1,0,-80,10,[1 2 4])
legend('Filter 1','Filter 2','Filter 3')
h14 = fullscreen('Kaskade'); setfigpos(2,1,2,1);
filterplot({b1;b2;b3},0,1,0,-80,10,[1 2 4],24,1)
text(0.15,-5,'Spezifikation knapp erfllt','FontSize',13)
%
%  Durch die kleine nderung   {\fontname{Courier}r1 = 0.118}   gelingt noch ein Ausgleich der 
%  Welligkeit im Sperrbereich.  Zu prfen ist auch noch, ob die Forderung  
%  Welligkeit {\fontname{Courier}< 0.1}   von der Kombination der Filter eingehalten wird:
%
r1 = 0.118;
b1 = remez(6,[0,r1,1-r1,1],[1,1,0,0]);
h15 = fullscreen('D123'); setfigpos(2,1,1,1);
filterplot({b1;b2;b3},0,1,0,-80,10,[1 2 4],24,1)
text(0.25,-5,'Frequenzgang der Dezimationsfilterkaskade','FontSize',13)
h16 = fullscreen('Kaskade'); setfigpos(2,1,2,1);
filterplot({b1;b2;b3},0,0.1,0,-0.1,0.1,[1 2 4],24,1)
text(0.035,0.075,'Welligkeit im Durchlassbereich','FontSize',13)
%
%  Der Rechenaufwand fr die Kaskade ergibt sich durch Summation der Brche  
%  (Anzahl Koeffizienten) / Dezimationsfaktor:
%
%      5/2 + 9/4 + 19/8 = 2.5 + 2.25 + 2.375 = 7.125   %<'FontName',MSVFORMFONT>
%
%  Dies ist die Zahl der Multiplikationen und Additionen pro Abtastung des Inputsignals.
%
%  In diesem Fall sind Halbbandtiefpsse verwendet worden.  Sind die Anforderungen 
%  an Welligkeit im Durchlass und Sperrbereich sehr unterschiedlich, z.B. Welligkeit 
%  im Durchlass {\fontname{Courier}< 2.0} dB  Sperrdmpfung {\fontname{Courier}> 80} dB  entsprechend 
%  Welligkeit {\fontname{Courier}< 0.00087} dB, dann knnen normale FIR-Tiefpsse gnstiger sein.
%
%  Vergleicht man den Frequenzgang der Dezimationsfilterkaskade mit der Spezifikation 
%  des Gesamtfilters, so zeigt sich ein Widerspruch im bergangsbereich:
%
h17 = fullscreen('Dezimationsfilterkaskade');
filterplot({b1;b2;b3},0,1,0,-80,10,[1 2 4],24,1)
filspezgraph([0,0.1],[0.125,1],0.1,-60,'add');
text(0.25,-5,'Frequenzgang der Dezimationsfilterkaskade','FontSize',13)
text(0.2,-25,'Die Dezimationsfilterkaskade erfllt nicht die Spezifikation','FontSize',13,'Color','r')
%
%  Der Fehler liegt daran, dass die drei Filter als Dezimationsfilter entworfen 
%  wurden, wo nur der Durchlassbereich des Gesamtfilters eingeht.  blicherweise 
%  folgt nach der Dezimationskaskade das Kernfilter, welches den gewnschten
%  Verlauf der Durchlasskurve realisiert.  Dabei ergeben sich hufig - wie hier - 
%  zustzliche Forderungen an das letzte Dezimationsfilter.  In unserem Fall wird 
%  die Spezifikation nmlich im Bereich  {\fontname{Courier}0.125...0.150}  nicht eingehalten. 
%  Das liegt schon jenseits der Nyquistfrequenz nach der dritten Dezimationsstufe. 
%  Also muss das letzte Dezimationsfilter vollstndig die Aufgabe des Kernfilters 
%  bernehmen.  Seine Spezifikation muss also sein:
%
filspezgraph([0,r3],[0.125*4,1],0.5,-60);  set(gcf,'Name','D3Spez');
text(0.25,-45,'Filter 3: Spezifikation fr das dritte Dezimationsfilter','FontSize',13)
%
%  Dieses lsst sich nicht durch ein Halbbandfilter realisieren.  Wir realisieren 
%  das Filter wie im Abschnitt 6.4b beschrieben mit  {\fontname{Courier}remez} .  Die Forderung 
%  an die Welligkeit im Durchlassbereich ist bei  {\fontname{Courier}remezord}  in linearer 
%  Skala anzugeben.  Die Welligkeit der Kaskade der beiden ersten Filter von  
%  {\fontname{Courier}0.006} dB ist von der Spezifikation  {\fontname{Courier}0.1} dB abzuziehen. 
%  Damit ergibt sich die lineare Welligkeit zu  {\fontname{Courier}10^{(0.1 - 0.006)/20} - 1 = 0.0109} . 
%  Die Sperrdmpfung ist nahezu  {\fontname{Courier}60} dB bzw.  {\fontname{Courier}0.001} . 
%
r  = remezord([r3,0.125*4],[1,0],[0.0108,0.001],2,'cell');
b4 = remez(r{1},r{2},r{3},r{4})
filspezgraph([0,r3],[0.125*4,1],0.5,-60,b4);  set(gcf,'Name','D3++'); setfigpos(2,1,1,1)
text(0.6,-25,'Filter 3','FontSize',13)
h19 = gcf;
h20 = fullscreen(''); setfigpos(2,1,2,1);
filterplot(b4,0,0.125*4,0,-0.12,0.12)
figure(h19)
%
%%  Das ber remezord entworfene Filter verfehlt knapp die Spezifikation. 
%%  Die Verbesserung lassen wir als bungsaufgabe.
%
%  Damit ist der Frequenzgang des Gesamtfilters:
%
h21 = fullscreen('D123++'); setfigpos(2,1,1,1);
filterplot({b1;b2;b4},0,1,0,-80,10,[1 2 4],24,1)
filspezgraph([0,0.1],[0.125,1],0.1,-60,'add')
text(0.25,-5,'Frequenzgang der Dezimationsfilterkaskade','FontSize',13)
h22 = fullscreen('Kaskade o.k.'); setfigpos(2,1,2,1);
filterplot({b1;b2;b4},0,0.1,0,-0.11,0.11,[1 2 4],24,1)
text(0.02,0.075,'Welligkeit im Durchlassbereich','FontSize',13)
figure(h21);
%
%  Die Spezifikation im Durchlassbereich wird sehr lokal im Bereich  {\fontname{Courier}0.0095...0.011}
%  um maximal  {\fontname{Courier}0.03}  dB verletzt.  Auch die Sperrdmpfung in direkter Nhe 
%  des bergangs im Bereich  {\fontname{Courier}0.1266...0.1274}  wird um maximal  {\fontname{Courier}0.4} dB verfehlt,
%  denn Die Parameter fr remez basieren auf einer Schtzung. Falls diese sehr 
%  kleinen Abweichungen nicht zulssig sind, ist ein passenderes Filter mit 
%  {\fontname{Courier}53}  Koeffizienten anstelle der  {\fontname{Courier}51}  sicher realisierbar. 
%  (bungsaufgabe!)
%  
%  Der Rechenaufwand fr das Gesamtfilter ist damit
%
%      5/2 + 9/4 + 51/8 = 2.5 + 2.25 + 6.375 = 11.125  %<'FontName',MSVFORMFONT>
%
%  
%  Im Fall der Dezimation um   {\fontname{Courier}k > 2}  erfolgt der Entwurf der Filter 
%  entsprechend.  Im Gegensatz zum einfachen Fall  {\fontname{Courier}k = 2}  muss das 
%  Dezimationsfilter aber Sperrbereiche fr mehrere Spiegel haben.  
%  Dies sei am Beispiel  {\fontname{Courier}k = 5}  demonstriert.  Das Nutzsignal liege im 
%  Bereich  {\fontname{Courier}0...r}  mit  {\fontname{Courier}r = 0.12}  ({\fontname{Courier}f_s/2 = 1}).  Die Sperrdmpfung sei -60 dB.
%
k = 5;
r = 0.12;
h23 = fullscreen('D-Spez k=5'); setfigpos(2,1,1,1);
filspezgraph([0,r],[2/k-r,2/k+r;4/k-r,4/k+r],0.5,-60)
text(0.25,-75,'Spezifikation eines Dezimationstiefpassfilters fr  k = 5','FontSize',13)
%
%  Ein erster Entwurf liefert:
%
k = 5;  r = 0.12;
b = remez(28,[0,r,2/k-r,2/k+r,4/k-r,4/k+r],[1,1,0,0,0,0],[0.017,1,1]);
filspezgraph([0,r],[2/k-r,2/k+r;4/k-r,4/k+r],0.5,-60,b);  set(gcf,'Name','k=5 S'); setfigpos(2,1,1,1)
h25 = fullscreen('k=5 D'); setfigpos(2,1,2,1);
filterplot(b,0,r,0,-0.5,0.5)
text(0.041,0.25,'Welligkeit im Durchlassbereich','FontSize',13)
%
%  Dieser Entwurf liesse sich noch etwas verbessern. Insbesondere die
%  Nullstelle bei  {\fontname{Courier}0.64}  ausserhalb der Sperrbereiche ist unntig.
%
%  Das beschriebene Verfahren zum Entwurf eines Multiraten-Tiefpassfilters lsst 
%  sich abgesehen vom letzten Schliff gut automatisieren.  Dies tut die Funktion
%  {\fontname{Courier}mrdesign}.  Die Parameter und die Ausgabe sind erlutert in
%
help mrdesign
%
%  Zwei Beispiele sind:
%
mrdesign(0.07,0.01,1,60,0);
%
mrdesign(0.003,0.001,1,90,0);
%
%  Hufig macht man sich nicht die Mhe, fr jede Dezimationsstufe ein spezielles 
%  Filter zu entwerfen.  Auch verbietet u.U. der verfgbare Speicherplatz eines 
%  Signalprozessors dieses Vorgehen.  Dann muss ein mglichst einfaches Filter 
%  gefunden werden, welches zumindest bis zur vorletzten Dezimationsstufe durchgehend 
%  verwendet werden kann.  Die Darstellung der Frequenzgnge ist in diesem Fall 
%  besonders einfach mit der schon im vorigen Abschnitt benutzten Funktion  
%  {\fontname{Courier}mrplot(b,s,k)} , wo  {\fontname{Courier}b}  der Koeffizientenvektor des Filters ist, 
%  {\fontname{Courier}s}  die Zahl der Stufen und  {\fontname{Courier}k}  der Dezimationsfaktor. 
%  Beispiel:  Das eben berechnete Filter fr  {\fontname{Courier}k = 5   s = 3} mal kaskadiert:
%
b = remez(28,[0,r,2/k-r,2/k+r,4/k-r,4/k+r],[1,1,0,0,0,0],[0.017,1,1]);
mrplot(b,3,5)
%
%  Die zwei Spitzen neben dem eigentlichen Durchlassgebiet, die die Forderung von 
%  {\fontname{Courier}-60} dB im Sperrgebiet nicht einhalten, mssen durch ein nachfolgendes 
%  Kernfilter gedmpft werden.
%
%  Ein weiteres Beispiel:
%
b = remez(10,[0,0.28,0.72,1],[1,1,0,0]); 
mrplot(b,3,2)
%
b = remez(10,[0,0.28,0.72,1],[1,1,0,0]); 
mrplot(b,6,2)
%
