%
%
%13.3  Interpolation%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Hufig wird das mit einem Multiratenfilter bearbeitete Signal in der ursprnglichen 
%  Abtastrate des Eingangssignals bentigt.  Nach der Filterung ist das Signal dann 
%  wieder synchron zu interpolieren.  Dies erfolgt am besten ber dieselben Schritte wie 
%  bei der Dezimation.  Das allgemeine Schema eines Multiratenfilters ist daher wie folgt:
%
mrfiltergraph
%
%  Mit der niedrigsten Abtastrate wird das sog.  Kernfilter gerechnet, das den 
%  eigentlichen Frequenzgang bestimmt.  Die Interpolation realisiert man wie im 
%  Abschnitt 9.2 besprochen durch Einfgung von Nullen (Hochtastung um den Faktor  {\fontname{Courier}k})  
%  und anschliessende Filterung (F). 
%
%  Prinzipiell lassen sich fr die Interpolation dieselben Filter verwenden wie bei 
%  der Dezimation. Es sind jedoch zwei Punkte zu bedenken:
%
%  (1)  Das Interpolationsfilter wird mit der Abtastrate seines Ausgangssignals gerechnet.  
%        Diese ist  {\fontname{Courier}k} mal so hoch wie bei dem entsprechenden Dezimationsfilter. 
%        Der Rechenaufwand der Interpolation ist dann  {\fontname{Courier}k} mal so gross wie bei
%        der Dezimation.  Werden Halbbandinterpolationsfilter benutzt, so sind nur die 
%        zwischen den Originalwerten liegenden  {\fontname{Courier}k - 1}  Abtastungen zu berechnen. 
%        Dann ist der Aufwand nur {\fontname{Courier}(k - 1)} mal so hoch wie bei der Dezimation.
%
%  (2)  Bei der Dezimation sollen die Dezimationfilter verhindern, dass nicht im 
%        Durchlassbereich des Gesamtfilters liegende evtl. sehr starke Signale 
%        in diesen Durchlassbereich hineingespiegelt werden.  Die Sperrdmpfung 
%        muss entsprechend gross sein.  Bei der Interpolation in einem Multiratenfilter
%        liefert das Kernfilter aber nur noch das Nutzsignal.  Das Interpolationsfilter 
%        soll Spiegel dieses Nutzsignals dmpfen, also Signale, deren Amplitude 
%        proportional zum Nutzsignal ist.  Das ist hufig weit weniger strend als 
%        ein Fremdsignal, das auch dann auftaucht, wenn kein Nutzsignal vorhanden ist.
%
%  Wegen Punkt (1) wird man versuchen, die Interpolationsfilter so einfach wie 
%  mglich und als Halbbandfilter zu realisieren.  Punkt (2) liefert hufig ein 
%  Argument fr deutlich geringere Anforderungen an die Sperrdmpfung der 
%  Interpolationsfilter.
%
%  Die schon im vorangegangenen Abschnitt besprochene Funktion  {\fontname{Courier}mrdesign} zum
%  Entwurf von Multiraten-Tiefpassfiltern lsst auch den Entwurf von angepassten 
%  Interpolationsfiltern zu.  Nachfolgend ein Beispiel, in dem der Rechenaufwand 
%  fr die Interpolationsfilter stark reduziert ist durch eine Sperrdmpfung von 
%  40 dB anstelle der von 80 dB fr alle anderen Filter:
%
mrdesign(0.07,0.01,1,80,40);
%

