%
%
%13.4  Multiratenbandpassfilter%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-4,'Color',MSVTITLCOLOR>
%
%
%
%  Multiratenbandpassfilter sind bei reeller Verarbeitung nur sinnvoll fr die 
%  Mittenfrequenz  {\fontname{Courier}0.5} .  In diesem Fall handelt es sich nur um  {\fontname{Courier}\pi/2}  im 
%  Frequenzbereich rotierte Filter.  Deshalb sind hier ebenfalls Halbbandfilter mglich.
%
%  Wir diskutieren die Situation an folgendem Beispiel:
%
%  Dezimationsfaktor:              k = 5                             %<'FontName',MSVFORMFONT>
%  Anzahl der Stufen:              s = 3  (Gesamtdezimation  1/125)  %<'FontName',MSVFORMFONT>
%  Welligkeit im Durchlassbereich: 0.002 dB                          %<'FontName',MSVFORMFONT>
%  Sperrdmpfung:                    100 dB                          %<'FontName',MSVFORMFONT>
%  Durchlassbereich:               0.4984 ... 0.5016                 %<'FontName',MSVFORMFONT>
%  Sperrbereiche:                  0 ... 0.4976,  0.5024 ... 1       %<'FontName',MSVFORMFONT>
%
%  Das Dezimationsfilter soll den Durchlassbereich mit gegebener Welligkeit 
%  realisieren und alle Spiegel davon mit  {\fontname{Courier}-100 dB}  sperren.  
%  Die Spezifikation des ersten Dezimationsfilters ist entsprechend:
%
r1 = 0.0016;
q1 = 0.0024;
filspezgraph([0.5-r1,0.5+r1],[0.1-q1,0.1+q1;0.3-q1,0.3+q1;0.7-q1,0.7+q1;0.9-q1,0.9+q1],1.0,-100)
text(0.32,-110,'Spezifikation fr Dezimationsfilter 1','FontSize',13,'Color','k')
%
%  Frhere MATLAB-Versionen des REMEZ-Algorithmus versagten bei so schmalen 
%  Bereichen.  Ab MATLAB 5.3 gibt es keine numerischen Probleme:
%  
seg1 = [0.1-q1,0.1+q1,0.3-q1,0.3+q1,0.5-r1,0.5+r1,0.7-q1,0.7+q1,0.9-q1,0.9+q1];
amp1 = [   0      0      0      0      1      1      0      0      0      0  ];
gew1 = [       1             1            0.1            1             1     ];
b1 = remez(24,seg1,amp1,gew1);
filspezgraph([0.5-r1,0.5+r1],[0.1-q1,0.1+q1;0.3-q1,0.3+q1;0.7-q1,0.7+q1;0.9-q1,0.9+q1],1.0,-100,b1)
set(gcf,'name','D-'); setfigpos(2,1,1,1)
h3 = fullscreen('S-'); setfigpos(2,1,2,1);
filterplot(b1,0.1-2*q1,0.1+2*q1,0,-120,-80)
%
%  Die Spezifikation wird noch nicht erfllt.  Anstatt den Filtergrad zu vergrssern 
%  wollen wir eine andere Methode anwenden: 
%  Bei sehr schmalen Sperrbereichen liegt es nahe, die Nullstellen manuell zu setzen. 
%  Entsprechend dem Vorgehen im Abschnitt 6.4c setzen wir in jeden Sperrbereich drei 
%  Nullstellen:  eine in die Mitte und je eine genau an die Grenze:
%  
ns = [0.1-q1,0.1,0.1+q1,0.3-q1,0.3,0.3+q1,0.7-q1,0.7,0.7+q1,0.9-q1,0.9,0.9+q1]';
ns = [ns;-ns];
[b1,a1] = z2koef(ns); 
h41= fullscreen('Nullstellen'); setfigpos(2,2,2,1);
zplane(b1,a1); axis(1.1*[-1 1 -1 1]); axis square
filspezgraph([0.5-r1,0.5+r1],[0.1-q1,0.1+q1;0.3-q1,0.3+q1;0.7-q1,0.7+q1;0.9-q1,0.9+q1],1.0,-100,b1);
setfigpos(2,1,1,1)
text(0.28,-110,'Filter 1: Spezifikation im Sperrbereich erfllt','FontSize',13)
h42 = fullscreen('Durchlassbereich'); setfigpos(2,2,2,2); filterplot(b1,0.5-r1,0.5+r1,0,-0.003,0.001)
text(0.4982,-0.00275,'Filter 1: Spezifikation im Durchlassbereich erfllt','FontSize',13)
%
%  Das Ergebnis ist offensichtlich bei gleicher Anzahl von Filterkoeffizienten
%  wesentlich besser als das mit REMEZ automatisch berechnete.
%
%  Fr die beiden folgenden Filter gilt:
%
%      r2 = 0.008    q2 = 0.012                         %<'FontName',MSVFORMFONT>
%      r3 = 0.040    q3 = 0.060                         %<'FontName',MSVFORMFONT>
%
%  Die Entwrfe der beiden folgenden Dezimationsfilter knnen nun gut mit {\fontname{Courier}remez} 
%  durchgefhrt werden.  Hier ist jeweils schon der richtige Filtergrad eingesetzt.
%  Nach den Dezimationsfiltern muss ein Kernfilter die eigentliche Filterung 
%  vornehmen.  Auch dieses ist hier als Filter 4 mit  {\fontname{Courier}remez}  entworfen:
%
r2 = 0.008; q2 = 0.012;
r3 = 0.040; q3 = 0.060;
seg2 = [0.1-q2,0.1+q2,0.3-q2,0.3+q2,0.5-r2,0.5+r2,0.7-q2,0.7+q2,0.9-q2,0.9+q2];
amp2 = [   0      0      0      0      1      1      0      0      0      0  ];
gew2 = [       1             1            0.01           1             1     ];
b2 = remez(36,seg2,amp2,gew2);
seg3 = [0.1-q3,0.1+q3,0.3-q3,0.3+q3,0.5-r3,0.5+r3,0.7-q3,0.7+q3,0.9-q3,0.9+q3];
amp3 = [   0      0      0      0      1      1      0      0      0      0  ];
gew3 = [       1             1            0.01           1             1     ];
b3 = remez(96,seg3,amp3,gew3);
b4 = remez(92,[0,0.2,0.3,0.7,0.8,1],[0,0,1,1,0,0],[1,0.01,1]);
h6 = fullscreen('Spez'); setfigpos(2,1,1,1);
filterplot({b1;b2;b3;b4},0,1,0,-120,10,[1,5,25,125],24,1)
text(0.25,-30,'Filterkaskade','FontSize',13,'Color','k')
h7 = fullscreen('Durchlass'); setfigpos(2,1,2,1);
filterplot({b1;b2;b3;b4},0.495,0.505,0,-110,10,[1,5,25,125],24,1)
%
%  Wir prfen noch die Welligkeit im Durchlassbereich:
%
if any(findobj('type','figure')==h7) figure(h7); setfigpos(2,2,2,1); end
h8 = fullscreen('Welligkeit'); if any(findobj('type','figure')==h7) setfigpos(2,2,2,2); end
filterplot({b1;b2;b3;b4},0.498,0.502,0,-0.02,0.02,[1,5,25,125],24,1)
text(0.4991,-0.0125,'die Verstrkung ist um 0.005 dB zu gross','FontSize',13,'Color','r')
%
%  Die Verstrkung des Gesamtfilters ist um  {\fontname{Courier}0.005 dB}  zu gross. 
%  Multiplikation der Filterkoeffizienten mit  {\fontname{Courier}10^{-0.005/20} = 0.9994} 
%  liefert zulssige Welligkeit:
%
b2 = 0.9994*b2;
h9 = fullscreen('Durchlass'); if any(findobj('type','figure')==h7) setfigpos(2,2,2,2); end
filterplot({b1;b2;b3;b4},0.498,0.502,0,-0.02,0.02,[1,5,25,125],24,1)
text(0.4993,-0.0125,'Spezifikation im Durchlass erfllt','FontSize',13,'Color','k')
%
%  Alle Filter sind Halbbandfilter: 
%
% Filter  Berechnungsfrequenz  Anzahl nicht verschwindender Koeffizienten %<'FontName',MSVFORMFONT>
%    1           1/5                             13                       %<'FontName',MSVFORMFONT>
%    2           1/25                            19                       %<'FontName',MSVFORMFONT>
%    3           1/125                           49                       %<'FontName',MSVFORMFONT>
%    4           1/125                           47                       %<'FontName',MSVFORMFONT>
%
%  Der Rechenaufwand fr das Gesamtfilter ergibt daraus sich zu
%
% 13/5 + 19/25 + 49/125 + 47/125 = 2.6 + 0.76 + 0.392 + 0.376 = 4.128     %<'FontName',MSVFORMFONT>
%
%  Dieses Ergebnis von nur  {\fontname{Courier}4.128}  Multipliziere/Akkumuliere-Befehlen pro Input-
%  Abtastschritt fr ein steilflankiges Schmalbandfilter mit usserst geringer
%  Durchlasswelligkeit zeigt die Leistungsfhigkeit des Multiratenkonzepts.
%  Offensichtlich kostet das erste Dezimationsfilter am meisten.  Weitere 
%  Dezimationen gibt es danach fast umsonst, ebenso das Kernfilter, welches 
%  wesentlich die Eigenschaften des Gesamtfilters bestimmt.  Wenn man es also 
%  schafft, eine oder zwei Dezimationen zu realisieren, dann ist jedes qualitativ 
%  hochwertige Schmalbandfilter fast ohne Zusatzaufwand mglich.
%
%  Einen einfachen automatischen Entwurf fr Multiratenbandpassfilter, die 
%  in allen Stufen dasselbe Dezimationsfilter benutzen, nimmt  {\fontname{Courier}mrdemo(g,k)}
%  vor.  Dabei ist  {\fontname{Courier}g}  der Grad des Dezimationsfilters und  {\fontname{Courier}k}  der Dezimationsfaktor.
%  {\fontname{Courier}g}  muss durch  {\fontname{Courier}4}  teilbar sein und  {\fontname{Courier}k}  ungerade.   {\fontname{Courier}mrdemo}  gibt die Koeffizienten 
%  des berechneten Dezimationsfilters zurck.  Bei nicht zu kleinem Filtergrad 
%  ist dies ein Halbbandfilter.  Hier zwei Beispiele:
%
mrdemo(12,3)
%
mrdemo(24,5)
%
%  Bessere Multiraten-Bandpassfilter liefert die Funktion  {\fontname{Courier}mrbpdesign} :
%
help mrbpdesign
%
%  Hier einige Beispiele:
%
mrbpdesign(0.01,0.002,1,80,0)         % beliebige Dezimationsfaktoren bis 7
%
mrbpdesign(0.01,0.002,1,80,0,[3 5])   % Dezimationsfaktoren 3 und 5
%
mrbpdesign(0.01,0.002,1,80,0,[3 3])   % Dezimation in Schritten von  1/3
%
mrbpdesign(0.01,0.002,1,80,0,[5 5])   % Dezimation in Schritten von  1/5
%
mrbpdesign(0.01,0.002,1,80,0,21)      % Gesamtdezimation auf  1/21  festgelegt
%
mrbpdesign(0.01,0.002,1,90,50)        % mit Interpolationsfiltern geringerer Sperrdmpfung
%
%  {\fontname{Courier}mrbpdesign}  verwendet fr die Dezimation und die Interpolation und auch 
%  fr das Kernfilter durchweg Halbbandfilter. Filter mit sehr schmaler 
%  Durchlassbreite lassen sich mit sehr geringem Rechenaufwand realisieren.  
%  In diesem Fall werden nmlich fr die ersten Dezimationen um den 
%  Dezimationsfaktor  {\fontname{Courier}k}  Halbbandfilter vom Grade  {\fontname{Courier}2*k-2}  verwendet, 
%  die nur  {\fontname{Courier}k}  von Null verschiedene Koeffizienten haben.  Tatschlich sind 
%  dies sehr einfache Kamm-Filter mit den Koeffizienten:
%
kcel = inputdlg('(ungerade Zahl)','Dezimationsfaktor');
k = eval(kcel{1});
b = nullein((ones(1,k).*(-1).^(0:k-1))/k,1)  % Koeffizienten im Kommandofenster
h = fullscreen('Kammfilter');
stem(b);  title('Kammfilterkoeffizienten','FontSize',15)
axis([0 2*k -2/k +2/k])
%
%  Bei  {\fontname{Courier}n}-facher Serienschaltung dieser Filter ergibt sich der Rechenaufwand  {\fontname{Courier}a}  
%  aus der geometrischen Reihe
%
%  a  =  1  +  1/k^1  +  1/k^2 + ... + 1/k^n  =  (1 - 1/k^n) / (1 - 1/k) %<'FontName',MSVFORMFONT>
%
%  Fr einen Gesamtdezimationsfaktor von ca. {\fontname{Courier}3000}  bentigt man fr  {\fontname{Courier}k = 3, 5, 7}
%  {\fontname{Courier}n = 7, 5, 4}   Dezimationsschritte und damit folgenden Rechenaufwand:
%
k = [3  5  7]
n = [7  5  4]
a = (1 - 1./k.^n) ./ (1 - 1./k)
%%  Resultat im Kommandofenster
%
%  Grssere Dezimationsschritte sind also vorteilhaft.  Dies besttigen die folgenden 
%  Versuche.  Im ersten Fall ist die Dezimation in Schritten von  {\fontname{Courier}1/3}  vorgeschrieben, 
%  im zweiten ist die Wahl frei:
%
%%  Die Rechnung ist rechenintensiv und dauert entsprechend.
%%  Die Graphik kann die schmalen Filter in der Gesamtdarstellung nicht mehr auflsen.
mrbpdesign(0.000016,0.000004,1,80,0,[3 3]); % schmales Filter mit geringem Rechenaufwand
%
mrbpdesign(0.000016,0.000004,1,80,0);       % schmales Filter mit sehr geringem Rechenaufwand
%
%  Das letzte Multiraten-Bandpassfilter bentigt weniger als  {\fontname{Courier}1.4}  Multiply-Accumulate-
%  Operationen pro Abtastschritt.  Dies wird erreicht durch die Dezimationsfolge 
%  {\fontname{Courier}1/7  1/5  1/5  1/5  1/5  1/3  1/3} .  Das Kernfilter wird also gerechnet bei der 
%  um den Faktor  {\fontname{Courier}1/39375}  reduzierten Abtastrate.  Die Verzgerung des Gesamtfilters 
%  betrgt  {\fontname{Courier}1683849}  Abtastschritte.
%
%  Schreibt man von vornherein durchweg grosse Dezimationsschritte vor, so fhrt 
%  das generell zu effizienten Filtern mit weniger Dezimationsstufen, aber meist 
%  aufwendigerem Kernfilter.  Die Verzgerung ist hufig geringer, was u.U. von 
%  Vorteil ist.  Die oben benutzte Spezifikation ergibt z.B. mit der Vorschrift, 
%  durchweg Dezimationsschritte von  {\fontname{Courier}1/7}  zu nehmen, ein Filter, dessen Verzgerung 
%  mit  {\fontname{Courier}825502}  bei der selben Effizienz nur halb so gross ist:
%
mrbpdesign(0.000016,0.000004,1,80,0,[7 7]); % schmales Filter mit geringem Rechenaufwand
%
%  Wegen der Effizienz grsserer Dezimationsschritte werden in  {\fontname{Courier}mrbpdesign} 
%  im Falle beliebiger Dezimationsschritte die grsseren Schritte zuerst ausgefhrt.
%