%
%
%13.7  Vermessung von Multiratenfiltern %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Amplituden- und Phasenfrequenzgang gengen als vollstndige Angabe des 
%  Verhaltens fr ein lineares Filter.  Das gilt jedoch nicht fr ein Multiratenfilter.  
%  Insbesondere mchte man fr eine Multiratenfilterkaskade nicht nur den 
%  Frequenzgang kennen, sondern auch eine Angabe ber die Unterdrckung der 
%  Aliassignale haben.  Der beste Weg ist, das Filter mit Sinussignalen in feinem 
%  Frequenzraster zu vermessen, d. h. fr jede Inputfrequenz das Spektrum des 
%  Ausgabesignals zu bestimmen.  Die Funktion  {\fontname{Courier}freqscan}  tut dies und stellt das 
%  Ergebnis als 3D-Graphik dar:   ber jeder Inputfrequenz (x-Achse) das Spektrum 
%  der Ausgabe (y-Achse ist Outputfrequenz,  z-Achse ist Spektralamplitude).  
%  Mchte man nur wissen, ob die Spezifikation bezglich der Unterdrckung der 
%  Aliassignale erfllt wird, so gengt ein Blick auf die 3D-Graphik lngs der 
%  Geraden  {\fontname{Courier}y = x} .  Dadurch wird der Amplitudenfrequenzgang auf eine vertikale 
%  Linie projiziert.  Alle Aliassignale erscheinen jedoch rechts und links davon, 
%  weil ihre Frequenzen von der Inputfrequenz abweichen.  Die Beschriftung der Achsen 
%  ist bei dieser Blickrichtung allerdings verwirrend, da zwei Achsen bereinander 
%  liegen.
%
%  Wir betrachten zunchst als einfaches Beispiel einen Multiratentiefpass:
%
[koef,srate,dly] = mrdesign(0.05,0.03,1,80,150); % Entwurf eines Multiratenfilters
freqscan('mrfilter(p{1},p{2},x)',{koef;srate},2*dly);
%
%%  Der Blick kann durch die Maus und die Tasten   t,  d,  s,  f  und  a   verndert werden.
%%  Tippen Sie bei selektiertem Bild  "t" ,  so erscheint der Blick auf das Aliasdiagramm von oben.
%
%  Im ersten Beispiel wurde absichtlich der ungewhnliche Fall mit 
%  wesentlich besserer Aliasdmpfung bei den Interpolationsfiltern 
%  genber den Dezimationsfiltern betrachtet, um praktisch nur die 
%  Aliassignale der Dezimationsfilter sichtbar zu machen.  Bei den beiden 
%  folgenden Beispielen ist die Aliasdmpfung der Interpolationsfilter 
%  gleich bzw. kleiner im Vergleich zur Aliasdmpfung der Dezimationsfilter.
%
[koef,srate,dly] = mrdesign(0.05,0.03,1,80,80); % Entwurf eines Multiratenfilters
freqscan('mrfilter(p{1},p{2},x)',{koef;srate},2*dly);
%
[koef,srate,dly] = mrdesign(0.05,0.03,1,80,40); % Entwurf eines Multiratenfilters
freqscan('mrfilter(p{1},p{2},x)',{koef;srate},2*dly);
%
%  Die drei Bilder zeigen im Vergleich die Wirkung der Interpolationsfilter.
%
%  Ein Beispiel fr ein Multiratenbandpassfilter ist das folgende:
%  
[koef,srate,dly]=mrbpdesign(0.05,0.01,1,120,120);
freqscan('mrfilter(p{1},p{2},x)',{koef;srate},2*dly);
%
%% Tippen Sie zunchst  "t"  fr den Blick auf das Aliasdiagramm.
%
%  In der Mitte des Bildes liegt der Durchlassbereich des Filters (rot).
%  In der Breite des Durchlasses ist ein senkrechter Balken (hellblau) 
%  zu sehen.  Dieser Balken liegt auf ca. -150 dB.  Er ist ein Artefakt 
%  der FFT mit dem Kaiserfenster, deren Artefaktunterdrckung defaultmssig 
%  auf  -150 dB  eingestellt ist.  Unter entsprechendem Verlust an Auflsung 
%  im Frequenzbereich ndern wir dies auf  -200 dB :
% 
freqscan('mrfilter(p{1},p{2},x)',{koef;srate},2*dly,0,1,200);
set(gca,'View',[0 90])
%
%  Die Absenkung des artefiziellen Balkens um weitere 50 dB ist deutlich.
%  Der Balken bleibt jedoch klar zu erkennen, gibt jedoch jetzt zwei 
%  Alias frei.
%
%  Ist die Aliasdmpfung der Interpolationsfilter gering, so werden Alias 
%  erzeugt fr Signale, die das Filter regulr passieren.  Diese verzerren 
%  das durchgehende Signal, sind aber nicht harmonisch wie Obertne, die durch 
%  Nichtlinearitt entstehen.  Alias von Interpolationsfiltern sind fr eine 
%  gegebene Inputfrequenz im Ausgabespektrum zu sehen, im Aliasdiagramm also 
%  vertikal:
%
[koef,srate,dly]=mrbpdesign(0.05,0.01,1,120,60);
freqscan('mrfilter(p{1},p{2},x)',{koef;srate},2*dly,0,1,200);
set(gca,'View',[0 90])
%
%  Die im allgemeinen mehr strenden Alias der Dezimationsfilter liegen dagegen 
%  im Aliasdiagramm horizontal.  Es gibt also Inputfrequenzen ausserhalb des
%  spezifizierten Durchlassgebietes, fr die das Ausgangssignal im Durchlass-
%  bereich liegt.  Diese sind im nachhinein nicht mehr von direkten Signalen 
%  zu trennen:
%
[koef,srate,dly]=mrbpdesign(0.05,0.02,1,100,120);
freqscan('mrfilter(p{1},p{2},x)',{koef;srate},2*dly,0,1,200);
set(gca,'View',[0 90])
%
%%  Betrachten Sie die Bilder auch aus anderen Blickrichtungen!
%