%
%
%14.2 Kompression im Zeitbereich%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-8,'Color',MSVTITLCOLOR>
%
%
%
% Bei Sprachsignalen wird hufig eine Dynamik-Kompression gewnscht.  
% Lautstrkeunterschiede sollen dabei abgeschwcht werden, ohne die Sprache zu 
% beeintrchtigen.  Im Zeitbereich kann man dies erreichen, indem die Lautstrke 
% detektiert und zur Steuerung der Amplitude verwendet wird.  Das Prinzip zeigt 
% folgendes Bild:
%
dyngraph
%
% Die Detektion der Amplitude kann auf verschiedene Weise erfolgen.  Mglich sind 
% z.B. Effektivwertdetektoren und Spitzenwertdetektoren.  In beiden Fllen ist 
% zeitliche Lokalitt gewnscht.  Den Effektivwert wird man also in einem gleitenden 
% Fenster bestimmen oder mit einem Exponentialgedchtnis versehen, was einem 
% IIR-Filter ersten Grades entspricht.  Im letzteren Fall berechnet sich der 
% jeweilige momentane Effektivwert  {\fontname{Courier}a_{rms}}  zum  {\fontname{Courier}k-}ten Abtastzeitpunkt nach
%
% a_{rms}(k) = (1 - v) a_{rms}(k-1) + v x(k)^2        %<'FontName',MSVFORMFONT>
%
% Hierin ist  {\fontname{Courier}v}  wie im Abschnitt 7.2 die Grenzfrequenz des IIR-Tiefpasses.
%
% Im Falle der Spitzenwertdetektion werden die Koeffizienten des IIR-Filters 
% meist geringfgig modifiziert:
%
% a_{peak}(k) = u a_{peak}(k-1) + v abs(x(k)) , %<'FontName',MSVFORMFONT>
%
% wo   u = 1 - v - r                %<'FontName',MSVFORMFONT>
%
% {\fontname{Courier}r}  heisst Release Time,   {\fontname{Courier}v}  heisst Attack Time.
%
% 
% Dieser Abschnitt ist noch nicht fertig ! %<'FontSize',18,'Color','g'>
%
%
% Es folgt eine Demonstration der Sprachkompression mit der Funktion  {\fontname{Courier}audiokomp} .
% In  {\fontname{Courier}audiokomp}  wird zwischen die detektierte Amplitude und das Tiefpassfilter 
% ein Tabellennachschlag eingeschoben.  Die Tabelle kann als erster Parameter von  
% {\fontname{Courier}audiokomp}  angegeben werden:
%
help audiokomp
%
audiokomp;
%
load 'oberseminar';
audiokomp(raisedcosine([1,5],50),0.6,x',200,3000);
%
% Das Sprachsignal wird durch die Kompression hrbar lauter bei gleichbleibendem 
% Maximalausschlag.
%
% Die Funktion  {\fontname{Courier}audiokomp2}  versucht zustzlich durch dynamische 
% fequenzabhngige Drehung der Phase die Amplitude zu minimieren.  Dies verndert 
% den Signalverlauf erheblich.  Da da menschliche Gehr aber unempfindlich bezglich 
% der Phase ist, bleibt dies unhrbar.
%
% Hier ein Versuch mit anderer Tabelle als oben:
%
load 'oberseminar';
audiokomp2([ones(1,4) 1+(0:6)/2],0.8,x',300,2400);
%