%
%
%14.3  Rauschunterdrckung im Frequenzbereich%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-17,'Color',MSVTITLCOLOR>
%
%
%
% Die Fouriertransformierte eines weissen Rauschens ist ebenfalls ein weisses Rauschen, 
% allerdings komplex.  Das Spektrum von Signalen wie Sprache und Musik besteht 
% dagegen hufig aus diskreten Frequenzen oder engen Frequenzbereichen, die sich 
% im Spektrum vom Rauschen besser abheben als im Zeitbereich.  Deshalb liegt es 
% nahe, zur Rauschunterdrckung ein Signal durch FFT in den Frequenzbereich zu 
% transformieren, dort fr alle Abtastwerte der Fouriertransformierten eine 
% Schwellwertentscheidung zu treffen und anschliessend zurck zu transformieren. 
% Die Funktion  {\fontname{Courier}denoise}  demonstriert dies graphisch an einem verrauschten 
% Dreitonsignal.  Die Funktion  {\fontname{Courier}audiodenoise(Schwellwert,Signal)}  macht den 
% Effekt hrbar, und zwar zunchst verrauscht, dann das Resultat des Verfahrens.
% 
denoise
%
audiodenoise(2);
%
audiodenoise(3);
%
audiodenoise(5);
%
% Natrliche Sprache hat ein komplizierteres Spektrum.  Deshalb nimmt die einfache 
% Schwellwertentscheidung zu viel von der Sprache selbst weg:
%
load 'oberseminar.mat';
audiodenoise(2,x'+0.05*randn(1,length(x)));
%
% Bei dieser Demonstration wurde jeweils nur eine FFT und iFFT gerechnet. 
% Um diese Rauschunterdrckung kontinuierlich durchzufhren muss das Signal 
% segmentiert werden in Stcke der gewnschten FFT-Lnge.
%
% Im Falle natrlicher Sprache ist das adaptive Fhren individueller Schwellen 
% fr alle Frequenzpunkte wesentlich besser, was hier aber nicht vorgefhrt wird.
% (Das DSP-Programm  FFT_CUT von Pawel Jalocha tut genau dies).  %<'Interpreter','none'>
%