%
%
%
%  3.4  Verschiebungssatz%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>%
%
%
%
%  Gegeben sei das Signal  {\fontname{Courier}x(t).  y(t)} sei gegen  {\fontname{Courier}x(t)} um die Zeit \tau verschoben:
%  y(t) = x(t - \tau)  %<'FontName',MSVFORMFONT>
%
%  Die Fouriertransformierten von  {\fontname{Courier}x}  und  {\fontname{Courier}y}  sind dann
%  {\fontname{Symbol}                  }
%  X(\omega) = _{\fontsize{24}\int} x(t) e^{-i\omegat} dt  %<'FontName',MSVFORMFONT>
%  \fontname{Symbol}                {-}
%  {\fontname{Symbol}                  }
%  Y(\omega) = _{\fontsize{24}\int} x(t - \tau) e^{-i\omegat} dt  %<'FontName',MSVFORMFONT>
%  \fontname{Symbol}                {-}
%  Setzt man  {\fontname{Courier}u = t - \tau} ,  so folgt
%  {\fontname{Symbol}                  }
%  Y(\omega) = _{\fontsize{24}\int} x(u) e^{-i\omega(u + \tau)} du  %<'FontName',MSVFORMFONT>
%  \fontname{Symbol}                {-}
%  und nach Ausklammerung
%  {\fontname{Symbol}                              }
%  Y(\omega) = e^{-i\omega\tau}_{\fontsize{24}  \int} x(u) e^{-i\omegau} du  %<'FontName',MSVFORMFONT>
%  \fontname{Symbol}                           {-}
%  also:
%  \bfY(\omega) = e^{-i\omega\tau} X(\omega)  %<'FontName',MSVFORMFONT>
%
%  Entsprechendes lsst sich fr die inverse Fouriertransformation
%  herleiten:
%  Gegeben sei  {\fontname{Courier}X(\omega).  Y(\omega)} sei gegen  {\fontname{Courier}X(\omega)} um \rho verschoben:
%  Y(\omega) = X(\omega - \rho)  %<'FontName',MSVFORMFONT>
%
%  Dann gilt:
%  y(t) = e^{i\rhot} x(t)    %<'FontName',MSVFORMFONT>
%
%
%  Beispiel:
%
%  Gegeben ist ein Rechteckpuls. Dessen Fouriertransformierte wird
%  mit fourierplot berechnet und gezeichnet:
%
syms t f; 
fourierplot('-Heaviside(t-0.5)+Heaviside(t+0.5)',t,f,[-6,6],[-50,50])
a = get(findobj('Name','Funktion'),'children');
if iscell(a) for k=1:length(a)  set(a{k},'ylim',[-0.5,1.5]);  end; end
if length(a)==1  set(a,'ylim',[-0.5,1.5]);  end; 
%
%  Dieser Rechteckpuls wird in der Zeit verschoben um 5 Einheiten. 
%  Das bewirkt im Frequenzbereich eine Multiplikation mit dem 
%  Faktor   {\fontname{Courier}e^{-i5\omega}}.
%
%%  Klicken Sie zwischen den beiden Zeitbereichen hin und her!
%%  Drehen Sie die Frequenzbereiche auf die 2D-Sicht "Imaginrteil 
%%  ber \omega".
%
syms t f; 
fourierplot('-Heaviside(t-5.5)+Heaviside(t-4.5)',t,f,[-6,6],[-50,50])
a = get(findobj('Name','Funktion'),'children');
if iscell(a) for k=1:length(a)  set(a{k},'ylim',[-0.5,1.5]);  end; end
if length(a)==1  set(a,'ylim',[-0.5,1.5]);  end; 
%
%  Die Verschiebung im Frequenzbereich durch Multiplikation im 
%  Zeitbereich hat grosse praktische Bedeutung in der Nachrichten-
%  technik (sog. Super-Prinzip zur Frequenzumsetzung).

