%
%  4.4  Z-Transformation%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Gegeben sei ein abgetastetes Signal im Zeitbereich beginnend mit dem Signalwert  {\fontname{Courier}x_0} :
%
%  x_0,  x_1,  x_2, ... ,  x_n, ...          %<'FontName',MSVFORMFONT>
%
%  Dann heisst folgende Funktion der komplexen Variablen  {\fontname{Courier}z}  die  Z-Transformierte 
%  des Signals  {\fontname{Courier}x} :
%         {\fontname{Symbol}}               %<'FontName',MSVFORMFONT>
%  X(z) = _{\fontsize{26}\Sigma} x_n z^{-n}  %<'FontName',MSVFORMFONT>
%         n={\fontname{Symbol}0}             %<'FontName',MSVFORMFONT>
%
%  {\fontname{Courier}X(z)}  ist natrlich nur fr die {\fontname{Courier}z} definiert, an denen die Summe konvergiert.  
%  Die Z-Transformierte enthlt wegen der Summe ber  {\fontname{Courier}n}  den Index  {\fontname{Courier}n}  nicht mehr. 
%
%  Die Z-Transformation ist:
%
%  (a)  linear,
%       d.h. sind  {\fontname{Courier}X}  und  {\fontname{Courier}Y} die Z-Transformierten von  {\fontname{Courier}x}  und  {\fontname{Courier}y} , so ist 
%       die Z-Transformierte von   {\fontname{Courier}a\cdotx + b\cdoty}   gegeben durch   {\fontname{Courier}a\cdotX + b\cdotY}
%
%  (b)  eindeutig,
%       d.h. zu jedem  {\fontname{Courier}x}  gibt es hchstens eine Z-Transformierte
%
%  Es gilt fr  {\fontname{Courier}k > 0}  der Verschiebungssatz
%
%      X(x_{n-k}) = z^{-k} \cdot X(z)        %<'FontName',MSVFORMFONT>
%                               k-1          %<'FontName',MSVFORMFONT>
%      X(x_{n+k}) = z^k \cdot X(z) - z^k \cdot _{\fontsize{26}\Sigma} x_n z^{-n}  %<'FontName',MSVFORMFONT>
%                               n=0          %<'FontName',MSVFORMFONT>
%
%  Der letzte Term bercksichtigt, dass in diesem Fall das Signal nach links ber die Null 
%  hinaus geschoben wurde. Diese Signalwerte drfen nach der Definition aber nicht in die 
%  Transformation eingehen.
%
%  Es gilt der Faltungssatz:
%
%  {\fontname{Courier}a_n}  und  {\fontname{Courier}b_n}  seien abgetastete Signale und  {\fontname{Courier}A(z)}  und  {\fontname{Courier}B(z)} deren
%  Z-Transformierte.  Dann ist die Z-Transformierte der Faltung von  {\fontname{Courier}a}  und  {\fontname{Courier}b}  im 
%  Zeitbereich gegeben durch das Produkt der Z-Transformierten   {\fontname{Courier}A(z)\cdotB(z)} :
%        n              n                    %<'FontName',MSVFORMFONT>
%  f_n = _{\fontsize{26}\Sigma} a_k b_{n-k}  =  _{\fontsize{26}\Sigma} a_{n-k} b_k %<'FontName',MSVFORMFONT>
%       k=0            k=0                   %<'FontName',MSVFORMFONT>
%
%  F(z) = A(z) \cdot B(z)                    %<'FontName',MSVFORMFONT>
%
%  Gegeben sei nun ein abgetastetes endliches Signal  {\fontname{Courier}x(n)  (0 <= n <= k)}
%  und seine Z-Transformierte   {\fontname{Courier}X(z)}.
%  Wir betrachten nun speziell die Z-Transformierte auf dem Einheitskreis:
%  z = e^{i\omega}                           %<'FontName',MSVFORMFONT> 
%
%  also
%           k-1                              %<'FontName',MSVFORMFONT>
%  X(e^{i\omega}) = _{\fontsize{26}\Sigma} x_n e^{-i\omegan}  %<'FontName',MSVFORMFONT>
%           n=0                              %<'FontName',MSVFORMFONT>
%
%  Diskretisiert man nun noch den Einheitskreis in  {\fontname{Courier}k}  Punkten  {\fontname{Courier}\omega_m = 2\pim/k},
%  so folgt:
%                   k-1 %<'FontName',MSVFORMFONT>
%  X_m = X(e^{i2\pim/k}) = _{\fontsize{26}\Sigma} x_n e^{-i2\pinm/k} %<'FontName',MSVFORMFONT>
%                   n=0 %<'FontName',MSVFORMFONT>
%
%  Das ist aber gerade die diskrete Fouriertransformierte des Signals  {\fontname{Courier}x_n} .
%
%  Die diskretete Fouriertransformierte ist in der Z-Transformierten enthalten.
%  Sie ist gegeben durch  {\fontname{Courier}k}  quidistante Sttzstellen der Z-Transformierten auf
%  dem Einheitskreis.
%
%  Ein Beispiel: 
%  Zwei Sinus mit  {\fontname{Courier}8 Hz}  bzw.  {\fontname{Courier}28 Hz}  mit Hammingfenster als Pulsform mit  
%  {\fontname{Courier}f_s = 128 Hz}  eine Sekunde abgetastet. Gezeigt wird die Z-Transformierte als 3D-Bild. 
%  Die Z-Transformierte ist eine komplexe Funktion. Abgebildet ist hier ber der z-Ebene  
%  {\fontname{Courier}log(abs(...))}.
%
%%  Das rechnet eine Weile:
n=128; t=(0:n-1)/n; 
numztrans(hamming(n)'.*(sin(2*pi*28*t)+sin(2*pi*8*t)));
%%  Das Bild kann mit der Maus gedreht werden.
%
%  Ein weiteres Beispiel:
%  Derselbe Fall wie oben, jedoch die eine Sinusfrequenz mit  {\fontname{Courier}60 Hz}  sehr nahe 
%  an der Nyquistfrequenz.
%
%%  Das rechnet eine Weile:
n=128; t=(0:n-1)/n; 
numztrans(hamming(n)'.*(sin(2*pi*60*t)+sin(2*pi*8*t)));
%%  Das Bild kann mit der Maus gedreht werden.
%
%
%%  bung 4.4:   Rufen Sie mehrfach  {\fontname{Courier}numztrans}  auf mit einem zuflligen Signal
%%
%%  {\fontname{Courier}randn(1,128)}   (oder auch {\fontname{Courier}randb(128)})
%%
%%  Betrachten Sie den generellen Verlauf und die Lage der Nullstellen.
%