%
%4.5  Digitalisierung%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Unter Digitalisierung verstehen wir die digitale Reprsentation der abgetasteten Werte 
%  in n-Bit-Wrtern.  Dies wird auch durch den letzten Parameter der MATLAB-Funktion  
%  {\fontname{Courier}fktabtast}  demonstriert.  In ihm wird angegeben, wieviele Bits fr eine Festkomma-
%  darstellung im 2-Komplement zur Verfgung stehen.  Nur der analoge Bereich  von  
%  {\fontname{Courier}-1...+1}  wird korrekt reprsentiert.  Signale ausserhalb dieses Bereiches werden 
%  abgeschnitten.
%
%  Beispiele:
%
fktabtast(5,10,'0.4*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',6);
pause
fktabtast(5,10,'0.4*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',5);
pause
fktabtast(5,10,'0.4*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',4);
pause
fktabtast(5,10,'0.4*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',3);
pause
fktabtast(5,10,'0.4*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',2);
pause
fktabtast(5,10,'0.4*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',1);
pause
%  Digitalisierung bei zu geringer Amplitude des Signals: 
%  
fktabtast(5,10,'0.1*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',1);
pause
fktabtast(5,10,'0.1*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',2);
pause
fktabtast(5,10,'0.1*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',3);
pause
fktabtast(5,10,'0.1*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',4);
pause
fktabtast(5,10,'0.1*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',5);
pause
fktabtast(5,10,'0.1*(cos(2*pi*0.7*t)+0.8*sin(2*pi*0.9*t))',6);
pause
%  Der durch die Digitalisierung verursachte Fehler wird als Digitalisierungsrauschen 
%  bezeichnet.  Die Eigenschaften dieses Rauschens sind aber komplizierter als bei 
%  natrlichem Rauschen.  Insbesondere ist es Signal-abhngig.  Die folgende bung zeigt, 
%  dass das Spektrum des Digitalisierungsrauschens Vielfache der Frequenz eines 
%  Sinussignals enthlt sowie auch deren Aliasfrequenzen.
%
%%  bung 4.5:   Die Funktion  {\fontname{Courier}fktabtast}  gibt sowohl den abgetasteten
%%  Vektor wie auch dessen Fehler zurck. Berechnen Sie diesen Fehler und dessen 
%%  Fouriertransformierte nach dem Schema
%%
%  [sample,fehler] = fktabtast(1,100,'Funktion',Bits);    %<'FontName',MSVFORMFONT>
%  diskretfourier(fehler);                                %<'FontName',MSVFORMFONT>
%%
%%  fr folgende Flle:
%              Funktion                 Bits            %<'FontName',MSVFORMFONT>
%              cos(2\pi1t)-0.5              1           %<'FontName',MSVFORMFONT>
%              cos(2\pi5t)-0.5              1           %<'FontName',MSVFORMFONT>
%              cos(2\pi10t)-0.5             1           %<'FontName',MSVFORMFONT>
%              cos(2\pi20t)-0.5             1           %<'FontName',MSVFORMFONT>
%              cos(2\pi1t)                  4           %<'FontName',MSVFORMFONT>
%              cos(2\pi1t)                  8           %<'FontName',MSVFORMFONT>
%              cos(2\pi10t)                 8           %<'FontName',MSVFORMFONT>
%              cos(2\pi10t)                16           %<'FontName',MSVFORMFONT>
%              cos(2\pi10t)                32           %<'FontName',MSVFORMFONT>
%              cos(2\pi12t)                32           %<'FontName',MSVFORMFONT>
%
%%  Man bezeichnet den Digitalisierungsfehler als Digitalisierungsrauschen. 
%%  Entspricht dieser Fehler einem weissen Rauschen ?
%