%
%
%  (a)  FIR-Filterentwurf durch Fouriertransformation mit Fenster%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-24,'Color',MSVTITLCOLOR>
%
%
%
%  Die Berechnung der Koeffizienten fr ein FIR-Filter ist im Prinzip einfach, denn der 
%  Koeffizientenvektor ist gleich der Impulsantwort und diese ist die Fouriertransformierte 
%  des Frequenzganges.  Allerdings gibt es bei der Transformation die schon behandelten 
%  Probleme der Fensterung.
%
%  Die MATLAB-Funktion  {\fontname{Courier}fedemo}  nimmt als Parameter einen String  {\fontname{Courier}fkt} , der den 
%  Betragsfrequenzgang festlegt.  Die freie Variable in dieser Funktion ist  {\fontname{Courier}0 < f < 1} , 
%  wo  {\fontname{Courier}f = 1}  die Abtastfrequenz bedeutet.  Der Berechnungskern von fedemo ist:
%  ff = (0:n-1)/n;                            % Frequenzbereich 0 bis Abtastfrequenz  %<'FontName',MSVFORMFONT>
%  f  = ff(1:n/2);                            % Frequenzbereich 0 bis Nyquistfrequenz %<'FontName',MSVFORMFONT>
%  w  = eval(fkt);                            % Frequenzgang 0 bis Nyquistfrequenz    %<'FontName',MSVFORMFONT>
%  wf = [w,w(n/2:-1:1)];                      % Frequenzgang 0 bis Abtastfrequenz     %<'FontName',MSVFORMFONT>
%  dftwf = ifft(wf);                          % IDFT davon                            %<'FontName',MSVFORMFONT>
%  b  = real([dftwf(n/2:-1:1),dftwf(2:n/2)]); % Impulsantwort                         %<'FontName',MSVFORMFONT>
%  bf = b.*hamming(n-1)';                     % Fensterung mit Hamming-Fenster        %<'FontName',MSVFORMFONT>
%
%%  Hervorhebung der Linien in folgenden Bildern mit den Tasten 1, 2, 3
%
fedemo(126,'round(f*10)/5');
%
fedemo(30,'4*f.^2');
%
fedemo(60,'f<0.15');
%
%  Bei Passfiltern gengt jedoch die Angabe der Grenze des Durchlassbereiches.
%  Die einfachste MATLAB-Standard-Funktion hierfr ist  {\fontname{Courier}fir1(Grad,Grenze)}.
%  {\fontname{Courier}Grad}  ist der Filtergrad.  Es gilt  {\fontname{Courier}Grad + 1 = Anzahl der Filterkoeffizienten}.
%  Es wird ein Tiefpass berechnet mit der oberen Grenze des Durchlasses bei
%  {\fontname{Courier}Grenze} (relativ zur Nyquistfrequenz).
%
%  Beispiel:  {\fontname{Courier}Grenze = 0.3 ;  Anzahl der Koeffizienten = 99  =>  Grad = 98}
%
figh = fullscreen('FIR1');
filterplot(fir1(98,0.3))
%
%
%%  bung 6.4a:  Es ist ein FIR-Filter zu berechnen, das dem durch  a(f) = min( 1, 0.1./f )  
%%  gegebenen Amplitudenfrequenzgang mglichst nahe kommt.   f ist hier relativ zur 
%%  Abtastfrequenz.
%%  Berechnen Sie das Filter fr folgende Filtergrade:  2, 4, 8, 16, 32, 64, 1000.
%%  Ist die Benutzung eines Fensters generell ntzlich?
%
