%
%
%(b)  Einsatz des Iterationsverfahrens REMEZ%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-16,'Color',MSVTITLCOLOR>
%
%
%
%  Um optimale Lsungen im Rahmen der Spezifikation zu erhalten, z.B. das Filter mit der 
%  kleinsten Zahl von Koeffizienten, welches die Spezifikation noch erfllt, wurden 
%  iterative Verfahren entwickelt. MATLAB bietet hierfr die Funktion  {\fontname{Courier}remez} :
%
help remez
%
%  Zur Ermittlung der minimalen Lsung dient  {\fontname{Courier}remezord} :
%
help remezord
%
%  Beispiel:
%  Spezifikation:  Hochpass 0.3 ... 1;  Welligkeit max. 1.5dB   = 0.19  %<'FontName',MSVFORMFONT>
%                  bergang 0.2 ... 0.3; Sperrdmpfung > 40 dB  = 0.01  %<'FontName',MSVFORMFONT>
%
h(1) = fullscreen('Frequenzgang'); 
h(2) = fullscreen('Durchlassbereich','w',0,[1.5 1.6; 1.5 1.6]); 
r = remezord([0.2,0.3],[0,1],[0.01,0.19],2,'cell');
figure(h(1)); filterplot(remez(r{:}))
figure(h(2)); filterplot(remez(r{:}),0.3,1,0,-2,2)
title('Durchlassbereich')
%
%
%%  bung 6.4b:  Es ist ein FIR-Filter zu entwerfen mit mit mglichst kleinem Grad nach 
%%  der durch folgende Abbildung gegebenen Spezifikation:
%
ofkt = '1.1*(f<=0.3)+0.01*(f>0.3).*(f<=0.5)+4*(f>0.5).*(f<=0.8)+1.1*(f>0.8)';
ufkt = '0.9*((f<=0.2)+(f>0.8))';
filspezfgraph(ofkt,ufkt,0,-60,20)
%
%%  Versuchen Sie den Weg ber   {\fontname{Courier}remezord}  und direkt mit  {\fontname{Courier}remez} .
%%  (g = 24 ist mglich)
%%  Weisen Sie die Filterkoeffizienten dem Vektor b zu und klicken Sie dann zur berprfung hier:
%
ofkt = '1.1*(f<=0.3)+0.01*(f>0.3).*(f<=0.5)+4*(f>0.5).*(f<=0.8)+1.1*(f>0.8)';
ufkt = '0.9*((f<=0.2)+(f>0.8))';
filspezfgraph(ofkt,ufkt,0,-60,20,b);
%

