%
%
%(d)  Spektrale Rotation%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Im Abschnitt  3.4  wurde der Verschiebungssatz hergeleitet:
%
%  Gegeben sei  {\fontname{Courier}X(\omega)}.  {\fontname{Courier}Y(\omega)}  sei gegen  {\fontname{Courier}X(\omega)} um  {\fontname{Courier}\rho}  verschoben:
%
%  y(t) = e^{i\rhot} x(t)    %<'FontName',MSVFORMFONT>
%
%  Stehen  {\fontname{Courier}x(t)}  fr die Impulsantwort eines Filters und  {\fontname{Courier}X(\omega)}  fr dessen Frequenzgang, 
%  so kann man offenbar den Frequenzgang um  {\fontname{Courier}\rho}  verschieben durch Multiplikation 
%  der Impulsantwort mit  {\fontname{Courier}e^{i\rhot}} .  Das ergibt allerdings nur dann durchweg reelle 
%  Koeffizienten, wenn  {\fontname{Courier}\rho = 0}  oder  {\fontname{Courier}\rho = \pi}  bzw. diese Werte sich abwechseln und
%  rein reelle und rein imaginre, wenn  {\fontname{Courier}\rho = pi/2}  oder  {\fontname{Courier}\rho = 3\pi/2} .
%
%  Die Funktion  {\fontname{Courier}specrot}  gibt ein Beispiel.
%%  Die Koeffizienten werden im Kommandofenster ausgegeben
%
specrot         % liefert komplexe Impulsantwort 
%
specrot(fir1(60,0.05),pi*(0:3)/2)
%
%  Ist  {\fontname{Courier}\rho = \pi} , so ergibt sich wieder ein reelles Filter.
%  Der Frequenzgang ist symmetrisch zum ursprnglichen:
%
specrot(fir1(60,0.2),pi)  % reelle Impulsantwort
%
%  Wegen  {\fontname{Courier}e^{i\pit} = +1 (-1)}  fr gerade (ungerade)  {\fontname{Courier}t}  ergibt sich die 
%  Impulsantwort des um  {\fontname{Courier}\pi}  rotierten Filters durch Vorzeichentausch bei jedem 
%  zweiten Koeffizienten (bei ungerader Anzahl von Koeffizienten und kausaler 
%  Zhlung von  {\fontname{Courier}1}  bis  {\fontname{Courier}g+1}  sind das die Koeffizienten mit geradem Index):
%
b1 = fir1(60,0.2);
b2 = real(specrot(b1,pi));
maxb = max([b1,b2])+0.05; minb = min([b1,b2])-0.05;
maxt = length(b1)+1;
h = fullscreen('Impulsantworten');
subplot(2,1,1); stem(b1); axis([0,maxt,minb,maxb])
title('Impulsantwort des ursprnglichen Filters','FontSize',13)
subplot(2,1,2); stem(b2); axis([0,maxt,minb,maxb])
title('Impulsantwort des um  \pi  rotierten Filters','FontSize',13)
pause
%
%%  bung 6.4d:  Berechnen Sie die Koeffizienten der Approximation des idealen Tiefpasses 
%%  fr die Grenzfrequenz 0.1 mit Filtergrad g = 60 unter Benutzung der Funktion  idealtpdemo.
%%
%%  Drehen Sie das Filter im Frequenzbereich um  \pi/2  mit  specrot.
%%  (1) Zu welchem Filtertyp gehrt das gedrehte Filter?
%%  (2) Stellen Sie die Impulsantworten dar:
%%      des Tiefpasses sowie Realteil und Imaginrteil des gedrehten Filters.
%