%
%
%(e)  Halbbandfilter%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Halbbandfilter sind Filter mit solcher Symmetrie, aus der folgt, dass jeder zweite 
%  Koeffizient Null ist.  Halbbandfilter bentigen also nur etwa halb so viele 
%  Multiplikationen und Additionen wie normale FIR-Filter.
%
%  Die gerade Symmetrie des Frequenzganges  {\fontname{Courier}S(\omega)}  zu  {\fontname{Courier}\omega = 0}  garantiert, dass die 
%  Impulsantwort reell ist.  Dann enthlt die inverse diskrete Fouriertransformation 
%  nur noch den reellen Cosinus-Term:
%       g/2      %<'FontName',MSVFORMFONT>
%  s_n = _{\fontsize{26}\Sigma}  S_k cos(2\pikn/(g+1))      %<'FontName',MSVFORMFONT>
%     k=-g/2      %<'FontName',MSVFORMFONT>
%
%  {\fontname{Courier}g}  ist hier der (gerade) Filtergrad.  Hat nun berdies  {\fontname{Courier}S(\omega)}  eine ungerade Symmetrie 
%  zu  {\fontname{Courier}\omega = 1/2}  ({\fontname{Courier}\omega = 1}  ist die Nyquistfrequenz), dann verschwindet obige Summe 
%  fr gerade  {\fontname{Courier}n}  ausser  {\fontname{Courier}n = 0} .  Es liegt dann also ein Halbbandfilter vor.
%
%  \bfBeispiel 1:
%
g = 18;                           % Filtergrad
b = fir1(g,1/2)                   % Tiefpass mit obiger Symmetrie
h1 = fullscreen('Impulsantwort des Halbbandfilters','w',0,[2 1; 1 1]);
stem(b)
h2 = fullscreen('Halbbandfilter','w',0,[2 1; 2 1]);
filterplot(b,-2,2,'lin',-0.1,1.1)
title('Halbbandfilter (zwei Perioden)','FontSize',13)
%
%  Hat dagegen  {\fontname{Courier}S(\omega)}  bei  {\fontname{Courier}\omega = 1/2}  eine gerade Symmetrie, so verschwindet die Summe 
%  fr alle ungeraden  {\fontname{Courier}n} .  Dies betrifft also zu  {\fontname{Courier}\omega = 1/2}  symmetrische Bandpass- und 
%  Sperrfilter.
%
%  \bfBeispiel 2:
%
g = 28;                           % Filtergrad
b = remez(g,[0,0.3,0.4,0.6,0.7,1],[0,0,1,1,0,0]) % Bandpass               
h3 = fullscreen('Impulsantwort des Halbbandfilters','w',0,[2 1; 1 1]);
stem(b)
h4 = fullscreen('Halbband-Bandpass','w',0,[2 1; 2 1]);
filterplot(b,-2,2,'lin',-0.1,1.1)
title('Bandpass','FontSize',13)
%
%  Eine Methode, um aus einem Tiefpass mit der Grenzfrequenz {\fontname{Courier}> 0.5}  ein 
%  Halbbandbandfilter zu erzeugen, ist in  {\fontname{Courier}halbbf}  realisiert:
%  Aus dem Tiefpass wird durch spektrale Rotation um  {\fontname{Courier}\pi}  ein zum Tiefpass 
%  symmetrischer Hochpass generiert und diese beiden werden in Serie verwendet, 
%  d.h. ihre Impulsantworten gefaltet.
%
%  \bfBeispiel 3:
%
halbbf;
%
%
%%  bung 6.4e:  Die Koeffizienten werden numerisch ermittelt.  Deshalb ist zu berprfen, 
%%  wie stark die theoretisch verschwindenden Koeffizienten von Null abweichen.
%%  berprfen Sie dies fr die Beispiele 1 und 3 dieses Abschnitts.
%%  Bei Verwendung von REMEZ wird intendierte Symmetrie bisweilen nicht ganz erreicht. 
%%  Deshalb ist diese Prfung generell angebracht.
%
