%
%
%(f)  Hilbertfilter%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Hilbertfilter werden bentigt, um die Signalphasen unabhngig von der Frequenz 
%  um  {\fontname{Courier}\pi/2}  zu drehen. Ein solches Filter realisiert man am einfachsten durch 
%  spektrale Rotation eines Halbbandtiefpasses um  {\fontname{Courier}\pi/2} .  Wie im Abschnitt 6.4d 
%  beschrieben wechseln sich reelle und rein imaginre Koeffizienten bei dem 
%  um  {\fontname{Courier}\pi/2} gedrehten Filter ab.  Beim Halbbandfilter ist aber jeder zweite 
%  Koeffizient Null, so dass sich ein reelles Filter ergibt.  Diese spezielle Situation wird 
%  durch die folgende Tabelle nochmals fr ein Halbbandfilter vom Grad  {\fontname{Courier}5}  veranschaulicht:
%  
%  e^{ik\pi/2} der Reihe nach:              1   i  -1  -i   1   i  -1  -i   1   i  -1 %<'FontName',MSVFORMFONT>
%
%  Koeffizientenvektor   b:          b1   0  b3   0  b5  b6  b7   0  b9   0  b11  %<'FontName',MSVFORMFONT>
%
%  gedrehtes Filter (Punktprodukt):  b1   0 -b3   0  b5 i*b6 -b7  0  b9   0 -b11 %<'FontName',MSVFORMFONT>
%
%  Dies aufgetrennt in je ein Filter fr
%       Realteil:                    b1   0 -b3   0  b5   0 -b7   0  b9   0 -b11  %<'FontName',MSVFORMFONT>
%       Imaginrteil:                 0   0   0   0   0  b6   0   0   0   0   0   %<'FontName',MSVFORMFONT>
%
%  Das Imaginrteilfilter ist eine reine Verzgerung mit dem Verstrkungsfaktor   {\fontname{Courier}b6} .
%  Die Ausgabe beider Filter ist ber alle Frequenzen genau  {\fontname{Courier}\pi/2} gegeneinander
%  gedreht.  Die Verstrkung beider Filter ist genau   {\fontname{Courier}1/2}  wegen der Verwendung
%  eines Halbbandtiefpasses mit der Grenzfrequenz  {\fontname{Courier}0.5} .
%
%  Die MATLAB-Funktion  {\fontname{Courier}halbhilb}  benutzt als Berechnungskern entsprechend:
%  b  = fir1(g,1/2);             % einfacher Entwurf eines Halbbandtiefpasses     %<'FontName',MSVFORMFONT>
%  d  = 2*real(specrot(b,pi/2)); % Halbbandtiefpass um pi/2 rotiert ist komplex   %<'FontName',MSVFORMFONT>
%
halbhilb(30);
%
%  Wie generell beim Entwurf durch diskrete Fouriertransformation mit Fenster (hier mit {\fontname{Courier}fir1}) 
%  ist die Welligkeit im Durchlassbereich nicht konstant.  Wir zeigen dies am Beispiel eines 
%  Hilbertfilters mit  {\fontname{Courier}127} Koeffizienten:
%
figh1 = fullscreen('Frequenzgang');
filterplot(halbhilb(126),0,1,'lin',0.995,1.005)
%
%  Wir werden im Kapitel ber analytische Signale sehen, dass die Welligkeit im Durchlassbereich 
%  bei vielen Anwendungen sehr klein sein muss.  Deshalb ist auch im Fall des Entwurfs von 
%  Hilbertfiltern ein Iterationsverfahren zur Minimierung dieser Welligkeit von Vorteil. 
%  Die schon behandelte Funktion  {\fontname{Courier}remez}  bietet genau dies. 
%  Ausschnitt aus "help remez":
%
%  B=REMEZ(N,F,A,'Hilbert') and B=REMEZ(N,F,A,W,'Hilbert') design filters %<'FontName',MSVFORMFONT>
%  that have odd symmetry, that is, B(k) = -B(N+2-k) for k = 1, ..., N+1. %<'FontName',MSVFORMFONT> 
%  A special case is a Hilbert transformer which has an approx. amplitude %<'FontName',MSVFORMFONT>
%  of 1 across the entire band, e.g. B=REMEZ(30,[.1 .9],[1 1],'Hilbert'). %<'FontName',MSVFORMFONT>
%
%  Ein Beispiel mit  {\fontname{Courier}127}  Koeffizienten wie oben:
%
figh2 = fullscreen('Frequenzgang');
subplot(2,1,1)
filterplot(halbhilb(126),0,1,'lin',0.995,1.005)
subplot(2,1,2)
filterplot(remez(126,[0.03 0.97],[1 1],'Hilbert'),0,1,'lin',0.995,1.005)
%
%
%%  bung 6.4f:  Der ideale Tiefpass mit der Grenzfrequenz  1/2  und ebenfalls seine 
%%  Approximationen haben die gewnschte Symmetrie bei geradem, aber nicht durch  4 
%%  teilbarem Filtergrad.
%%  Berechnen Sie nach oben angegebenem Schema ein Hilbertfilter aus dem Basisfilter  
%  b = idealtpdemo(2,1/2,126)  %<'FontName',MSVFORMFONT>
%%
%%  mit dem selben Filtergrad wie in obigen Beispielen. 
%%  Wie gross ist die Welligkeit dieses Filters verglichen mit den oben gerechneten Fllen?
%