%
%
%  6.5  Komplementr-Filter%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Gegeben sei ein FIR-Filter von geradem Grad   {\fontname{Courier}g}  und symmetrischer Impulsantwort
%        g  %<'FontName',MSVFORMFONT>
%  y_n = _{\fontsize{26}\Sigma} h_k x_{n-k}  %<'FontName',MSVFORMFONT>
%       k=0  %<'FontName',MSVFORMFONT>
%
%  Verzgert man das Inputsignal um  {\fontname{Courier}g/2}  Abtastungen und bildet
%
%  z_n = x_{n-g/2} - y_n  %<'FontName',MSVFORMFONT>
%
%  so ist  -  abgesehen von der Verzgerung  -  offenbar  {\fontname{Courier}y + z = x} .  {\fontname{Courier}z}  ist also das 
%  zu  {\fontname{Courier}y}  komplementre Signal.  {\fontname{Courier}z} knnte man auch direkt berechnen nach
%       g  %<'FontName',MSVFORMFONT>
%  z_n = _{\fontsize{26}\Sigma} q_k x_{n-k}  %<'FontName',MSVFORMFONT>
%      k=0  %<'FontName',MSVFORMFONT>
%
%  mit  {\fontname{Courier}q_k = -h_k}  ausser  {\fontname{Courier}q_{g/2} = 1 - h_k} .  Hufig wird aber gerade die Aufspaltung 
%  des Signals gewnscht, z.B. in einen Tiefpass- und einen Hochpassanteil, die beide 
%  weiterverarbeitet werden sollen.  Dann braucht man nur ein FIR-Filter zu rechnen und 
%  erhlt den komplementren Anteil durch Subtraktion.  Das folgende Bild zeigt die 
%  Struktur.
%
komplementaerfilter
%
%  Beim Entwurf von FIR-Filtern, bei denen auch der komplementre Anteil 
%  weiterverarbeitet werden soll, ist zu beachten, dass die Welligkeit im Durchlassbereich 
%  des Filters durch die Subtraktion zur Welligkeit im Sperrbereich des Komplementr-
%  filters wird.
%
%  \bfBeispiel:  
%  Das Inputsignal soll in Tiefpass- und Hochpassanteil getrennt werden mit dem 
%  bergangsbereich  {\fontname{Courier}0.3...0.5} .  Die Sperrdmpfung soll  {\fontname{Courier}40 dB}  sein.
%
r = remezord([0.3,0.5],[1,0],[0.01,0.01],2,'cell');
b  = remez(r{1},r{2},r{3},r{4});
if rem(r{1},2)~=0  r{1} = r{1} + 1; b = remez(r{1},r{2},r{3},r{4}); end
k  = r{1}/2;
bk = [zeros(1,k),1,zeros(1,k)] - b;  % Koeffizienten des Komplementrfilters
h = fullscreen('Komplementrfilter');
filterplot({b;bk},0,1,'lin',0,1.1)
legend('Tiefpass','komplementrer Hochpass',0)
set(h,'KeyPressFcn','hervorhebung'); 
set(gcf,'UserData',{zeros(1,8); 1.2*ones(1,10); {'b';'g'}});
%
%
%%  bung 6.5:  Der Entwurf wurde mit der Abschtzung von remezord gemacht. 
%%  Es ist zu prfen, ob das berechnete Filter die Spezifikationen einhlt. 
%%  Das Filter ist so zu verbessern, dass es die Spezifikation mit minimaler 
%%  Anzahl von Koeffizienten erfllt.
%
