%
%
%7.3  Eigenschaften von IIR-Filtern%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-8,'Color',MSVTITLCOLOR>
%
%
%
%  IIR-Filter sind durch folgende Eigenschaften gekennzeichnet:
%
%  (a)  deutlich geringerer Rechenaufwand als bei FIR-Filtern fr 
%        vergleichbaren Betragsfrequenzgang
%       
%  (b)  linearer Phasengang ist NICHT erreichbar
%
%  (c)  bei Entwurf und Realisierung ist auf Instabilitt und
%        Akkumulation von Rundungsfehlern zu achten
%
%  (d)  die Realisierung erfolgt meist nicht in der StandardStruktur
%
%  Ein Beispiel fr Instabilitt gibt folgendes einfache Filter.  Zunchst der 
%  Betragsfrequenzgang, danach die Antwort auf einen Einheitspuls:
%
b = [0.1];  a = [1  0  1.1];       % Filterkoeffizienten
fig1 = fullscreen('Frequenzgang','w',0,[2 1; 1 1]); % Bilderzeugung
filterplot({{b;a}},0,1,0,-30,5)    % Frequenzgang des Filters
x = [1, zeros(1,99)];              % Eingangsimpuls;  Hhe = 1
y = filter(b,a,x);                 % Filtern 
fig1 = fullscreen('Instabil','w',0,[2 1; 2 1]);     % Bilderzeugung
plot(1:length(y),y);               % Impulsantwort des Filters 
axis([1,100,-10,10])               % divergierende Amplitude            
%