%
%
%7.5  Berechnung des Frequenzganges%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-10,'Color',MSVTITLCOLOR>
%
%
%
%  Im Fall von FIR-Filtern ergab sich der Frequenzganz einfach durch Fouriertransformation 
%  der Impulsantwort, also des Koeffizientenvektors.  Bei IIR-Filtern in Direktstruktur ist
%  der Frequenzgang relativ einfach herzuleiten:
%
%  Aus der Struktur ergibt sich als Algorithmus  ({\fontname{Courier}g} = Filtergrad):
%         g            g      %<'FontName',MSVFORMFONT>
%  y_n = ( _{\fontsize{26}\Sigma} b_k x_{n-k} - _{\fontsize{26}\Sigma} a_k y_{n-k} )/a_0  %<'FontName',MSVFORMFONT>
%        k=0          k=1     %<'FontName',MSVFORMFONT>
%
%  Multiplikation der Gleichung mit  {\fontname{Courier}z^{-n}}  und Summation ber  {\fontname{Courier}n = 0,...\infty}  ergibt
%   g      \infty             g      \infty     %<'FontName',MSVFORMFONT>
%  _{\fontsize{26}\Sigma} b_k \cdot _{\fontsize{26}\Sigma} x_{n-k} z^{-n} = _{\fontsize{26}\Sigma} a_k \cdot _{\fontsize{26}\Sigma} y_{n-k} z^{-n}     %<'FontName',MSVFORMFONT>
%  k=0    n=0           k=0    n=0     %<'FontName',MSVFORMFONT>
%
%  Mit der Definition der Z-Transformierten und dem Verschiebungssatz erhlt man daraus
%   g                g     %<'FontName',MSVFORMFONT>
%  _{\fontsize{26}\Sigma} b_k z^{-k} X(z) = _{\fontsize{26}\Sigma} a_k z^{-k} Y(z)     %<'FontName',MSVFORMFONT>
%  k=0             k=0     %<'FontName',MSVFORMFONT>
%
%  Im Spektralbereich der Z-Transformierten verhlt sich das Filter also nach
%            g           g     %<'FontName',MSVFORMFONT>
%  Y(z) = ( _{\fontsize{26}\Sigma} b_k z^{-k} / _{\fontsize{26}\Sigma} a_k z^{-k} ) \cdot X(z)     %<'FontName',MSVFORMFONT>
%           k=0         k=0     %<'FontName',MSVFORMFONT>
%
%  Fr   {\fontname{Courier}Y(z) = H(z) \cdot X(z)}   ist also
%            g             g     %<'FontName',MSVFORMFONT>
%  H(z) = ( _{\fontsize{26}\Sigma} b_k z^{-k} ) / _{\fontsize{26}\Sigma} a_k z^{-k}     %<'FontName',MSVFORMFONT>
%           k=0          k=0     %<'FontName',MSVFORMFONT>
%
%  Das Verhalten im Frequenzbereich der Fouriertransformation ist gleich dem der 
%  Z-Transformation auf dem Einheitskreis in der komplexen z-Ebene. Wir setzen 
%  deshalb  {\fontname{Courier}z = e^{i\omega}}  und erhalten
%
%  H(\omega) = H(z=e^{i\omega})     %<'FontName',MSVFORMFONT>
%
%  Nun wird  {\fontname{Courier}0 \leq \omega < \pi}  in   {\fontname{Courier}N}  quidistante Sttzstellen  {\fontname{Courier}\omega_k = 2\pik/N} diskretisiert und an 
%  diesen  {\fontname{Courier}H(\omega_k)}  berechnet  {\fontname{Courier}(k = 0,...,N-1)} .  Genau das tut die schon fr FIR-Filter 
%  benutzte Funktion  {\fontname{Courier}freqz} .
%
%  Aus "{\fontname{Courier}help freqz}":
%
%  FREQZ Z-transform digital filter frequency response.                     %<'FontName',MSVFORMFONT>
%  When N is an integer, [H,W] = FREQZ(B,A,N) returns the N-point frequency %<'FontName',MSVFORMFONT>
%  vector W in radians and the N-point complex frequency response vector H  %<'FontName',MSVFORMFONT>
%  of the filter B/A:                                                       %<'FontName',MSVFORMFONT>
%              jw              -jw               -jnbw                      %<'FontName',MSVFORMFONT>
%       jw  B(e)   b(1) + b(2)e + .... + b(nb+1)e                           %<'FontName',MSVFORMFONT>
%    H(e) = ---- = -----------------------------------                      %<'FontName',MSVFORMFONT>
%              jw              -jw               -jnaw                      %<'FontName',MSVFORMFONT>
%           A(e)   a(1) + a(2)e + .... + a(na+1)e                           %<'FontName',MSVFORMFONT>
%  given numerator and denominator coefficients in vectors B and A. The     %<'FontName',MSVFORMFONT>
%  frequency response is evaluated at N points equally spaced around the    %<'FontName',MSVFORMFONT>
%  upper half of the unit circle.                                           %<'FontName',MSVFORMFONT>
%
%  Als Beispiel dient hier wieder das einfache Filter ersten Grades:
%
r = 0.4;
b = r;
a = [1  -(1-r)];
h = fullscreen('Frequenzgang')
freqz(b,a)
%
%%  bung 7.5  Vergleichen Sie die Darstellungen des Frequenzganges 
%%  der FIR- und IIR-Filter
%
b = remez(30,[0,0.25,0.35,1],[1 1 0 0],[0.01 1]); a = 1; 
%
[b,a] = ellip(8,3,60,0.3);
%
%%  mit folgenden Funktionen
%
h1 = fullscreen('Freqz');           freqz(b,a)
%
h2 = fullscreen('Filterplot lin');  filterplot({{b;a}},0,1,'lin',0,1.2)
%
h3 = fullscreen('Filterplot log');  filterplot({{b;a}},0,1,'log')
%
filterort(b,a,'lin')
%
filterort(b,a,'log')
%
