%
%
%7.6  Pole und Nullstellen%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Gegeben seien smtliche Nullstellen  {\fontname{Courier}z_k^{(0)}}  eines Polynoms vom Grad  {\fontname{Courier}g} . 
%  Dann lsst sich das Polynom faktorisieren:
%   g              g                                                        %<'FontName',MSVFORMFONT>
%  _{\fontsize{26}\Sigma} a_k z^k  =  c _{\fontsize{26}\Pi} (z - z_k^{(0)}) %<'FontName',MSVFORMFONT>
%  k=0            k=1                                                       %<'FontName',MSVFORMFONT>
%
%  Wir wenden dies an auf die bertragungsfunktion im Spektralbereich der 
%  Z-Transformierten nach Erweiterung um den Faktor  {\fontname{Courier}z^g} .  Dabei ist zu beachten, 
%  dass wir hier die Koeffizienten mit Null beginnend nummerieren im Gegensatz 
%  zur MATLAB-Funktion  {\fontname{Courier}freqz} (s.o.):
%           g           g                                                            %<'FontName',MSVFORMFONT>
%  H(z) = (_{\fontsize{26}\Sigma} b_k z^{-k}) / _{\fontsize{26}\Sigma} a_k z^{-k}    %<'FontName',MSVFORMFONT>
%          k=0         k=0                                                           %<'FontName',MSVFORMFONT>
%
%  Mit   {\fontname{Courier}j = g - k}  folgt
%           g             g                                                          %<'FontName',MSVFORMFONT>
%  H(z) = (_{\fontsize{26}\Sigma} b_{g-j} z^j) / _{\fontsize{26}\Sigma} a_{g-j} z^j) %<'FontName',MSVFORMFONT>
%         j=0           j=0                                                          %<'FontName',MSVFORMFONT>
%
%  Die Nullstellen des Zhler- und des Nennerpolynoms seien  {\fontname{Courier}z_j^{(0)}}  bzw.  {\fontname{Courier}z_j^{(p)}} .  
%  Die Nullstellen des Nennerpolynoms sind Pole der bertragungsfunktion.  
%  Dann gilt die Faktorisierung
%            g                g                                                      %<'FontName',MSVFORMFONT>
%  H(z) = c _{\fontsize{26}\Pi} (z - z_j^{(0)}) / _{\fontsize{26}\Pi} (z - z_p^{(p)})%<'FontName',MSVFORMFONT>
%           j=0              j=0                                                     %<'FontName',MSVFORMFONT>
%
%  und nach Einsetzen  von  {\fontname{Courier}z = e^{i\omega}}  :
%            g                  g  %<'FontName',MSVFORMFONT>
%  H(\omega) = c _{\fontsize{26}\Pi} (e^{i\omega} - z_j^{(0)}) / _{\fontsize{26}\Pi} (e^{iw} - z_j^{(p)})  %<'FontName',MSVFORMFONT>
%           j=0                j=0  %<'FontName',MSVFORMFONT>
%
%  \bfBeispiel:
%  Entwurf eines elliptischen Filters und Darstellung der bertragungsfunktion 
%  in der Z-Ebene.  Durch diese Darstellung wird klar, dass gerade die Position
%  der Pole nahe dem Einheitskreis das Durchlassverhalten wesentlich bestimmt.
%
%%  Drehen Sie das Bild in verschiedene Richtungen, auch die Aufsicht 
%%  auf die z-Ebene (Pseudocolor-Plot).
%
[b,a] = ellip(4,1,60,0.3);   % ein einfaches IIR-Filter
hzplot(b,a);                 % dessen bertragungsfunktion
%
%  Fr die Darstellung der Nullstellen und Pole in der Z-Ebene gibt es die 
%  Funktion  {\fontname{Courier}zplane(b,a)} :
%
[b,a] = ellip(4,1,60,0.3);   % ein einfaches IIR-Filter
fig2 = fullscreen('Null/Polstellen','w',0,[1 1.35; 1 1]);
zplane(b,a)
lineobj = get(gca,'Children'); 
set(lineobj(2:3),'Color','r','MarkerSize',8,'LineWidth',2); end
title('Nullstellen und Pole in der Z-Ebene','FontSize',13)
legend('Nullstellen','Pole')
%
%  MATLAB stellt Funktionen zur Wandlung zwischen allen gebruchlichen 
%  Darstellungen zur Verfgung. Die Bezeichner sind einheitlich:
%  Nullstellen und Pole:   ZP  (Zero/Pole)                                  %<'FontName',MSVFORMFONT>
%  Koeffizienten b,a :     TF  (Transferfunktion)                           %<'FontName',MSVFORMFONT>
%                          SS  (State Space)                                %<'FontName',MSVFORMFONT>
%                          SOS (second-order sections linear system model)  %<'FontName',MSVFORMFONT>
%
%  Die Darstellungen  {\fontname{Courier}SS}  und  {\fontname{Courier}SOS}  werden in diesem Kurs nicht verwendet.
%  Die Umwandlungsfunktionen heissen   {\fontname{Courier}zp2tf, tf2zp,}  usw. wo die  {\fontname{Courier}2}  sinnigerweise 
%  fr  "to"  steht.
%
%  \bfBeispiel:
%
help tf2zp
%
%  Anwendung:  Berechnung der Pole und Nullstellen aus den Koeffizienten  {\fontname{Courier}a}  und  {\fontname{Courier}b}
%  des oben berechneten elliptischen Filters:
%
[z0,zp,c] = tf2zp(b,a)         % Berechnung der Nullstellen und Pole
%%  Ausgabe im Kommandofenster!
%
%  Die ausgegebenen Koordinaten  {\fontname{Courier}z0}  sind die der Nullstellen im Bild "Null/Polstellen",
%  {\fontname{Courier}zp}  die der Pole, und  {\fontname{Courier}c}  ist der Verstrkungsfaktor.
%
%  Wie schon im Abschnitt 6.4c dargestellt gibt es Flle, in denen es sinnvoll ist, 
%  beim Entwurf Nullstellen und Pole festzulegen und daraus die Koeffizienten mit  
%  {\fontname{Courier}zp2tf(z,p,k)}  zu ermitteln.
%
%  Wir testen hier nur, ob die Rckwandlung dasselbe Filter ergibt durch Darstellung 
%  beider Frequenzgnge in einem Diagramm.  Die Graphen sollten vollkommen 
%  bereinander liegen.
%
%%  Mit den Tasten 1 und 2 knnen die beiden Graphen hervorgehoben werden.
%
[bb,aa] = zp2tf(z0,zp,c)
fig2 = fullscreen('Frequenzgang'); 
filterplot({{bb;aa};{b;a}})
lineobj = get(gca,'Children'); 
set(lineobj(1),'Color','b'); set(lineobj(2),'Color','r')
set(fig2,'UserData',{zeros(1,8); 1.2*ones(1,8); {'b';'g';'m';'c'}});
set(fig2,'KeyPressFcn','hervorhebung')
%
%  Systeme, deren Pole und Nullstellen wie blich als konjugiert komplexe Paare 
%  vorliegen, lassen sich einfach in eine Kaskade von Systemen zweiter Ordnung 
%  zerlegen, indem fr jedes Teilsystem ein Pol- und ein Nullstellenpaar 
%  ausgewhlt wird.  Die Funktion  {\fontname{Courier}lcascade(b,a)}  ermittelt aus gegebenen 
%  Koeffizienten  {\fontname{Courier}b, a}  zunchst die Pole und Nullstellen und anschliessend
%  die Koeffizienten der Teilsysteme.  Wir demonstrieren dies mit einem Tiefpass 
%  der Ordnung  {\fontname{Courier}6} .  Es werden drei Bilder gezeigt:
%  1.  Der Frequenzgang des ursprnglichen Filters
%  2.  Die Frequenzgnge der drei Teilsysteme zweiter Ordnung
%  3.  Der Frequenzgang der Kaskade der drei Teilsysteme zweiter Ordnung
%
[b,a] = ellip(6,1,80,0.1);
[B,A] = lcascade(b,a);
fh1 = fullscreen('Ausgangssystem'); filterplot({{b;a}},0,1,0,-100,20,1,32,0)
fh2 = fullscreen('Teilsysteme');    filterplot({{B(1,:);A(1,:)};{B(2,:);A(2,:)};{B(3,:);A(3,:)}},0,1,0,-100,20,[1 1 1],32,0)
fh3 = fullscreen('Kaskade');        filterplot({{B(1,:);A(1,:)};{B(2,:);A(2,:)};{B(3,:);A(3,:)}},0,1,0,-100,20,[1 1 1],32,1)
%
%%  bung 7.6:  Es ist die Lage der Nullstellen und Pole von Butterworth-Filtern 
%%  zu ermitteln fr die Filtergrade  4, 8, 12  bei der Grenzfrequenz  0.3
%
