%
%
%
%
%9.2  Synchrone Interpolation%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%  Im Falle synchroner Interpolation werden Sttzstellen des Signals bentigt, die so 
%  zwischen den gegebenen Abtastzeitpunkten liegen, dass diese zusammen mit den 
%  gegebenen ein abgetastetes Signal ergeben mit einer Abtastfrequenz, die ein 
%  Vielfaches  {\fontname{Courier}m}  der gegebenen Abtastfrequenz betrgt.  Im Falle  {\fontname{Courier}m = 2}  sind dies 
%  z.B. die genau in der Mitte zwischen den gegebenen Abtastungen liegenden Werte.  
%
%  \bf(a,b)  Polynom-Interpolation und Spline-Interpolation
%
%  Bei linearer Interpolation und  {\fontname{Courier}m = 2}  sind die Mittelwerte benachbarter 
%  Abtastwerte zu nehmen bzw. bei  {\fontname{Courier}m > 2}  die entsprechenden linearen 
%  Interpolationen.  Das folgende Bild veranschaulicht die lineare Interpolation.
%
linintgraph
%
%  Die lineare Interpolation entspricht einem FIR-Filter.  Die Koeffizienten sind:
%  m = 2 :    [1]         fr den Originalwert  %<'FontName',MSVFORMFONT>
%             [1/2  1/2]  fr den ersten Wert   %<'FontName',MSVFORMFONT>
%
%  m = 3 :    [1]         fr den Originalwert  %<'FontName',MSVFORMFONT>
%             [2/3  1/3]  fr den ersten Wert   %<'FontName',MSVFORMFONT>
%             [1/3  2/3]  fr den zweiten Wert  %<'FontName',MSVFORMFONT>
%
%  Bentigt man im Fall  {\fontname{Courier}m = 1}  nur die Zwischenwerte und setzt diese danach niemals 
%  in Relation zu den Originalen, entspricht die Interpolation dem Filter mit den 
%  Koeffizienten   {\fontname{Courier}b = [0.5 0.5]} , welches schwache Tiefpasseigenschaften hat.
%
fig1 = fullscreen('Frequenzgang'); 
filterplot([0.5,0.5])
%
%  Werden die Zwischenwerte dagegen fr eine Hochtastung verwendet, so gibt es 
%  von Abtastung zu Abtastung Sprnge zwischen verschiedenen FIR-Filtern. 
%  Das ist eine nichtlineare Operation, die Artefakte erzeugt.  Diese Artefakte 
%  sind Reste des gespiegelten Teils des ursprnglichen Spektrums zwischen 
%  Nyquistfrequenz und Abtastfrequenz.  Durch das Einfgen von interpolierten 
%  Werten ist die Abtastfrequenz um den Faktor m grsser.  Alles, was nach der 
%  Interpolation in diesem Bereich liegt, sind keine Spiegelfrequenzen sondern 
%  echte, aber ungewnschte Frequenzanteile. 
%  Die Funktion  {\fontname{Courier}fintpol(methode,f1,f2,r)} veranschaulicht den Fehler im 
%  Frequenzbereich fr den Fall  {\fontname{Courier}m = 1} .  Das Ausgangssignal fr die 
%  Interpolation erzeugt  {\fontname{Courier}fintpol}  als Summe zweier Sinussignale mit den 
%  Frequenzen  {\fontname{Courier}f1}  und  {\fontname{Courier}f2}  sowie weissem Rauschen mit der 
%  Standardabweichung  {\fontname{Courier}r} .  Als Interpolationsmethode stehen zur Verfgung: 
%  {\fontname{Courier}'linear', 'cubic', 'spline'} .
%
fintpol('linear',0.2,0.9,0)
%
fintpol('cubic',0.2,0.9,0)
%
fintpol('spline',0.2,0.9,0)
%
fintpol('linear',0.2,0.9,10)
%
fintpol('cubic',0.2,0.9,10)
%
fintpol('spline',0.2,0.9,10)
%
%  Es ist zu erkennen, dass ein hherer Polynomgrad den Fehler zwar verringert, 
%  aber nicht zu Null macht. 
%
%
%  \bf(c)  Nullen einfgen und Filtern mit FIR-Filter
%
%  Die bliche Methode fr die synchrone Interpolation ist das Hochtasten durch 
%  Einfgung von Nullen in die Inputsequenz und anschliessendes Filtern.  Das 
%  Einfgen von Nullen hat auf das Spektrum keinen Einfluss, aber natrlich auf 
%  die Abtastfrequenz.  Wird z.B. zwischen je zwei Inputabtastungen eine Null 
%  eingefgt, so wird dadurch die Abtastrate verdoppelt:  {\fontname{Courier}f_s' = 2f_s}   
%  Bei der diskreten Fouriertransformation haben die Nullen keine Wirkung, so 
%  dass das Spektrum dasselbe bleibt, aber nach dem Einfgen der Nullen enthlt 
%  der Bereich  {\fontname{Courier}0...f_s'}  zwei der ursprnglichen Perioden  
%  {\fontname{Courier}0...f_s} .  Wir berprfen dies kurz im MATLAB-Experiment:
%
spechochtast
%
spechochtast(0.8,0.85,1)
%
%  Nach dem Einfgen von Nullen braucht man im Falle der Hochtastung um  {\fontname{Courier}m = 2}  
%  nur noch mit einem Tiefpassfilter der oberen Grenze  {\fontname{Courier}f_s'/4}  zu filtern, 
%  um genau das ursprngliche Spektrum aus dem Bereich  {\fontname{Courier}0...f_s} zu erhalten. 
%  Dieses FIR-Filter sollte die vorgegebenen Abtastwerte abgesehen von der 
%  Verzgerung unverndert lassen.  Das ist jedoch nur dann der Fall, wenn 
%  jeder zweite Koeffizient Null ist ausser dem mittleren.  Also sollte es
%  ein Halbbandfilter sein.  Glcklicherweise passt diese Forderung genau mit 
%  der nach der Grenzfrequenz zusammen.  Solche Filter mit dem Grad  {\fontname{Courier}g > 6}  
%  liefert das MATLAB-Kommando  {\fontname{Courier}fir1(g,1/2)} .
%
%  Der vierte Parameter von  {\fontname{Courier}spechochtast}  ist der Filtergrad des Halbbandfilters. 
%  Falls dieser grsser als  {\fontname{Courier}7}  und gerade ist, wird auch das Filterergebnis 
%  gezeigt:
%
spechochtast(0.7,0.8,1,40)
%
spechochtast(0.7,0.8,1,20)
%
spechochtast(0.7,0.8,1,10)
%
%  Offenbar ist das Filter mit  {\fontname{Courier}g = 10}  vllig unzureichend.  Auch bei  
%  {\fontname{Courier}g = 20}  ist der Spiegel der Komponente  {\fontname{Courier}f2 = 0.8}  noch erkennbar.
%
%  Das selbe demonstrieren wir als Audiosignal:
%  Ein Ein- oder Mehrtonsignal der Abtastrate  {\fontname{Courier}8 kHz} wird durch Einfgung 
%  von Nullen hochgetastet auf  {\fontname{Courier}16 kHz} .  Wir hren der Reihe nach (1) das 
%  ursprngliche Signal;  (2) das hochgetastete Signal,  (3) das hochgetastete 
%  Signal nach Tiefpassfilterung mit einem Halbbandtiefpass vom Grad {\fontname{Courier}g}:
%
%%  Die Berechnung der Audiofiles dauert leider eine Weile.
%
[x1,y1,z1] = audiohochtast(3000,6);  % Eintonsignal, schlechtes Filter
%
[x2,y2,z2] = audiohochtast(3000,30); % Eintonsignal, gutes Filter
%
[x3,y3,z3] = audiohochtast(4*440*[1 5/4 3/2 2],12); % Dreiklang, mssiges Filter
%
%  Zur Wiederholung der Tne ohne lange Rechnung:
%
sound(x1,8000); pause(2); sound(y1,16000); pause(2); sound(z1,16000); pause(2); 
%
sound(x2,8000); pause(2); sound(y2,16000); pause(2); sound(z2,16000); pause(2); 
%
sound(x3,8000); pause(2); sound(y3,16000); pause(2); sound(z3,16000); pause(2);
%
%  Besonders strend ist offenbar, wenn das Filter bei der Nyquistfrequenz der 
%  Ausgabeabtastung zu wenig dmpft.  Ein durchdringender Ton auf dieser Frequenz 
%  wird ja durch das Einfgen von Nullen erzeugt.  Die mit MATLAB nach  {\fontname{Courier}fir1(g,1/2)} 
%  mit geradem  {\fontname{Courier}g}  berechneten Halbbandfilter haben leider bei der 
%  Nyquistfrequenz keine Nullstelle.
%
%  Die MATLAB-Funktion  {\fontname{Courier}ipoldemo(g,n)}  zeigt interpolierte Sequenzen von 
%  Zufallsfolgen.  Das zweite Beispiel benutzt keinen Halbband-Tiefpass.  
%  Deshalb sind dort die Inputwerte nicht in der Ausgabesequenz enthalten. 
%  Hufig ist das nicht schdlich.
%
ipoldemo(8,50);
%
ipoldemo(4,50);
%
%  Im Falle  {\fontname{Courier}m > 2}  sind entsprechende Interpolationstiefpsse zu entwerfen 
%  mit der Grenzfrequenz  {\fontname{Courier}f_s'/2m} , bei denen jeder {\fontname{Courier}m}-te 
%  Koeffizient verschwindet ausser dem mittleren, dessen Wert genau {\fontname{Courier}1/m} betrgt. 
%
%
%  Grosse Bedeutung hat die synchrone Abtastratenumsetzung im Audiobereich, da 
%  verschiedene Abtastraten verwendet werden:
%
%  Hr-Rundfunk:    \fontname{Courier}32000 Hz   ( 2^8 5^3 )
%  CD :                   \fontname{Courier}44100 Hz   ( 2^2 3^2 5^2 7^2 )
%  Studiotechnik :    \fontname{Courier}48000 Hz   ( 2^7 3^1 5^3 )
%
%  Solche rationalen Verhltnisse tastet man zweischrittig um.  Zunchst 
%  erfolgt eine Hochtastung auf das kleinste gemeinschaftliche Vielfache 
%  der beiden Abtastraten.  Anschliessend wird die Abtastrate dezimiert.
%  Die Realisierung ist zwischen 32000 Hz und 48000 Hz aufwandsarm.  Bei
%  der Umsetzung von  48 kHz  nach  32 kHz ber 96 kHz wird nur jeder 
%  dritte Originalwert und jeder 6. der Hochtastung gebraucht.
%  Dies zeigt anschaulich die Funktion  syncumsetzgraph(f1,f2) :
%
syncumsetzgraph( 48000, 32000 )
%
%  Auch die Umkehrung ist einfach:  Jeder sechste Originalwert und je ein 
%  interpolierter dazwischen sind zu ermitteln:
%
syncumsetzgraph( 32000, 48000 )
%
%
%%  bung 9.2a  Zeigen Sie, dass mit  
%%
%%  h = fir1(g,1/m);
%%  b = h/m/h(g/2+1);
%%
%%  Interpolationstiefpsse fr gerade  g  und beliebige  m  berechnet werden knnen 
%%  mit den oben genannten Eigenschaften.
%%
%%  bung 9.2b  Ein Dezimationsfilter braucht nur fr die bentigten Abtastpunkte 
%%  der dezimierten Abtstrate gerechnet werden.  Ist eine entsprechende Einsparung 
%%  auch bei einem Interpolationsfilter mglich?
%%
%%  bung 9.2c  Betrachten Sie die synchrone Abtastratenumsetzung zwischen 
%%  f1 = 48000 Hz  (und  f1 = 44100 Hz)  nach  f2 = 38400 Hz  und stellen Sie
%%  ein Schema hierfr auf.
%
