function  fftfilgraph2
%  fftfilgraph2 zeichnet ein Diagramm, das die Berechnung des
%  Matrix-Vektor-Produktes fr grosse Bandmatrizen durch
%  sich berlappende Diagonalsubmatrizen zeigt.
%  In diesem Beispiel ist die Matrix eine untere Dreiecksmatrix.
%  Das entspricht einem kausalen linearen Verhalten.
%  Gegenber fftfilgraph1 zeigt fftfilgraph2 zustzlich die
%  nderung, die eine Diagonalisierung der Toeplitz-Submatrizen
%  durch Transformation in den Frequenzbereich durch die FFT
%  verursacht. Die nderung hat KEINE Auswirkung auf das
%  Ergebnis.

%  Autor:  K. v. d. Heide,  e-mail:  v.d.heide@on-line.de
%
w   = 5; 
fs  = 20;
pt1 = 14;
pt2 = 20;
h = fullscreen('FFT-Filter-Graph');
axis([-10,171,-10,124]); 
set(gca,'Visible','off')

drawsq([0,0],95)
patch([15,15,55,55],[80,65,65,80],'y')
patch([40,40,80,80],[55,40,40,55],'y')
patch([0,80,95,0],[80,0,0,95],'r')
%patch([15,15,30],[80,65,65],'w')
%patch([40,40,55],[55,40,40],'w')
patch([40,55,55],[80,65,80],'r')
patch([65,80,80],[55,40,55],'r')

line([15,55,55,15,15],[40,40,80,80,40],'Color','b')
line([40,80,80,40,40],[15,15,55,55,15],'Color','b')
line([15,55],[65,65],'Color','b')
line([40,80],[40,40],'Color','b')
line([110,110],[0,95],'Color','k','LineWidth',w)
line([120,120],[40,80],'Color','k','LineWidth',w)
line([130,130],[15,55],'Color','k','LineWidth',w)
line([150,150],[40,65],'Color','k','LineWidth',w)
line([160,160],[15,40],'Color','k','LineWidth',w)
line([150,150],[65,80],'Color','y','LineWidth',w)
line([160,160],[40,55],'Color','y','LineWidth',w)
line([170,170],[0,95],'Color','k','LineWidth',w)
line([55,150],[80,80],'Color','k','LineStyle',':')
line([55,170],[65,65],'Color','k','LineStyle',':')
line([80,160],[55,55],'Color','k','LineStyle',':')
line([80,170],[40,40],'Color','k','LineStyle',':')
line([80,170],[15,15],'Color','k','LineStyle',':')

text(108,101,'u','FontSize',fs)
text(118,85,'u1','FontSize',fs)
text(128,60,'u2','FontSize',fs)
text(45,101,'H','FontSize',fs)
text(76,100,'*','FontSize',fs)
text(138,101,'=','FontSize',fs)
text(148,85,'v1','FontSize',fs)
text(158,60,'v2','FontSize',fs)
text(168,101,'v','FontSize',fs)
text(32,60,'A1','FontSize',fs)
text(57,35,'A2','FontSize',fs)
text(-30,-15,...
   'Die schwarzen Teile von  v1 = A1*u1  und  v2 = A2*u2  sind gleich den entsprechenden Segmenten von  v',...
   'FontSize',pt1)
text(0,-22,...
   'Die gelben Teile von  v1 = A1*u1  und  v2 = A2*u2  sind nicht verwendbar',...
   'FontSize',pt1)
text(-30,120,...
   'Filterung im Frequenzbereich durch FFT von berlappenden Signalsegmenten',...
   'FontSize',pt2)

