function [fig1,fig2] = fourectdemo(n)
% [fig1,fig2] = fourectdemo(n)
% Fouriersynthese einer Rechteckschwingung mit
% Abbruch der Synthese beim n-ten Glied (n <= 20).
% (a) Darstellung der Synthese mit 1,2,3,...,n Gliedern.
% (b) wie (a) jedoch als 3D-Plot.
% Ausgegeben werden die beiden figure handle.

% Autor: Klaus von der Heide, e-mail:  v.d.heide@on-line.de
%
if nargin<1  n = 10; end
t  = (-400:399)/400;
for k = 1:n
   r = 2*k - 1;
   s(k,:) = sin(r*2*pi*t)/r; 
end
y = s(1,:);
for k = 2:n  y = [y; sum(s(1:k,:))]; end
y = 2*y/pi + 0.5;
fig1 = fullscreen('Fourierentwicklung von Rechteck');
plot(t,y)
line([-1,1],[0,0],'LineStyle',':','Color','k')
set(gcf,'UserData',{zeros(1,8); 1.2*ones(1,8); {}},...
        'KeyPressFcn','hervorhebung');
fig2 = fullscreen('Fourier von Rechteck 3D');
surf(t,1:n,y)
view(172,20)
rotate3d
