function fsqview
% fsqview, Benutzung als KeyPressFcn fr freqscan
% zur nderund der Blickrichtung per Tastatur.
% Folgende Tasten haben eine Wirkung:
%  a :  view = [-45 0]
%  d :  view = [-17 72]
%  f :  view = [0 0]
%  h :  Help window
%  p :  Drucken des Bildes
%  s :  view = [135 84]
%  t :  view = [0 90]
%  x :  Lschen des Bildes
% ESC:  Lschen aller Bilder ausser MSCRIPTVIEW-Fenstern

% Autor: K. von der Heide, e-mail:  v.d.heide@on-line.de

c  = get(gcf,'CurrentCharacter');
switch c
   case 'a', set(gca,'View',[-45 0])
   case 'd', set(gca,'View',[18 85])
   case 'f', set(gca,'View',[0 0])
   case 's', set(gca,'View',[135 84])
   case 't', set(gca,'View',[0 90])
   case 'h'
      helpwin = figure;
      set(helpwin,'NumberTitle','off','Name','HelpWin','Color','w',...
         'MenuBar','none','Position',[4 380 385 200],...
         'KeyPressFcn','delete(gcf)','ButtonDownFcn','delete(gcf)')
      axis([0,80,1,12]); axis off
      text(0,11.5,'Das obenliegende Bild kann mit der Maus')
      text(0,10.5,'und durch Tastatureingabe gedreht werden:')
      text(0,9.5,'\fontname{Courier}\bfTaste   Wirkung')
      text(0,8,'\fontname{Courier}"ESC"   Lschen aller Bilder')
      text(0,7,'\fontname{Courier}  a     Blick auf Alias und Produkte')
      text(0,6,'\fontname{Courier}  d, s  Schrgblicke\fontname{Courier}')
      text(0,5,'\fontname{Courier}  f     Blick auf Amplitudenfrequenzgang')
      text(0,4,'\fontname{Courier}  t     Blick von oben')
      text(0,3,'\fontname{Courier}  h     dieses Hilfe-Fenster erzeugen')
      text(0,2,'\fontname{Courier}  p     Drucken')
      text(0,1,'\fontname{Courier}"Entf"  Lschen des Bildes')
   case 'p', printdlg(gcf)
end   
if double(c)==27  msvdelfig;   end
if double(c)==127 delete(gcf); end
