function x0 = iir1demo(c)
% x0 = iir1demo(c)
% IIR-Filter ersten Grades (Exponentialgedchtnis)
% Gezeigt wird der Betragsfrequenzgang und die Impulsantwort fr das
% Filter mit den Koeffizienten  b = [c, 0] ; a = [ 1, c - 1]

% Autor: K. v. d. Heide, e-mail:  v.d.heide@on-line.de
%
if nargin<1  c = 0.02; end
fsiz = 12;
b = [ c, 0 ];  a = [ 1, c - 1 ];    % Koeffizienten
x = [1,zeros(1,199)];               % Eingangsimpuls
y = filter(b,a,x);                  % Filtern 
h(1) = fullscreen('IIR1: Frequenzgang', 'w',1,[1 2; 1 1]);
filterplot({{b;a}},0,1,0,-50,10);
h(2) = fullscreen('IIR1: Ausschnitt',   'w',1,[2 2; 1 2]);
filterplot({{b;a}},0,0.02,0,-20,5);
h(3) = fullscreen('IIR1: Impulsantwort','w',1,[2 2; 2 2]);
stem(y); title('Impulsantwort','FontSize',fsiz);
