function x0 = iirbanddemo(f1,f2,dbtrans,dbstop,p)
%  x0 = iirbanddemo(f1,f2,dbtrans,dbstop,p)
%  Entwurf eines IIR-Bandfilters mit den Grenzen des Durchlassbereiches
%  f1 und f2  sowie der Welligkeit im Durchlassbereich dbtrans (in dB)
%  und der Sperrdmpfung dbstop (in dB).
%  p ist die Zahl der Bits fr die Festkomma-Reprsentation der Koeffizienten.

% K. v. d. Heide,  e-mail:  v.d.heide@on-line.de
%
% Defaults
% ========
if nargin<5  p = 100; end;
if nargin<4  dbstop = 60; end;
if nargin<3  dbtrans = 0.5; end;
if nargin<1  f1 = 0.2; end;
if nargin<2  f2 = f1+0.2; end;
%
% Filterentwurf
% =============
dbs=dbstop; dbt=dbtrans; 
[b1,a1]=ellip(1,dbtrans,dbstop,[f1,f2]); % liefert Fehlermeldung, die bei 
[b2,a2]=ellip(2,dbt,dbs,[f1,f2]);        % Direktaufruf NICHT kommt !
[b3,a3]=ellip(3,dbtrans,dbstop,[f1,f2]);
[b4,a4]=ellip(4,dbtrans,dbstop,[f1,f2]);
[b5,a5]=ellip(5,dbtrans,dbstop,[f1,f2]);
[b6,a6]=ellip(6,dbtrans,dbstop,[f1,f2]);
[b7,a7]=ellip(7,dbtrans,dbstop,[f1,f2]);
[b8,a8]=ellip(8,dbtrans,dbstop,[f1,f2]);
%
% Darstellung
% ===========
figh = fullscreen('IIR-Filter');
filterplot({{b1;a1};{b2;a2};{b3;a3};{b4;a4};{b5;a5};{b6;a6};{b7;a7};{b8;a8}},0,1,0,-100,10,1,p);
title('IIR-Bandpass-Entwurf','FontSize',13);
legend('Grad = 1','Grad = 2','Grad = 3','Grad = 4','Grad = 5','Grad = 6','Grad = 7','Grad = 8',0);
set(gcf,'UserData',{zeros(1,8); 1.2*ones(1,8); {'b';'g';'m';'c'}});
set(figh,'KeyPressFcn','hervorhebung')