function ipolgraph1
% Statisches Bild zur Darstellung des Unterschieds von
% synchroner und asynchroner Interpolation

% Autor: Klaus von der Heide,  e-mail:  v.d.heide@on-line.de
% 
tl = [0.02,0];            % TickLength
figcol = [0.7,0.7,0.7];   % Bildrandfarbe
switch screen
   case 1
      up = 0.012;         % berschriftposition
      tp = 0.265;         % Textposition
   case 2
      up = 0.13;          % berschriftposition
      tp = 0.32;          % Textposition
   otherwise error('Bildpositionen fr screen nicht angegeben.');
end;
h = fullscreen('Umtastung');
axes('Position',[0.1,0.1,0.8,0.8],'Color','w',...
   'XColor',figcol,'XTick',(0:0.2:1),'YColor','w','YTick',[],...
   'XGrid','on','XTickLabel',['';'';'';'';'';''])
text(up,1.07,'Synchrone vs. asynchrone Interpolation','FontSize',25,'FontWeight','bold')
text(tp,0.9,'Abtastpunkte des Inputs','FontSize',20,'Color','k')
text(tp,0.65,'synchrone Abtastpunkte','FontSize',20,'Color','g')
text(tp,0.4,'synchrone Abtastpunkte','FontSize',20,'Color','g')
text(tp,0.15,'asynchrone Abtastpunkte','FontSize',20,'Color','r')
axes('Position',[0.1,0.75,0.8,0.01],'LineWidth',2,...
   'TickDir','in','TickLength',tl,...
   'XColor','k','XTick',(0:0.2:1),'XTickLabel',[],...
   'YColor','w','YTick',[])
axes('Position',[0.1,0.55,0.8,0.01],'LineWidth',2,...
   'TickDir','in','TickLength',tl,...
   'XColor','g','XTick',(0.1:0.2:1),'XTickLabel',[],...
   'YColor','w','YTick',[])
axes('Position',[0.1,0.35,0.8,0.01],'LineWidth',2,...
   'TickDir','in','TickLength',tl,...
   'XColor','g','XTick',(0.05:0.05:1),'XTickLabel',[],...
   'YColor','w','YTick',[])
axes('Position',[0.1,0.15,0.8,0.01],'LineWidth',2,...
   'TickDir','in','TickLength',tl,...
   'XColor','r','XTick',(0.04:sqrt(3)/20:1),'XTickLabel',[],...
   'YColor','w','YTick',[])
