echo on 
%
% MATLAB - Einfhrung Teil 1
% ==========================
% Klaus von der Heide, e-mail: v.d.heide@on-line.de
%
%
% MATLAB interpretiert die Eingaben
%        =============
%
% Beispiele:
%      Im STEP Modus debuggen, mit dem [ >| ] Button
%
3 + 5              % an dieser Stelle ist ein Breakpoint gesetzt
3*5                % Multiplikation
3/5                % Division
5^3                % Potenz
sin(2*pi*1.753)    % Standardfunktion Sinus
%
%
% Konstruktion von Vektoren und Matrizen
% ======================================
%
[3, 5, 1, 7]       % Ein Zeilenvektor
%
% blank statt Komma:

%
[3 5 1 7]          % Ein Zeilenvektor
%
% Semikolon statt Komma: 
%
[3; 5; 1; 7]       % Ein Spaltenvektor
%
% Matrix:
%
[3,2,7;1,6,3]
%
% Transponierung: 
%
[3,2,7;1,6,3]'
%
% quidistante Vektorkomponenten:
%
-3:5
0:0.2:1
%
%
% Wertzuweisung an Variablennamen
% ===============================
%
% Die Wertzuweisung ist prozedural, berschreiben alter 
% Werte also blich. Dabei knnen sich Datentyp und 
% Datenstruktur beliebig ndern:
%
x = -3:3          % Zeilenvektor
x = 1             % Skalar
x = 'Hallo!'      % Zeichenkette
%
% Will man den Wert im Protokoll nicht sehen, 
% dann ist mit ; abzuschliessen:
%
x = -3:3;
y = 0:6;
z = x + y         % Vektoraddition
%
% Funktionen knnen Vektoren berechnen, die an individuelle
% Komponenten zurckgegeben werden:
%
x = [1 2 3 4; 5 6 7 8]
%
[zeilen,spalten] = size(x);  % Bestimmen der Matrixgre
%
zeilen
spalten
%
%
% Vorab definierte Variable
% =========================
%
pi                 % die Kreiskonstante PI
ans                % das letzte Ergebnis
ans-3              % es kann auch weiter verwendet werden
i                  % die imaginre Einheit
j                  % nochmal die imaginre Einheit unter anderem Namen
inf                % Das Symbol fr Unendlich
NaN                % Das Symbol fr undefinierte Werte "Not A Number"
%
%
% Lineare Algebra
% ===============
%
% Die Funktion rand liefert eine Matrix der angegebenen Dimensionen 
% von Zufallszahlen aus dem Intervall (0.0 ; 1.0)

a = round(10*rand(2,3))      % eine 2x3 Zufallsmatrix
b = round(10*rand(size(a)))  % eine Zufallsmatrix der gleichen Gre 
c = a - b         % Matrixaddition
d = a'*b          % Matrixmultiplikation
f = a*b'          % Matrixmultiplikation
g = a*a'          % Matrixmultiplikation 
h = g^-1          % Matrixinversion
u = [1 2 3], v = [2 2 1]     % Zwei Zeilenvektoren
s = u*v'          % Skalarprodukt von Zeilenvektoren
u = u', v = v'    % Beide transponieren
s = u'*v          % Skalarprodukt von Spaltenvektoren
%
%
% Selektieren von Komponenten in Matrizen
% =======================================
%
a                 % Matrix a
a(2,3)            % Element in Zeile 2 / Spalte 3
a(1,:)            % Zeile 1
a(:,2)            % Spalte 2
a(:,2:-1:1)       % Matrix aus Spalten 2 und 1 von a
%
%
% Operationen mit Matrizen
% ========================
%
% In Matlab werden die Wahrheitswerte reprsentiert, wie in der 
% Programmiersprache C, also i.A. 1 fr TRUE und 0 fr FALSE 
%
a > b             % Komponentenweiser Vergleich
a == b            % Komponentenweiser Test auf Gleichheit
a < b             % Komponentenweiser Vergleich
cos(c)            % Funktion Komponentenenweise anwenden
%
%
% Operationen elementweise
% ========================
%
u,v               % Zwei Spaltenvektoren
u.*v              % Komponentenweise Multiplikation
u.^2              % Komponentenweises Quadrieren 
a.^2              % Komponentenweises Quadrieren 
%
%
% Datenstrukturen
% ===============
%
person.name = 'vdh'
person.geb  = [01 03 41]
person.beruf= 'prof'
%
person

% Das Script ist zuende, bitte nun den debug-Modus 
% wieder verlassen, dazu % im Command-Fenster das 
% Kommando "dbcont" eingeben. Wenn danach kein 
% Prompt erscheint, nocheinmal die Return-Taste 
% tippen.

% Das Fenster des Editor/Debugger wird dann nicht 
% mehr bentigt, bitte minimieren, damit die nun 
% erzeugten Fenster sichtbar sind.

echo off
%