%
%
%Plotfunktionen%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
n = 500;                % Abszisse mit n Punkten
t = (0:n-1)/n;          % Abszisse
f = 3.7;                % Frequenz
s = sin(2*pi*f*t);      % Sinus-Signal
r = 0.2*randn(size(s)); % normalverteiltes Rauschen
fig1 = figure;          % ein Bildobjekt erzeugen                  
plot(t,s)               % Darstellung von s
pause
%
fig2 = figure;          % ein Bildobjekt erzeugen                  
plot(t,s+r,t,s)         % Darstellung von s+r und s
pause
%
figure(fig2)            % nur ntig, wenn nicht fokussiert
title('s + r  und  s')  % Bildtitel
xlabel('Zeitbereich')   % Beschriftung der Abszisse
legend('s + r','s')     % Legende
pause
%
delete(fig1,fig2)       % Lschen von von fig1 und fig2
pause
%
f(1) = figure;          % Erzeugen Figure f(1)
plot(t,r)               % Darstellung des Rauschens im Zeitbereich
f(2) = figure;          % Erzeugen eines zweiten Bildes f(2)
hist(r)                 % Histogramm von r
f(3) = figure;
hist(r,20)              % Histogramm mit 20 Spalten
pause
%
h = hist(r,20);         % Histogramm mit 20 Spalten
f(4) = figure;
stem(h)                 % dasselbe Histogramm als stem-plot
pause
%
for k = 1:4  delete(f(k)); end % Bilder f(1)...f(4) lschen
pause
%
%
% \bfZeichnen mit line-Objekten
%
%
fig1 = figure;
line(t,s+r,'color','g','LineWidth',1.)
line(t,s,'color','r','LineWidth',1.5)
axis([0.1,0.8,-2.1,2.1])
drawnow
pause
%
get(fig1)               % Properties von (get current figure)
pause
%
figure(fig1)            % fig1 fokussieren
get(gca)                % Properties von (get current axes)
delete(fig1)            % Fenster fig1 lschen
pause
%
%
% \bfSetzen von Properties
%
%
if screen==1  pos = {[1 208 318 371];[293 398 239 182];[293 208 238 201]}; end
if screen==2  pos = {[2 310 315 436];[292 542 360 205];[291 310 361 207]}; end
for k = 1:3   h(k)=figure; end   % Kreieren neuer Bilder mit Namen h(k)
for k = 1:3   set(h(k),'position',pos{k},'Color','w'); end
for k = 1:3   set(h(k),'MenuBar','none','NumberTitle','off'); end
pause
%
% Nun die Attribute der erzeugten Abbildungen verndern:
%
set(h(1),'Name','normalverteilte Zufallszahlen')
set(h(2),'Name','Verteilung')
set(h(3),'Name','gleichverteilte Zufallszahlen')
pause
%
t = 1:200;
z = randn(size(t));
figure(h(1)); plot(t,z)
pause
%
figure(h(2)); hist(z,20)
pause
%
figure(h(3)); plot(t,rand(size(t)))
pause
%
for k = 1:3  delete(h(k)); end
pause
%
%% Im DSP-Skript knnen alle fokussierten Bilder mit der Taste "Entf" gelscht werden. 
%% Smtliche Grafiken sind dann mit der Taste "ESC" zu lschen.
%
%
% \bf3D-Plots
%
%
% Das ist einfach und sehr eindrucksvoll: Verweis auf Manual
% Hier nur ein Beispiel:
%
x = (-50:50)/30; 
y = x;
fig = figure;
mesh(x,y,exp(-x.^2)'*exp(-y.^2).*(sin(2*x)'*cos(5*y)))
pause
%
delete(fig)
pause
%
%
% \bfBewegtbilder: das kommt spter
%
