%
% MATLAB - Einfhrung Teil 3%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% \bfKontrollfluss 
%
%
for k = 1:10  ksq(k) = k^2; end  % for-Schleife  %<'Interpreter','none'>
ksq
pause
% Hinweis: wo immer mglich, expliziten Kontrollfluss mit for, while etc. 
% vermeiden, weil die Matrix-Konstrukte wesentlich effizienter sind. Hier z.B. 
% ksq = (1:10).^2;                               %<'FontName','Courier','Interpreter','none'>
%
% Die while-Schleife : 
% blicherweise strukturiert notiert
%
% while k>0               % while-Schleife       %<'FontName','Courier'>
%    sqrtk(k) = sqrt(k);                         %<'FontName','Courier'>
%    k = k - 1;                                  %<'FontName','Courier'>
% end                                            %<'FontName','Courier'>
%
k = 10;
while k>0  sqrtk(k) = sqrt(k); k = k - 1, end
pause
%
% Sie liefert folgendes Ergebnis: 
%
sqrtk
pause
%
% IF-THEN-ELSE Anweisung 
% blicherweise strukturiert notiert
%
% if     k==3  x = 2;     % if b  statement;    %<'FontName','Courier'>
% elseif k>8   x = 5;     % dies ist optional   %<'FontName','Courier'>
% else         x = 1;     % dies ist optional   %<'FontName','Courier'>
% end                     % dies muss sein      %<'FontName','Courier'>
%
if k==3  x = 2; elseif k>8  x = 5; else x = 1; end
x
pause
%
% SWITCH-Anweisung (oder auch CASE-Anweisung)
% blicherweise strukturiert notiert
%
% switch k                                      %<'FontName','Courier'>
%    case 1                                     %<'FontName','Courier'>
%       x = 7;                                  %<'FontName','Courier'>
%    case 2                                     %<'FontName','Courier'>
%       x = 8;                                  %<'FontName','Courier'>
%    case {5,7,9}                               %<'FontName','Courier'>
%       x = 1;                                  %<'FontName','Courier'>
%    otherwise x = 0;                           %<'FontName','Courier'>
% end                                           %<'FontName','Courier'>
%
switch k, case 1, x = 7; case {5,7,9}, x = 1; otherwise x = 0; end
k,x
pause
%
%
% \bfAusgewhlte Funktionen
%
%
eval('3+4')             % fhrt den String als Ausdruck aus
pause
%
feval('sin',0.73)       % fhrt die im String angegebene
                        % Funktion mit dem Argument aus
pause
%
c = inline('sin(2*pi*f*t)','f','t') ; % Definition der im String
                        % angegebenen Funktion c mit den
                        % Argumenten f und t. 
pause
c
pause
%
% Nun Aufruf von c:
%
zeit = (0:499)/500;     % zweites Argument: Zeitbereich
u = c(2.7,zeit);        % Aufruf
fig = figure;
plot(zeit,u)            % Graph der Funktion
pause
%
delete(fig)             % Lschen des fokussierten Bildes
pause
%
%
% \bfOnline-Hilfe
%
%
help inline             % Bei bekanntem Funktionsbezeichner:
                        % direkte Hilfeausgabe im Comand-Window
pause
% 
% Help in der Men-Leiste (oder Aufruf helpwin): Es wird ein Fenster fr den 
% Hilfe-Browser geffnet. HelpDesk bietet eine komfortable HTML-Hilfe.
%
% Suchen mit Schlsselwrtern ist auch vom Kommandofenster mglich:
%
lookfor filter
pause
%
