function b = mrdemo(g,k)
% b = mrdemo(g,k)
% Demonstation des Entwurfs von Multiraten-Bandpass-Dezimationsfiltern.
% g : Filtergrad
% k : Dezimationsfaktor (muss ungerade sein!)
% Es wird ein zu k passendes Halbbandfilter entworfen mit Durchlass 
% bei  0.5 * Nyquistfrequenz  und Sperrung aller Aliasfrequenzen.
% Ausgegeben werden die Filterkoeffizienten.

% Autor: K. v. d. Heide, e-mail:  v.d.heide@on-line.de
%
if nargin<2  k = 5;  end
if nargin<1  g = 12; end

b = decbandpass(g,k);            % Filterentwurf
g = length(b) - 1;               % Filtergrad evtl. erhht

for i = 1:3
   h(i)   = fullscreen('','w',1,[2 3; 1 i]);
   h(i+3) = fullscreen('','w',1,[2 3; 2 i]);
   set(h(i),  'Name',sprintf('%g-stufige Kaskade',i+1));
   set(h(i+3),'Name',sprintf('%g-stufige Kaskade',i+1));
end;
c = (b + b((g+1):-1:1))/2;
c = c(1:2:(g+1));
cc= {nullein(c,1)};
dez = [1];
for i = 1:3
   s = i + 1;
   bb = cc;
   for t = 1:s-1  bb = [bb;cc]; dez = [dez,k^t]; end;
   figure(h(i));   filterplot(bb,0,1,0,-110,10,dez);  title('Einzelfilter');
   figure(h(i+3)); filterplot(bb,0,1,0,-110,10,dez,24,1); 
   title(sprintf('%g-stufige Filter-Kaskade',i+1));
end;
