function x = mrplot(b,s,k,f1,f2,d1,d2)
% x = mrplot(b,s,k,f1,f2,d1,d2)
% Demonstration einer Kaskade von Dezimationsfiltern:
% b        Filterkoeffizienten
% k        Dezimationsfaktor (1/k)
% s        Anzahl der Dezimationsstufen
% f1...f2  Frequenzbereich fr den Plot (ny = 1) bezogen
%          auf die Abtastrate der Filtereingabe. 
% d1, d2   vertikale Plotgrenzen in dB

% K. von der Heide,  e-mail:  v.d.heide@on-line.de
%
if nargin<7  d2 = 10; end;
if nargin<6  d1 = -110; end;
if nargin<5  f2 = 1; end;
if nargin<4  f1 = 0; end;
if nargin<3  k = 2; end;
if nargin<2  s = 3; end;
if nargin<1  b = fir1(14,1/2); end
g = length(b)-1;  % Grad des Dezimationsfilters
dz = k.^(0:s-1);
c = {b};
bb = c;
for t = 2:s  bb = [bb;c]; end
h1 = fullscreen('Einzelfilter','w',1,[2 1; 1 1]);
filterplot(bb,f1,f2,0,d1,d2,dz);
h2 = fullscreen('Filterkaskade','w',1,[2 1; 2 1]);
filterplot(bb,f1,f2,0,d1,d2,dz,24,1);
title(sprintf('%g-stufige Kaskade von Dezimationsfiltern 1:%g  mit %g Koeffizienten',s,k,length(b)));
