function  pllgraph
%  pllgraph zeichnet das Blockschema einer Phase Locked Loop

%  Autor:  K. v. d. Heide,  e-mail:  v.d.heide@on-line.de
%
lw = 1.5;               % LineWidth
fs = 18;                % FontSize
cf = 0.8*[1 1 1];       % Fllfarbe
cl = 'k';               % Linienfarbe
spl= 2;                 % Pfeilspitzenlnge
h = fullscreen('PLL-Schema');
axis([10,110,-20,60]); 
set(gca,'Visible','off')

drawsq([10,30],10,cf,'OSC',fs)
drawsq([30,30],10,cf,':m',fs)
drawsq([50,30],10,cf,'PD',fs)
drawsq([70,30],10,cf,':n',fs)
drawsq([30,10],10,cf,'Filter',fs-2)

drawarr([20,35],[30,35],cl,lw,spl)
drawarr([40,35],[50,35],cl,lw,spl)
drawarr([70,35],[60,35],cl,lw,spl)
drawarr([90,35],[80,35],cl,lw,spl)
drawarr([55,15],[40,15],cl,lw,spl)
drawarr([15,15],[15,30],cl,lw,spl)

line([15,30],[15,15],'Color',cl,'LineWidth',lw)
line([55,55],[30,15],'Color',cl,'LineWidth',lw)

text(92,35,'Referenzfrequenz','FontSize',fs)
text(12,50,'Schema einer Phase Locked Loop (PLL)','FontSize',fs+3)
