%
%
%Samplescript  %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%General  %<'FontWeight','bold','FontSize',15,'Color','b'>
%
% Scripts are edited using a normal ASCII text editor.  Clicking on the following 
% line should open the MATLAB editor showing the ASCII file viewed here:
%
edit('samplescript.m')
%
%% Please choose an appropriate position of the viewer window and the editor 
%% window such that both can be seen simultaneously.
%
% Four types of lines are used in this viewer:
%
% 1.  Text lines (black)
%
% 2.  Instructions to the user (italics, blue)
%
% 3.  MATLAB command lines (red or magenta if selected)
%
% 4.  Link lines (green or magenta if selected)
%
% Command lines and links can be selected by the mouse or by the keyboard. 
% Selected lines are shown in magenta.
%
%
%Text lines  %<'FontWeight','bold','FontSize',15,'Color','b'>
%
% Script text including the title and blank lines must be precedet by the character "%" 
% in the first column.  Otherwise the line will be interpreted as a MATLAB command. 
% The preceding characters "%" are not shown by the viewer.
%
% There are two possibilities to control the text properties:
%
% A.  Script text is interpreted by the MATLAB T_EX-interpreter. Look for the property 
%      "interpreter" of the text-object in the MATLAB manual. Two examples are:
%
% \bfThis is an example for bold font:   y = x^2
%
% This is an example for a formula:   {\fontname{Courier}e^{-t^2}sin(t)} 
%
% B.  The text line may be followed by a string of text property pairs enclosed in the
%       special brackets  "<"  and  ">".  The opening bracket must be precedet by "%".
%       These properties will be applied to the whole line.
% Methods  A. and  B. may be combined:
%
% Example               %<'Color','g','FontWeight','bold'>
%         \infty                                            %<'FontName','courier'>
%  S(\omega) = _{\fontsize{24}\int} s(t) e^{-i\omegat} dt   %<'FontName','courier'>
%        -\infty                                            %<'FontName','courier'>
%
%
%Instructions to the user  %<'FontWeight','bold','FontSize',15,'Color','b'>
%
% Lines precedet by two characters "%%" are used for instructions to the reader of these scripts.  
% They are presented in italics and blue color.
%
%
%MATLAB command lines  %<'FontWeight','bold','FontSize',15,'Color','b'>
%
% Command lines are not precedet by the character "%".  They are not interpreted by 
% the T_EX interpreter.  Command lines not separated by text lines are called a MATLAB block.
% MATLAB blocks can be selected and executed by mouse clicks or by hitting the keyboard.
%
x = 2    % this is a MATLAB command
 %         this is a blank command line with this comment within a MATLAB block
y = x^2  % in contrast to a text line this is not TEX-interpreted: y = x^2
% This is a text line separating two MATLAB blocks
z = sqrt(y)
%
%
% A MATLAB command may be spread over several lines according to the MATLAB syntax:
%
for k=1:5
   pwr(k,:) = [k  k^2  k^3  k^4];
end
pwr
%
%
%Link lines  %<'FontWeight','bold','FontSize',15,'Color','b'>
%
% A link line is a concatenation of three strings: 
% The file name, the specific string "%MSV ", and an arbitrary text.  Only the text 
% is shown by the viewer in green color or in magenta if selected.  Clicking on 
% this text will select this link and then execute the viewer using the file name 
% as the argument.  This results in a new viewer window.  
% As an example we use a short script on MATLAB graphics:
%
samplegraphic %MSV Using MATLAB Graphic
%
%
%% As an exercise you should edit the script file named  "exercise.m"  with arbitrary 
%% content according to your own preferences.  Then test the syntax by clicking this
%% link to your script (the file exercise.m exists but is blank):
%
exercise %MSV Exercise: Change this title
%
%% The browser window of your exercise-script must be deleted before possible changes 
%% of  exercise.m  made with the editor can be stored.
%
%
%Including new toolboxes into the Root Window  %<'FontWeight','bold','FontSize',15,'Color','b'>
%
% If  {\fontname{Courier}mscriptview}  is called without parameters, it automatically searches the 
% Matlab path for toolboxes to be viewed.  A new toolbox must include a textfile 
% with one line that defines the link to the root of this toolbox.  For example, this 
% attachment could be put into an own folder.  Then a textfile should be added to 
% this folder with the only line (and no newline)
%
% {\fontname{Courier}samplescript %MSV How to write your own script}
%
% The extension of this file must be  {\fontname{Courier}'msv'} .  Thus  {\fontname{Courier}attachment.msv}  would be 
% an acceptable filename.  When the folder is included in the Matlab path, then a  
% call of  {\fontname{Courier}mscriptview}  without parameters will find this file and include the link 
% into the root window at the priority set by the Matlab path.
%
% The headlines of the root window are defined by the textfile  {\fontname{Courier}root.msv}  in 
% the browser toolbox.
%