function [x0,y0] = windemo(n)
% [x0,y0] = windemo(n) 
% plottet einige gngige Fenster wie winplot, jedoch nur bersicht.
% n ist optional die Breite des Fensters; Default = 800

% K. v. d. Heide;  e-mail:  v.d.heide@on-line.de
%
if nargin<1  n=800; end;
fsiz = 12;                             % FontSize
t  = (-(n-1)/2:1:+(n-1)/2);            % Abszisse

h1 = fullscreen('Fenster-Funktionen');
plot(t,hanning(n),t,hamming(n),t,blackman(n),t,kaiser(n,7));
legend('Hanning','Hamming','Blackman','Kaiser');
title('Vergleich gngiger Fensterfunktionen','FontSize',fsiz);
set(h1,'UserData',{zeros(1,8); 1.2*ones(1,8); {'b';'g';'m';'c'}});
set(h1,'KeyPressFcn','hervorhebung')

h2 = fullscreen('Kaiser-Fenster');
plot(t,kaiser(n,5),t,kaiser(n,7),t,kaiser(n,10),t,kaiser(n,16),t,kaiser(n,25));
legend('Beta =  5','Beta =  7','Beta = 10','Beta = 16','Beta = 25');
title('Kaiser-Fenster','FontSize',fsiz);
set(h2,'UserData',{zeros(1,8); 1.2*ones(1,8); {'b';'g';'m';'c'}});
set(h2,'KeyPressFcn','hervorhebung')
